#include "LinHash.h"

LinHash::LinHash(int BucFac, float LoadFac) {
   BF = BucFac;
   LF = LoadFac;
   BoundVal = 0;
   BitsUsed = 0;
   SplitNum = 0;
   MaskNum = 0;
   SNum = (int) ceil(BF*LF);
   HashBuckets = new Bucket(BucFac);
}

void LinHash::InsertIntoHash(struct OneRecord InRec) {	
  int EntryNum, *CheckNum;
  Bucket *CurrentBucket, *PrevBucket;

  CheckNum = (int *)&InRec.loid;
  EntryNum = *CheckNum & MaskNum;
  if (EntryNum < BoundVal) 
     EntryNum = *CheckNum & ((MaskNum << 1) | MaskNum);

  CurrentBucket = FindBucket(EntryNum);
  while ((CurrentBucket->OverFlowBucket) && (CurrentBucket->RecNum == BF))
     CurrentBucket = CurrentBucket->OverFlowBucket;

  if (CurrentBucket->RecNum == BF) {
     CurrentBucket->OverFlowBucket = new Bucket(BF);
     CurrentBucket = CurrentBucket->OverFlowBucket;
  }

  CurrentBucket->BucketRecords[CurrentBucket->RecNum++] = InRec;

  if ((++SplitNum) == SNum) {
     int CheckVal = 1;
     SplitNum = 0;

     CheckVal = CheckVal << BitsUsed;
     Bucket *LastBucket = HashBuckets;

     while (LastBucket->NextBucket)
        LastBucket = LastBucket->NextBucket;
     LastBucket->NextBucket = new Bucket(BF);
     LastBucket = LastBucket->NextBucket;
     CurrentBucket = FindBucket(BoundVal++);

     if (BoundVal > MaskNum) {
        BoundVal = 0;
        BitsUsed++;
        MaskNum = (int) pow(2,BitsUsed) - 1;
     }

     while(CurrentBucket) {
        int i=0;

        while(i<CurrentBucket->RecNum) {
           if (*CheckNum & CheckVal) {
              LastBucket->BucketRecords[LastBucket->RecNum++] = CurrentBucket->BucketRecords[i];
              if (LastBucket->RecNum == BF) {
                 LastBucket->OverFlowBucket = new Bucket(BF);
                 LastBucket = LastBucket->OverFlowBucket;
              }
              for(int k=i; k<CurrentBucket->RecNum-1; ++k)
                 CurrentBucket->BucketRecords[k] = CurrentBucket->BucketRecords[k+1];
              CurrentBucket->RecNum--;
            }
            else 
              i++;
         }
         CurrentBucket = CurrentBucket->OverFlowBucket;
      }
   }
}

void LinHash::PrintHashTable() {
   Bucket *CurrBuc = HashBuckets;
   Bucket *temp = CurrBuc;
   int k = 0;

   while(CurrBuc) {
      printf("Bucket# %d ",k++);
      while(temp) {
         for(int i=0; i<temp->RecNum;++i)
            printf("%d ",temp->BucketRecords[i].loid);
         temp = temp->OverFlowBucket;
      }
      CurrBuc = CurrBuc->NextBucket;
      temp = CurrBuc;
      printf("\n");
   }
}

Bucket *LinHash::FindBucket(int EntNum) {
   Bucket *TempBuc = HashBuckets;
   for(int i=0;i<EntNum;++i) 
      TempBuc = TempBuc->NextBucket;
   return TempBuc;
}

LinHash::~LinHash() {
   Bucket *CurrBuc = HashBuckets->NextBucket;
   Bucket *temp = HashBuckets;
   Bucket *prev;

   while(CurrBuc) {
      while(temp) {
         prev = temp;
         temp = temp->OverFlowBucket;
         delete prev;
      }
      temp = CurrBuc;
      CurrBuc = CurrBuc->NextBucket;
   }
   while(temp) {
      prev = temp;
      temp = temp->OverFlowBucket;
      delete prev;
   }
}
    
