#include "dld.h"

extern "C" {
  void *dlink();
}

/* Member fcns for class Param */

Params::Params(int argnum) { 
      param_count=0; 
      param_list = (char *) malloc(4*argnum);
}

void Params::add_parameters(void *ptrval) {
      memcpy((param_list+param_count*4),&ptrval,4);
      param_count++;
};

char *Params::get_parameters() {
    return(param_list);
};

int Params::get_parnum() {
    return(param_count);
};

/* constructor of the 'function' class. */
Function::Function(char *signature)
{
    int i;
    char fcnpath[100];
    char *chptr, *chptr1;
    int *dummyptr;
     
    error=0;
    chptr = strrchr(signature,'.');
    if (chptr)
       chptr++;
    else 
       chptr = signature;

    chptr1 = strrchr(chptr,'$');
    if (chptr1) chptr = chptr1+1;

    sprintf(fcnpath,"%s/shobj/%s.so",DatabaseHome,chptr);

    hand=dlopen(fcnpath,1);
    if (hand==0) {
       error = 1;
       return;
    };

    func=(void *(*) (...)) (dlsym(hand,chptr));
    if(func==NULL) {
      error = 1;
      return;
    };

    dlink(NULL,NULL,0);

}; /* end of function::function */



/* function for executing the shared object when 'function' class is called
   without any parameters */
void *Function::execute(Params *Par) {
 
void *retptr;
void *buf;

   buf = (void *)(Par->get_parameters());
 
   switch(Par->get_parnum()) {
     case 0 : retptr = (*func)();
              break;
     case 1 : retptr = (*func)(*(void **)buf);
              break;
     case 2 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4));
              break;
     case 3 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4),*(void **)(buf+8));
              break;
     case 4 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4),*(void **)(buf+8),*(void **)(buf+12));
              break;
     case 5 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4),*(void **)(buf+8),*(void **)(buf+12),*(void **)(buf+16));
              break;
     case 6 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4),*(void **)(buf+8),*(void **)(buf+12),*(void **)(buf+16),*(void **)(buf+20));
              break;
     case 7 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4),*(void **)(buf+8),*(void **)(buf+12),*(void **)(buf+16),*(void **)(buf+20),*(void **)(buf+24));
              break;
     case 8 : retptr = (*func)(*(void **)(buf),*(void **)(buf+4),*(void **)(buf+8),*(void **)(buf+12),*(void **)(buf+16),*(void **)(buf+20),*(void **)(buf+24),*(void **) (buf+28));
              break;
   }
   return retptr;
 
 }; /* end of function::execute */
 
