
#ifndef __BPLUSDDL_H
#include "bplusddl.h"
#endif


/****************************************************************************
 
        parses the following statement :
 
        ... [ UNIQUE ]  indexName ON className attributeName [ ASC | DESC ]
 
*****************************************************************************/

IndexCreate::parse()
{

        connectUserRequest();

        // check the UNIQUE keyword
        getToken();
        if( tokenType() == MS_UNIQUE ) setUniqueFlag();
        else backtrack();

        // get index name
        CHECK_TOKEN(IDENTIFIER, 9, "");
        setIndexName(tokenValue());

        // must be On keyword
        CHECK_TOKEN(ON, 15, "");

        // get class name
        CHECK_TOKEN(IDENTIFIER, 6, "");
        setClassName(tokenValue());
 
        attributeList = new LinkedList;

        do {
                IndexedAttribute *indexedAttribute;
                indexedAttribute = new IndexedAttribute;
 
                // get indexed attribute name
                CHECK_TOKEN(IDENTIFIER, 10, "");
                indexedAttribute->setAttributeName(tokenValue());
 
                // order for the attribute is determined here
                getToken();
                if(tokenType() == DESC)
                        indexedAttribute->setOrder();
                else if(tokenType() != ASC) backtrack();
 

      // insert indexed attribute to the list
                attributeList->insert(INDEXED_ATTRIBUTE, VOID indexedAttribute);

        } while(getToken() == COMMA ); // continue until not comma

        backtrack();
        return TRUE;
}

IndexCreate::IndexCreate( UserRequest *userReq)
{
        ur = userReq;
        strcpy(indexName,"");
        strcpy(className,"");
        uniqueFlag    = FALSE;
        attributeList = NULL;
}


IndexDrop::parse()
{
        connectUserRequest();
 
        // get index name
        CHECK_TOKEN(IDENTIFIER, 9, "");
        setIndexName(tokenValue());
}




