#include <string.h>
#include <sm_client.h>
#include "mood_catalog.h"
#include "mood_catdef.h"
#include "keywords.h"
#include "lists.h"
#include "linklist.h"

extern int User;
extern displayFID( FID * );


void MoodsTypes::dispLevel( LevelInfo * Plevel ) 
{ 
	if ( !Plevel ) return;

	printf("%s,", Plevel->ClassName);
	dispLevel( Plevel->next );
	printf("\n");
}

void MoodsTypes::dispHier( Hierarchy *Phier ) 
{
	if ( !Phier ) return;

	dispLevel( Phier->thislevel );
	printf("-----------------\n");
	dispHier( Phier->nextlevel );
}

int MoodsTypes::changeNameOfClass( char *Pold, char *Pnew ) 
{
	CatBOOLEAN 	status=0;
	Catalog 	tmpType;
	AttributeType 	tmpAttr;
	OID     	tmpOid, curOid, nextOid;
	CatBOOLEAN 	eof;
	int	     	err;

        if(!getTypOid( Pold, &tmpOid, &status )) return FALSE;
        CAT_CHECK( (&status), TYPE_NOT_EXIST, Pold );

        if(!readType( tmpOid , &tmpType, &status )) return FALSE;
        CAT_CHECK( (&status), TYPE_NOT_EXIST, "can not read type information ");

        strcpy(tmpType.TypeName , Pnew );
        if( !updateType( tmpOid, tmpType )) return FALSE;

        // search all attributes to change AttributeTypeName field...
			CatATTRIBUTE attrins(AttributeId);

	mscat_GetFirstOid( AttributeId, curOid, "" );

	while( !eof )
        { 
		mscat_ReadObject(curOid, "");
        	memcpy( &tmpAttr, UserDesc->basePtr, sizeof(AttributeType) );
        	if ( !strcmp( tmpAttr.AttrTypeName, Pold ) ) {
        		strcpy( tmpAttr.AttrTypeName , Pnew );
        		attrins.updateAttr( curOid, tmpAttr );
        	}

		mscat_ReleaseObject("can not release attribute object" );
		mscat_GetNextOid(curOid,nextOid,"");
		memcpy( &curOid, &nextOid, S_OID );
        }
	return TRUE;
}

int MoodsTypes::addAttributeToClass(char *PClsName, AttributeType PAttr ,CatBOOLEAN *status)
{
	Catalog tmpType;
	AttributeType tmpAttr;
	OID     tmpOid,AttrOid;
	int     l_type,l_size,err;


        if( !getTypOid( PClsName, &tmpOid, status )) return FALSE;
        CAT_CHECK( status, TYPE_NOT_EXIST, PClsName );
       
        if( !readType( tmpOid, &tmpType, status )) return FALSE;
        CAT_CHECK( status , TYPE_NOT_EXIST, "can not read type information" );

        if ( !memcmp( &tmpType.List_SubClass , &nullOid , S_OID ) ) { 
              printf(" this class has some sub classes. not implemented yet\n");
              *status = 1 ;
              return FALSE;
        }
        List subClsList( &tmpType.List_SubClass , &l_type, &l_size, status ) ;
        if ( ! (*status) )  
                 if ( l_size ) { 
                      printf("this class has some sub classes. not implemented yet\n");
                      return FALSE;
                 }
         // i should write this!!!!!!!!
        CatATTRIBUTE myattr(AttributeId) ;

        // delete instance file & recreate it from scratch...
	mscat_DestroyFile(tmpType.Instance_File, "can not destroy instance file of class" );

	mscat_CreateFile(tmpType.Instance_File,"can not create instance file");

        List AttrList( &tmpType.List_Attributes, &l_type, &l_size, status );
        INTERNAL_CHECK( status, "can not read attribute list");
         
        myattr.writeAttr(PAttr, &AttrOid );

        AttrList.insertToList( &AttrOid, status );
        INTERNAL_CHECK( status, "can not insert to attribute list" );

        if( !updateType( tmpOid, tmpType )) return FALSE; // just for instance file..

	return TRUE;
}
      
     
 

int MoodsTypes::getClassHierarchy(char *PClsName, Hierarchy **PHierarchy,CatBOOLEAN *status)
{
	Catalog 	Intern, tmpType;
	OID     	tmpOid, element;
	Hierarchy 	*top_level;
	LevelInfo 	*nowhereLevel;
	int     	indx, l_type, l_size;

	*PHierarchy = NULL;

	// the structure will be filled dynamically.. destroy them...
	if( !getTypOid( PClsName, &tmpOid, status) ) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, PClsName );
 
	//  read type info to get sub class list into memory ....
	if( !readType( tmpOid, &Intern, status )) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, "can not read type info");
	List subcls( &Intern.List_SubClass, &l_type, &l_size , status ) ;
	INTERNAL_CHECK( status, "can not construct sub class list");

	if ( l_size ) { // pre allocation of hierarchy....
		*PHierarchy = new Hierarchy();
		top_level = *PHierarchy;
		//top_level->thislevel = NULL ;
		//top_level->nextlevel = NULL ;

		top_level->thislevel = new LevelInfo();
		nowhereLevel = top_level->thislevel ;
		//nowhereLevel->next = NULL ;

		// put father into hierarchy ...
		strcpy( nowhereLevel->ClassName, Intern.TypeName ) ;
	}

	// add all subclasses to the end of list...
	for ( indx = 0 ; indx < l_size ; indx++ ) {
		subcls.getElement( &element, indx, status ) ;
		INTERNAL_CHECK( status, "can not receive element from list" );

		if(!readType( element, &tmpType, status ) ) return FALSE;
		INTERNAL_CHECK( status, "can not read type info");

		nowhereLevel->next = new LevelInfo() ;
		nowhereLevel = nowhereLevel->next  ;
		//nowhereLevel->next = NULL ;
               
		strcpy( nowhereLevel->ClassName , tmpType.TypeName );
	}

	for ( indx = 0 ; indx < l_size ; indx ++ ) {
		subcls.getElement( &element, indx, status );
		INTERNAL_CHECK( status ,"can not receive element from list") ;
		if( !readType( element, &tmpType, status ) ) return FALSE;
		INTERNAL_CHECK( status, "can not read type info") ;
		if( !getClassHierarchy(tmpType.TypeName, &top_level->nextlevel, status)) return FALSE;
		if ( top_level->nextlevel )  top_level = top_level->nextlevel;
		INTERNAL_CHECK( status,"error in inner construct of hierarchy") ;
	}
	return TRUE;
}



/************ REMOVE IT LATER ****************/

int MoodsTypes::dispSuperClass( char *Pcls ) 
{ 
	CatBOOLEAN 	status=0;
	OID 		typid, listid;
	int 		indx, l_size, l_type;
	Catalog		typeentry, tmpentry;

	if( !getTypOid( Pcls, &typid, &status ) ) return FALSE;
	CAT_CHECK(&status, TYPE_NOT_EXIST, Pcls ); 

	if( !readType( typid, &typeentry, &status)) return FALSE;
	CAT_CHECK( &status, TYPE_NOT_EXIST, "can not read type entry");

	List SuperList( &typeentry.List_SuperClass, &l_type, &l_size, &status);
	INTERNAL_CHECK( &status, "can not construct list superclass" );

	for ( indx=0; indx < l_size; indx++ ) { 
			 
		SuperList.getElement( &listid, indx, &status);
		INTERNAL_CHECK( &status, "can not get element from list");

		if( !readType( listid, &tmpentry, &status )) return FALSE;
		INTERNAL_CHECK( &status, "can not read type info ");

		printf("%s\n", tmpentry.TypeName);
	}
	
	return TRUE; 
}


int MoodsTypes::dispSubClass( char *Pcls ) 
{ 
	CatBOOLEAN 	status=0;
	OID 		typid, listid;
	int 		indx,l_size,l_type;
	Catalog 	typeentry,tmpentry;

	if( !getTypOid( Pcls, &typid, &status )) return FALSE;
	CAT_CHECK(&status, TYPE_NOT_EXIST, Pcls ); 

	if( !readType( typid, &typeentry, &status)) return FALSE;
	CAT_CHECK( &status, TYPE_NOT_EXIST, "can not read type entry");

	List SuperList( &typeentry.List_SubClass, &l_type, &l_size, &status);
	INTERNAL_CHECK( &status, "can not construct list superclass" );

	for ( indx=0; indx < l_size; indx++ ) { 
			 
		SuperList.getElement( &listid, indx, &status);
		INTERNAL_CHECK( &status, "can not get element from list");

		if( !readType( listid, &tmpentry, &status )) return FALSE;
		INTERNAL_CHECK( &status, "can not read type info ");

		printf( "%s\n", tmpentry.TypeName);
	} 
	return TRUE;
}
/************ REMOVE IT LATER ****************/



int MoodsTypes::getSubClass( char *Pcls , LinkedList *Pname) 
{ 
	CatBOOLEAN 	status=0;
	OID 		typid, listid;
	int 		indx,l_size,l_type;
	Catalog 	typeentry,tmpentry;
	char		*subClassName;

	if( !getTypOid( Pcls, &typid, &status )) return FALSE ;
	CAT_CHECK(&status, TYPE_NOT_EXIST, Pcls ); 

	if( !readType( typid, &typeentry, &status)) return FALSE;
	CAT_CHECK( &status, TYPE_NOT_EXIST, "can not read type entry");

	List SuperList( &typeentry.List_SubClass, &l_type, &l_size, &status);
	INTERNAL_CHECK( &status, "can not construct list superclass" );
    
	for ( indx=0; indx < l_size; indx++ ) { 

		SuperList.getElement( &listid, indx, &status);
		INTERNAL_CHECK( &status, "can not get element from list");

		if( !readType( listid, &tmpentry, &status )) return FALSE;
		INTERNAL_CHECK( &status, "can not read type info ");

		subClassName = (char *) myAlloc( 100 );
		strcpy( subClassName, tmpentry.TypeName );
		Pname->insert( STRCONS, (void *) subClassName );
	}
	return TRUE; 
}

int MoodsTypes::getSuperClass( char *Pcls , LinkedList *Pname) 
{ 
	CatBOOLEAN 	status=0;
	OID 		typid, listid;
	int 		indx,l_size,l_type;
	Catalog 	typeentry,tmpentry;
	char		*superClassName;

	if( !getTypOid( Pcls, &typid, &status ) ) return FALSE;
	CAT_CHECK(&status, TYPE_NOT_EXIST, Pcls ); 

	if( !readType( typid, &typeentry, &status)) return FALSE;
	CAT_CHECK( &status, TYPE_NOT_EXIST, "can not read type entry");

	List SuperList( &typeentry.List_SuperClass, &l_type, &l_size, &status);
	INTERNAL_CHECK( &status, "can not construct list superclass" );
    
	for ( indx=0; indx < l_size; indx++ ) { 

		SuperList.getElement( &listid, indx, &status);
		INTERNAL_CHECK( &status, "can not get element from list");

		if( !readType( listid, &tmpentry, &status )) return FALSE;
		INTERNAL_CHECK( &status, "can not read type info ");

		superClassName = (char *) myAlloc( 100 );
		if( !superClassName ){
			printf("can not allocate mem\n");
			exit(1);
		}
		strcpy( superClassName, tmpentry.TypeName );
		Pname->insert( STRCONS, (void *) superClassName);
	} 
	return TRUE;
}

int MoodsTypes::getClassInfo(char *PClsName,Catalog *PCat,AttrList **PAttr,
                 LinkedList *Psuper, LinkedList *Psub, CatBOOLEAN *status ) 
{
	if( !getSuperClass(PClsName,Psuper)) return FALSE;
	if( !getSubClass(PClsName,Psub)) return FALSE;
	if( !getClassInfo( PClsName, PCat, PAttr, status )) return FALSE;

	return TRUE;
}

int MoodsTypes::getClassInfo(char *PClsName,Catalog *PCat,AttrList **PAttr,CatBOOLEAN *status) 
{
	OID         typeoid;
	Catalog     intern;

	if( !getTypOid( PClsName, &typeoid, status )) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, PClsName );

	if( !readType( typeoid, &intern, status )) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, "can not read type info" );
	memcpy( PCat , &intern, sizeof(Catalog) );

	if( !getAttrInfo( typeoid , PAttr, status )) return FALSE;
	INTERNAL_CHECK( status , "can not construct attribute " );

	return TRUE;
            
}


int MoodsTypes::getAttrInfo(OID PType ,AttrList **PAttr,CatBOOLEAN *status)
{ 
	OID		typeoid, attrid;
	Catalog     	intern;
	int         	indx,l_type,l_size;
	//char 		y[1000];
	AttributeType 	intern_attr;
	//char 		z[1000];
	AttrList    	*list_start, *nowhere=NULL;


	if( !readType( PType , &intern, status )) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, "" );

	*PAttr = NULL;

	if( OID_IS_INVALID( intern.List_Attributes )) return TRUE;

	List a_list( &intern.List_Attributes, &l_type, &l_size, status ) ;
	INTERNAL_CHECK( status, " can not construct attr list" );

	CatATTRIBUTE attr_instance(AttributeId);
	for ( indx = 0 ; indx < l_size ; indx++ ) {
		a_list.getElement( &attrid, indx, status );
		INTERNAL_CHECK( status, "can not get entry from list" );
             
		if (nowhere != NULL ) { 
			nowhere->next = new AttrList();
			nowhere = nowhere->next ;
		} else 
			nowhere = new AttrList() ;

		//nowhere->next = NULL ;
		//nowhere->nextsub = NULL ;

		if (!indx) list_start = nowhere ;

		attr_instance.readAttr( attrid , &intern_attr, status ) ;
		nowhere->entry = intern_attr ;
		if ( intern_attr.AttributeConstructor != 'N' ) {
			if( !getAttrInfo(intern_attr.AttrType,&nowhere->nextsub,status )) return FALSE;
			INTERNAL_CHECK( status , "can not get internal attribute information");
		} else  
		nowhere->nextsub = NULL ;
	}
	*PAttr = list_start ;
	*status = 0 ;
	return TRUE;
}


CatalogTypeItem::CatalogTypeItem(Catalog toPrint) 
{
	strcpy( TypeName, toPrint.TypeName ) ;
	TypeId    = toPrint.TypeId;
	Size      = toPrint.Size;
	ClassType = toPrint.ClassType; 
}

int MoodsTypes::listTypes( LinkedList	*outList ) 
{
	Catalog 	intern;
	CatalogTypeItem *listItem;
	OID oid1,oid2;
	int err;
	OBJHDR ObjectHeader;
	USERDESC *UserDesc;
	char eof = FALSE;
 
	mscat_GetFirstOid( CatalogId, oid1, "Cannot read the first OID, in listTypes" ) ;
 
	while( eof !=TRUE ){
 
		mscat_ReadObject(oid1, "Cannot read the object , in listTypes" );
		if((*( ( int *)(UserDesc->basePtr)) == TYPE_CATALOG ))
		{
			memcpy( &intern, UserDesc->basePtr, sizeof( Catalog ) );
			listItem = new CatalogTypeItem( intern );
			outList->insert( CATALOG_TYPE_ITEM, (void *) listItem );
		}
		mscat_ReleaseObject( "Cannot release object in locate object" );
		mscat_GetNextOid(oid1, oid2, "Cannot read the next OID in listTypes " );
		memcpy( &oid1, &oid2, sizeof( OID ) );

	}

	return TRUE;
}

isInList( LinkedList *inList, char *className )
{
	ListItem	*p;

	for( p=inList->firstItem; p; p=p->next )
		if( !strcmp( (char *) p->item, className ) ) return TRUE;

	return FALSE;
}

checkExistence( LinkedList *inList, AttrList *inAtt )
{
	AttrList	*p, *q;

	if( !inAtt ) return FALSE;
	if( inAtt->entry.AttributeConstructor == 'T' )
	{
		if( checkExistence( inList, inAtt->nextsub )) return TRUE;
		if( checkExistence( inList, inAtt->next )) return TRUE;
		return FALSE;
	}

	p = inAtt;
	while( p ) {
		q = p->nextsub;

		switch(p->entry.AttributeConstructor )
		{
			case 'S' : // means set constructor
			case 'L' : // means list constructor
			case 'R' : // means set constructor
				if( isInList( inList, q->entry.AttrTypeName)) return TRUE;
				return FALSE;

			case 'N' : // means an atomic type or a database typeName

				if( !strcmp( p->entry.AttrTypeName, "STRING" ) ||
				    !strcmp( p->entry.AttrTypeName, "FLOAT" ) ||
				    !strcmp( p->entry.AttrTypeName, "INTEGER" ) ||
				    !strcmp( p->entry.AttrTypeName, "OID" ) ||
				    !strcmp( p->entry.AttrTypeName, "FID" ) ||
				    !strcmp( p->entry.AttrTypeName, "IID" ) ||
				    !strcmp( p->entry.AttrTypeName, "CHAR" ) ||
				    !strcmp( p->entry.AttrTypeName, "BOOLEAN" ) )
					return FALSE;

				if( isInList( inList, p->entry.AttrTypeName)) return TRUE;
					return FALSE;
		}
		p = p->next;
	}

	return FALSE;
}

int MoodsTypes::checkReference( LinkedList *inList, SortedStringList *outList ) 
{
	Catalog 	intern;
	CatalogTypeItem *listItem;
	OID oid1,oid2;
	int err;
	OBJHDR ObjectHeader;
	USERDESC *UserDesc;
	char eof = FALSE;
	AttrList	*attList;
	CatBOOLEAN status;
	char	*aTypeName;

 
	mscat_GetFirstOid(CatalogId,oid1,"Cannot read the first OID,in listTypes");
 
	while( eof !=TRUE ){
 
		mscat_ReadObject(oid1, "Cannot read the object , in listTypes" );

		if((*( ( int *)(UserDesc->basePtr)) == TYPE_CATALOG ))
		{
			memcpy( &intern, UserDesc->basePtr, sizeof( Catalog ) );

			if( strcmp( intern.TypeName, " " )) {

				if( !getAttrInfo( oid1, &attList, &status ))
					return FALSE;

				if( checkExistence( inList, attList )) {
					aTypeName = myAlloc( MAXSTRLEN );
					strcpy( aTypeName, intern.TypeName );
					outList->insertSorted( STRCONS, aTypeName);
				}

				delete attList;
			}

		}

		mscat_ReleaseObject( "Cannot release object in locate object" );
		mscat_GetNextOid(oid1, oid2, "Cannot read the next OID in listTypes " );
		memcpy( &oid1, &oid2, sizeof( OID ) );

	}

	return TRUE;
}


int MoodsTypes::describe( char *Pclsname ) 
{
	OID tmpOid;
	CatBOOLEAN status=0 ;

	if( !getTypOid( Pclsname, &tmpOid, &status )) return FALSE;
	CAT_CHECK( &status, TYPE_NOT_EXIST, Pclsname);
	if( !describe(tmpOid) ) return FALSE;
	return TRUE;
}


int MoodsTypes::describe( OID PclsName, int left_tab  = 0) 
{ 
	OID attrOid;
	int l_type,l_size,indx;
	int par=0, i ;
	CatBOOLEAN status=0;
	//char    sp2[1000];
	Catalog catentry;
	//char    sp[1000];
	Catalog catentryo;
	//char    x[1000];
	AttributeType attrinfo;

	if( !readType( PclsName, &catentry, &status) ) return FALSE;
	CAT_CHECK( &status, TYPE_NOT_EXIST, "" );

	if ( !memcmp( &catentry.List_Attributes, &nullOid, S_OID ) )  
		// no attributes for this type...
		return TRUE;

	List attrlist( &catentry.List_Attributes, &l_type, &l_size, &status );
	INTERNAL_CHECK( &status, "can not construct list in describe" );

	CatATTRIBUTE curattr( AttributeId )  ;

	for ( indx = 0 ; indx < l_size ; indx++ ) { 
		attrlist.getElement( &attrOid, indx, &status );
		for( i = 0; i < left_tab; i++ ) printf(" ");
		INTERNAL_CHECK(&status, "can not receive attribute oid" );
          
		curattr.readAttr( attrOid,&attrinfo, &status );
		INTERNAL_CHECK(&status, "can not read attribute entry in describe" );

		printf("%s ", attrinfo.AttributeName );

		switch( attrinfo.AttributeConstructor ) { 
			case 'T' : left_tab +=3; printf( "TUPLE(\n "); par++; break;
			case 'S' : left_tab +=3; printf( "SET(\n "); par++; break;
			case 'R' : left_tab +=3; printf( "REF(\n "); par++; break;
			case 'L' : left_tab +=3; printf( "LIST(\n "); par++; break;
		}
            
		if( !readType( attrinfo.AttrType, &catentryo, &status));
		INTERNAL_CHECK( &status , "cant read type info in describe" );

		printf("%s ", catentryo.TypeName);
		if( !describe( attrinfo.AttrType,left_tab)) return FALSE;
		while ( par > 0 ) { 
			par = par - 1 ; 
			for( i = 0; i < left_tab; i++ ) printf(" ");
			left_tab -= 3;
			printf( ")" ) ;
		}
		printf("\n");
	}
	return TRUE;
}


int MoodsTypes::getAttrFile( FID *Pfid ) 
{
	memcpy( Pfid, &AttributeId, S_FID );
	return TRUE;
}

int MoodsTypes::deleteFiles() 
{
	int 		err;
	CatBOOLEAN 	status=0;

	mscat_DestroyFile( CatalogId, "deleting catalog file");
	mscat_DestroyFile( AttributeId, "deleting attribute file");
	mscat_DestroyFile( FunctionId, "deleting function file");
	mscat_DestroyFile( SequenceId, "deleting sequence file");

	return TRUE;
}


MoodsTypes::MoodsTypes() 
{
	// open catalog given catalog file....
	//printf("trying to get moodstypes\n");
	memset(&nullOid,0,S_OID);
	memset(&nullFid,0,S_FID);

	memcpy( &CatalogId,&DBrec.CatalogId,sizeof(FID));
	memcpy( &AttributeId, &DBrec.AttributeId,sizeof(FID) ); 
	memcpy( &FunctionId, &DBrec.FunctionId,sizeof(FID) );
	memcpy( &SequenceId, &DBrec.SequenceId,sizeof(FID) );
     
	strcpy( seqName, "__" );
	strcat( seqName, DBrec.dbname );
	strcat( seqName, "__" );
}

int MoodsTypes::deleteAttributes( Catalog ct, CatBOOLEAN *status )
{
	OID attrid;
	int indx,l_type,l_size;
	AttributeType intern_attr;
	Catalog intern_ct;
	int err;

	List a_list( &ct.List_Attributes, &l_type, &l_size, status ) ;
	INTERNAL_CHECK( status, " can not construct attr list" );

	CatATTRIBUTE attr_instance(AttributeId);

	for ( indx = 0 ; indx < l_size ; indx++ ) {

		a_list.getElement( &attrid, indx, status );
		INTERNAL_CHECK( status, "can not get entry from list" );


		attr_instance.readAttr( attrid , &intern_attr, status ) ;

		if ( intern_attr.AttributeConstructor != 'N' ) {

			if( !readType( intern_attr.AttrType , &intern_ct, status )) return FALSE;
			CAT_CHECK( status, TYPE_NOT_EXIST, "" );

			if( intern_ct.RefCount == 1 ) {

				if( !deleteAttributes( intern_ct, status ) ) return FALSE;
				INTERNAL_CHECK( status , "can not get internal attribute information");

				mscat_DestroyObject( intern_attr.AttrType, "" );
			} else {
				// decrement ref count
				if( !updateRefCount( intern_attr.AttrType, -1 ))
					return FALSE;
			}

		}

		// Destroy attribute object
		mscat_DestroyObject( attrid, "" );

	}

	// destroy attribute list
	mscat_DestroyObject( ct.List_Attributes, "");

  *status = 0 ;
  return TRUE;

}

/********
int MoodsTypes::deleteAttributes( OID PAttlist, CatBOOLEAN *Pstatus )
{ 
	OID 		element;
	int 		indx,l_type,l_size, err;
	Catalog 	typeinfo;

	List dellist( &PAttlist, &l_type, &l_size, Pstatus ) ;
	INTERNAL_CHECK( Pstatus, "can not construct list " );

	CatATTRIBUTE subattr(AttributeId) ;

	for ( indx= 0 ; indx < l_size ; indx++ ) { 
		dellist.getElement( &element, indx, Pstatus ) ;
		INTERNAL_CHECK( Pstatus , "error on getting element from attribute list" ); 
		if( !readType(element, &typeinfo, Pstatus ) ) return FALSE;

		if ( !strcmp (typeinfo.TypeName," ") ) 
			if( !( OID_IS_INVALID( typeinfo.List_Attributes ) ) )
				if( !deleteAttributes( typeinfo.List_Attributes, Pstatus)) return FALSE ;

		mscat_DestroyObject( element, "can not delete attribute");
	}
	mscat_DestroyObject( PAttlist, "");
	return TRUE;
} 
*********/

int MoodsTypes::deleteType( OID Ptype )
{
	int 	err;
	mscat_DestroyObject( Ptype, "" );
	return TRUE;
}
           

           

int MoodsTypes::dropFromSuperClass( OID PClass, OID PList, CatBOOLEAN *Pstatus ) 
{ 
	int     indx,indxo,l_type,l_size,i_type,i_size ;
	OID     element,elemento;
	Catalog typeinfo;

	if ( memcmp( &PList , &nullOid, S_OID ) ) { // list not empty ....
		List superlist( &PList, &l_type, &l_size, Pstatus ) ;
		INTERNAL_CHECK( Pstatus, "unable to construct list" );
 
		for ( indx = 0 ; indx < l_size ; indx++ ) {
			superlist.getElement( &element ,indx, Pstatus ) ;
			INTERNAL_CHECK( Pstatus , "unable to receive element from list" );
	
			readType( element, &typeinfo, Pstatus) ;
			INTERNAL_CHECK( Pstatus , "unable to read type information");

			if ( memcmp( &typeinfo.List_SubClass, &nullOid, S_OID ) ) { 
				// super class has some sub class list ...
				List subclass(&typeinfo.List_SubClass,&i_type,&i_size,Pstatus);
				INTERNAL_CHECK( Pstatus , " can not construct intern. subclass " );

				for ( indxo = 0 ; indxo < i_size ; indxo++ ) { 
					subclass.getElement( &elemento, indxo, Pstatus) ;
					INTERNAL_CHECK( Pstatus, "cant receive element from list" );
           
					if ( !memcmp( &PClass, &elemento, S_OID ) ) { 
						// my type is found...
						subclass.deleteFromList( indxo, indxo, Pstatus);
						INTERNAL_CHECK( Pstatus,"error deleting from super cls");
   
					}
				} 
			} else { 
				*Pstatus = 1 ;
				INTERNAL_CHECK( Pstatus , "super dont have sub as me" );
			}
		}
	} else {
		*Pstatus = 1 ;
		INTERNAL_CHECK( Pstatus, "no elements in super class's sub list" );
	}

	return TRUE;
}

int MoodsTypes::deleteClass(char *PclsName,int *Pforce, CatBOOLEAN *status ) 
{ 
	OID tmpOid;
	if( !getTypOid(PclsName, &tmpOid, status )) return FALSE;
	INTERNAL_CHECK(status, "can not find type entry" );
	if( !deleteClass( tmpOid, Pforce, status)) return FALSE;
	return TRUE;
}



/********************************************
int MoodsTypes::deleteClass( OID PClass, int *PForce, CatBOOLEAN *Pstatus ) 
{
	Catalog delClass;
	int     l_type,l_size, indx ;
	OID     element ;
	int     err;

	readType( PClass, &delClass, Pstatus );
	INTERNAL_CHECK( Pstatus, "class non existant" );

	if ( !memcmp( &delClass.List_SubClass, &nullOid, S_OID ) ) {
		// no inherited classes ( LEAF LEVEL ) .....
		dropFromSuperClass( PClass, delClass.List_SuperClass, Pstatus );
		INTERNAL_CHECK( Pstatus, "can not delete from super class" );
      
		// current type is deleted from all super classes
// deleteAttributes( delClass.List_Attributes , Pstatus );
// CAT_CHECK( Pstatus, "can not delete attributes of class " );
// you can not understand this please don't bother..

		mscat_DestroyFile( delClass.Instance_File, "destroying instance file");
        
		if( !deleteType( PClass ) ) return FALSE ;
		*Pstatus = 0 ;
	} else { // contains sub classes ....
		if ( *PForce ) { // sure delete....
			List subcls( &delClass.List_SubClass, &l_type, &l_size, Pstatus) ;
			INTERNAL_CHECK( Pstatus, "error constructing sub class list");
             
			for ( indx = 0 ; indx < l_size ; indx++ ) { 
				// delete all sub classes ...
				subcls.getElement( &element, indx, Pstatus );
				INTERNAL_CHECK( Pstatus, "can not get subclass from list" );
				deleteClass( element, PForce, Pstatus );
				INTERNAL_CHECK( Pstatus, "error on delete class" );
			}

			if ( !l_size ) { // no entries in list....
			dropFromSuperClass( PClass, delClass.List_SuperClass, Pstatus );
			INTERNAL_CHECK( Pstatus , "can not delete from super class" );
//deleteAttributes( delClass.List_Attributes , Pstatus );
//CAT_CHECK( Pstatus, "can not delete attributes of class" );
// you can not understand this please don't bother..
			mscat_DestroyFile( delClass.Instance_File, "destroying instance file");
			if( !deleteType( PClass)) return FALSE;
			return TRUE;
		}

		*PForce = 0 ;
		*Pstatus = 0 ;
		} else { 
			*PForce = 1 ;
			*Pstatus = 1 ;
		}
}
mscat_DestroyFile( delClass.Instance_File, "destroying instance file");
	return TRUE;
}
*****************************************************************/

int MoodsTypes::deleteClass( OID PClass, int *PForce, CatBOOLEAN *Pstatus ) 
{
	Catalog delClass;
	int     l_type,l_size, indx ;
	OID     element ;
	int     err;

	// read class info. for class tobe dropped
	readType( PClass, &delClass, Pstatus );
	INTERNAL_CHECK( Pstatus, "class non existant" );

	// destroy instance file
	mscat_DestroyFile( delClass.Instance_File, "destroying instance file");

	// delete from super class list
	if( !( OID_IS_INVALID( delClass.List_SuperClass )) )
	{
		dropFromSuperClass( PClass, delClass.List_SuperClass, Pstatus );
		INTERNAL_CHECK( Pstatus, "can not delete from super class" );
		mscat_DestroyObject( delClass.List_SuperClass, "" );
	}

	// delete from subclass list
	if( !(OID_IS_INVALID( delClass.List_SubClass ) ))
	{
		dropFromSubClass( PClass, delClass.List_SubClass, Pstatus );
		INTERNAL_CHECK( Pstatus, "can not delete from sub class" );
		mscat_DestroyObject( delClass.List_SubClass, "" );
	}

	// delete attributes of class
	if( !( OID_IS_INVALID( delClass.List_Attributes )) )
	{
		if( !deleteAttributes( delClass, Pstatus ))
			return FALSE;
		INTERNAL_CHECK( Pstatus, "can not delete attributes of class " );
	}

	// delete the function of class
	if( !( OID_IS_INVALID( delClass.List_Function )) )
	{
		int listType, listSize, indx;
		OID lele;

		List funcList( &delClass.List_Function, &listType, &listSize, Pstatus);

		for( indx = 0 ; indx < listSize ; indx++ ) {
			funcList.getElement( &lele, indx, Pstatus );
			INTERNAL_CHECK( Pstatus, "cant receive element from list" );
			mscat_DestroyObject( lele, "" );
		}

		INTERNAL_CHECK( Pstatus, "can not delete attributes of class " );
		mscat_DestroyObject( delClass.List_Function, "" );
	}


	// Now remove the Catalog object
	if( !deleteType( PClass ) ) return FALSE ;

	return TRUE;
}



int MoodsTypes::dropFromSubClass( OID PClass, OID PList, CatBOOLEAN *Pstatus ) 
{ 
	int     indx,indxo,l_type,l_size,i_type,i_size ;
	OID     element,elemento;
	Catalog typeinfo;

	if ( memcmp( &PList , &nullOid, S_OID ) ) { // list not empty ....
		List sublist( &PList, &l_type, &l_size, Pstatus ) ;
		INTERNAL_CHECK( Pstatus, "unable to construct list" );
 
		for ( indx = 0 ; indx < l_size ; indx++ ) {
			sublist.getElement( &element ,indx, Pstatus ) ;
			INTERNAL_CHECK( Pstatus , "unable to receive element from list" );
	
			if( readType( element, &typeinfo, Pstatus))
				return FALSE;
			INTERNAL_CHECK( Pstatus , "unable to read type information");

			if ( memcmp( &typeinfo.List_SuperClass, &nullOid, S_OID ) ) { 
				// super class has some sub class list ...
				List superclass(&typeinfo.List_SuperClass,&i_type,&i_size,Pstatus);
				INTERNAL_CHECK( Pstatus , " can not construct intern. subclass " );

				for ( indxo = 0 ; indxo < i_size ; indxo++ ) { 
					superclass.getElement( &elemento, indxo, Pstatus) ;
					INTERNAL_CHECK( Pstatus, "cant receive element from list" );
           
					if ( !memcmp( &PClass, &elemento, S_OID ) ) { 
						// my type is found...
						superclass.deleteFromList( indxo, indxo, Pstatus);
						INTERNAL_CHECK( Pstatus,"error deleting from super cls");
					}
				} 
			} else { 
				*Pstatus = 1 ;
				INTERNAL_CHECK( Pstatus , "super dont have sub as me" );
			}
		}
	} else {
		*Pstatus = 1 ;
		INTERNAL_CHECK( Pstatus, "no elements in super class's sub list" );
	}

	return TRUE;
}

            
int MoodsTypes::writeType( Catalog Pcat, OID *Ptypeoid, CatBOOLEAN *Pstatus) 
{
	Catalog 	tmpCat;
	int 		err;

	Sequence typeIdgen ;
	if( !typeIdgen.initSequence( &SequenceId, seqName, Pstatus))
		return FALSE;

	INTERNAL_CHECK( Pstatus , "can not create type id generator" );
       
	memcpy( &tmpCat, &Pcat, S_CATALOG );
	if( !typeIdgen.getNextVal( &tmpCat.TypeId, Pstatus )) return FALSE;
	INTERNAL_CHECK( Pstatus , "can not get next value from type id generator" );

	mscat_CreateObject( CatalogId, S_CATALOG, &tmpCat, Ptypeoid,"error writing type information" ); 

	return TRUE;
}

int MoodsTypes::findType( char *PClsName, CatBOOLEAN *found ) 
{
	OID		spare;

	// search class by its name
	if( !getTypOid( PClsName, &spare, found )) return FALSE;

	return TRUE;
}

int MoodsTypes::updateType( OID Ptypeoid, Catalog Ptypeinfo ) 
{
	int     err ;

	mscat_ReadObject( Ptypeoid, "reading type info");
	mscat_WriteObject( S_CATALOG, &Ptypeinfo,"update type entry" ); 
	mscat_ReleaseObject("");

	return TRUE;
}

int MoodsTypes::updateRefCount( OID typeOid, int updateVal )
{
	Catalog	typeInfo;
	CatBOOLEAN status;
	int err;

	// read class info
   	if( !readType( typeOid, &typeInfo, &status )) return FALSE;
   	INTERNAL_CHECK( &status, "can not read super class info ");

	// if type is unnamed type
	if( !strcmp( typeInfo.TypeName, " " ) )
	{
		typeInfo.RefCount += updateVal;
		mscat_ReadObject( typeOid, "reading type info");
		mscat_WriteObject( S_CATALOG, &typeInfo,"update type entry" );
		//mscat_ReleaseObject("");
	}
 
	return TRUE;
	
}

int MoodsTypes::copyInheritedTypes( OID *Pinherit, List *Psuperlist, int *Poffset, CatBOOLEAN *Pstatus ) 
{
	Catalog typeinfo;
	int     l_type,l_size ;
	OID     attroid,tmpoid;
	AttributeType attrinfo;

	// read super class info
	if( !readType( *Pinherit, &typeinfo, Pstatus )) return FALSE;
	INTERNAL_CHECK( Pstatus, "can not read super class info ");

	// construct superclass list
	List attrlist(&typeinfo.List_Attributes, &l_type, &l_size, Pstatus );
	INTERNAL_CHECK( Pstatus , "can not construct attribute list " );

	CatATTRIBUTE curattr(AttributeId) ;

	attrlist.getFirst(&attroid, Pstatus);
	INTERNAL_CHECK( Pstatus, "can not get first attribute" );

	curattr.readAttr( attroid, &attrinfo, Pstatus );
	INTERNAL_CHECK( Pstatus, "can not read attribute information" );

	do { 
		attrinfo.AttributeOffset = *Poffset ;
		*Poffset = *Poffset + attrinfo.AttributeLength ;


		// set as inherited from super class
		attrinfo.ClassMember = 0 ;


		// if this is a unnamed type than increment its RefCount
		if( attrinfo.AttributeConstructor != 'N' ) {
			if( !updateRefCount( attrinfo.AttrType, 1 ))
				return FALSE;
		}

		//printf("writing attribute info as...:\n");
		//printf("%x\n",attrinfo.ClassMember);
		curattr.writeAttr( attrinfo , &tmpoid );
		Psuperlist->insertToList( &tmpoid, Pstatus );
		INTERNAL_CHECK( Pstatus, "error on inserting attribute list" );
          
		attrlist.getNext(&attroid, Pstatus);
          
		if ( !(*Pstatus) ) curattr.readAttr(attroid, &attrinfo, Pstatus) ;
              
	} while ( !(*Pstatus) ) ;
	*Pstatus = 0; 
	return TRUE;
}


/**************


int MoodsTypes::copyInheritedTypes( OID *Pinherit, List *Psuperlist, int *Poffset, CatBOOLEAN *Pstatus ) 
{
	Catalog typeinfo;
	int     l_type,l_size ;
	OID     attroid,tmpoid;
	AttributeType attrinfo;

	if( !readType( *Pinherit, &typeinfo, Pstatus )) return FALSE;
	INTERNAL_CHECK( Pstatus, "can not read super class info ");

	List attrlist(&typeinfo.List_Attributes, &l_type, &l_size, Pstatus );
	INTERNAL_CHECK( Pstatus , "can not construct attribute list " );

	CatATTRIBUTE curattr(AttributeId) ;

	attrlist.getFirst(&attroid, Pstatus);
	INTERNAL_CHECK( Pstatus, "can not get first attribute" );

	curattr.readAttr( attroid, &attrinfo, Pstatus );
	INTERNAL_CHECK( Pstatus, "can not read attribute information" );

	do { 
		attrinfo.AttributeOffset = *Poffset ;
		*Poffset = *Poffset + attrinfo.AttributeLength ;
		attrinfo.ClassMember = 0 ;
		//printf("writing attribute info as...:\n");
		//printf("%x\n",attrinfo.ClassMember);
		curattr.writeAttr( attrinfo , &tmpoid );
		Psuperlist->insertToList( &tmpoid, Pstatus );
		INTERNAL_CHECK( Pstatus, "error on inserting attribute list" );
          
		attrlist.getNext(&attroid, Pstatus);
          
		if ( !(*Pstatus) ) curattr.readAttr(attroid, &attrinfo, Pstatus) ;
              
	} while ( !(*Pstatus) ) ;
	*Pstatus = 0; 
	return TRUE;
}
************/

int MoodsTypes::linkToSuper( OID Pinherits, OID Pmytype ) 
{
	CatBOOLEAN status = 0;
	int     l_type,l_size,i_size,i_type,indx;
	OID     oid,tmpoid,inheritsoid;;
	Catalog curtype;

	// construct a list of super classes ....
	List superCls( &Pinherits, &l_type, &l_size, &status );
	INTERNAL_CHECK( &status, "can not construct super class list" );
     
	for ( indx = 0 ; indx < l_size ; indx++ ) {
		superCls.getElement( &oid, indx, &status );
		INTERNAL_CHECK( &status, "can not get super class oid" );

		// read type info of super class... 
		if( !readType( oid, &curtype, &status )) return FALSE;
		INTERNAL_CHECK( &status, "can not read super class type" );

		if ( !memcmp( &curtype.List_SubClass, &nullOid, S_OID ) ) { 
			// null list ( not created yet ) ..... (create it)...
			List sublist(&CatalogId,NEAR_FIRST_PHYSICAL,NULL,MAXINHERITS,&status);
			INTERNAL_CHECK( &status, "can not construct subclass list" );

			sublist.insertToList(&Pmytype, &status);
			INTERNAL_CHECK( &status, "can not insert mytype to subclass list" );

			sublist.getListOid( &tmpoid, &status );
			INTERNAL_CHECK( &status, "can not get lists oid" );

			memcpy(&curtype.List_SubClass, &tmpoid, S_OID );
           
			if( !updateType( oid, curtype )) return FALSE;
		} else { // sub class list exists ....
                
			// load list into memory....
			List sublist( &curtype.List_SubClass,&i_type,&i_size,&status);
			INTERNAL_CHECK( &status, "error on getting sub class list ");

			sublist.insertToList( &Pmytype, &status); 
			INTERNAL_CHECK( &status, "can not insert mytype to subclass list" );
  
		}
	}
	return TRUE;
}      


long TypeNameOffset_Catalog( Catalog *mythis ) 
{
	return ( (long) &mythis->TypeName  -  (long) mythis );
}

long TypeIdOffset_Catalog( Catalog *mythis ) 
{
	return ( (long) &mythis->TypeId  -  (long) mythis );
}

int MoodsTypes::getTypOid( char *PClsName, OID *PTypeOid, CatBOOLEAN *Pstatus) 
{
	Catalog 	tinfo;

	*Pstatus = 0; // set found flag as FOUND
	
	if( (PClsName == NULL ) || ( !strcmp( PClsName, " ")) ) {
		// set an error
		*Pstatus = 1;
		return TRUE;
	}

        // search class by its name
	if( !ms_LocateObject( &CatalogId, CHAR, PClsName, TypeNameOffset_Catalog(&tinfo),PTypeOid, TYPE_CATALOG ) ) return FALSE;

	// if class is not found set status as 1
	if( OID_IS_INVALID( (*PTypeOid )) ) *Pstatus = 1;
	else *Pstatus = 0;

	return TRUE;

}

int MoodsTypes::getTypOid( int typeident , OID *PTypeOid, CatBOOLEAN *Pstatus) 
{
	Catalog tinfo;
	int anyInt = typeident;

	ms_LocateObject( &CatalogId, INTEGER, (char *) &anyInt, TypeIdOffset_Catalog( &tinfo), PTypeOid, TYPE_CATALOG );
	if( OID_IS_INVALID( (*PTypeOid) )) *Pstatus = 1;
	else *Pstatus = 0;
	return TRUE;
}


int MoodsTypes::createInstanceFile( FID * PFid, CatBOOLEAN *Pstatus ) 
{
	int err;

	*Pstatus = 0;
	mscat_CreateFile( (*PFid)," creating instance file" );
	printf("CREATING INSTANCE FILE FOR CLASS\n");
	return TRUE;
}

int MoodsTypes::readType( OID PtypeOid, Catalog *Pcat, CatBOOLEAN *Pstatus ) 
{	
	int err ;
     
	mscat_ReadObject( PtypeOid, "reading catalog object");

	if(UserDesc==NULL) *Pstatus = 1;
	else {
		*Pstatus = 0;
		memcpy(Pcat,UserDesc->basePtr,sizeof(Catalog));
	}

	mscat_ReleaseObject( "can not release object");

	return TRUE;
}
     

int MoodsTypes::readType( char *PClsName, Catalog *Pcat, CatBOOLEAN *Pstatus) 
{ 
	int err ;
	OID tmpOid;

	if( !getTypOid( PClsName, &tmpOid, Pstatus) ) return FALSE;
	mscat_ReadObject( tmpOid, "reading catalog object");
 
	if ( UserDesc == NULL ) *Pstatus = 1;
	else {
		*Pstatus = 0;
		memcpy( Pcat, UserDesc->basePtr, sizeof(Catalog) ) ;
	}

	mscat_ReleaseObject( "can not release object");

	return TRUE;
}

int MoodsTypes::setClassType( char *Ptype, int User ) 
{
	if ( User == 0 ) *Ptype = 'C' ;
	else if ( User == 1 ) *Ptype = 'c' ;
	else *Ptype = 't' ;
	return TRUE;
} 

int MoodsTypes::createUnnamedType( memberNode *Pattr, int *offset, OID *Ptypeoid, CatBOOLEAN *status ) 
{ 
	Catalog unnamed;
	int 	Size;
	OID	CAoid;

	// construct attribute list for internal type 
	List attrList( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXATTR, status );
	INTERNAL_CHECK( status , " can not construct attribute list for unnamed" );
             
	Size = *offset ;
	strcpy( unnamed.TypeName, " ");
	setClassType( &unnamed.ClassType, 1 ); // user class ...
	unnamed.RefCount = 1;
	MoodsAttr( Pattr , offset, &attrList, status );
	INTERNAL_CHECK( status, "error creating attribute entries for unnamed" );
    
	attrList.getListOid( &CAoid, status );
	INTERNAL_CHECK( status , "can not get unnamed attribute list oid" );

	memcpy( &unnamed.List_Attributes, &CAoid, S_OID );
	//memcpy( &unnamed.Statistics, &nullOid, S_OID );
	memcpy( &unnamed.List_SuperClass, &nullOid, S_OID );
	memcpy( &unnamed.List_SubClass, &nullOid, S_OID );
	memcpy( &unnamed.Instance_File, &nullFid, S_FID );
	unnamed.Size = *offset - Size ;
	writeType( unnamed, Ptypeoid, status );
	INTERNAL_CHECK( status, "can not write unnamed type" );
	return TRUE;
     
}

int MoodsTypes::addAttributeToClass( char *PclsName, memberNode *Pmember, CatBOOLEAN *status)
{
	OID  	typeOid, atrOid;
	Catalog typeinfo;
	int     offset, l_size, l_type; 

	if( !getTypOid( PclsName, &typeOid, status )) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, PclsName );

	if( !readType( typeOid, &typeinfo, status )) return FALSE;
	CAT_CHECK( status, TYPE_NOT_EXIST, "");

	offset = typeinfo.Size;
	List attrlist( &typeinfo.List_Attributes, &l_type, &l_size, status );
	INTERNAL_CHECK(status, "can not construct list of attributes");

	MoodsAttr( Pmember, &offset, &attrlist, status);
	INTERNAL_CHECK( status, "can not add attributes to class");

	typeinfo.Size = offset; 
	if( !updateType( typeOid, typeinfo )) return FALSE;

	return TRUE;
}


int MoodsTypes::MoodsAttr( memberNode *Attribute, int *offset, List *superList, CatBOOLEAN *status ) 
{
	AttributeType moodsattr;
	int size;
	OID unnamedOid,tmpOid,typePtr;
	Catalog typeinfo,mycat;

     if ( Attribute == NULL )  return TRUE;

     getTypOid( Attribute->typeName, &typePtr, status );
     if( *status ) return FALSE;
 
     readType( typePtr, &mycat, status );

     Attribute->type = mycat.TypeId;

     
     CatATTRIBUTE curAttr( AttributeId );
     strcpy( moodsattr.AttributeName , Attribute->memberName );
     moodsattr.AttributeOffset = *offset;
     //memcpy( &moodsattr.Statistic, &nullOid, S_OID );
     size = *offset ;

     if( Attribute->type == TYPE_SET || Attribute->type == TYPE_LIST ||
	 Attribute->type == TYPE_REF || Attribute->type == TYPE_TUPLE ) {
     	switch( Attribute->type ) {
		case TYPE_SET   : moodsattr.AttributeConstructor='S'; break;
		case TYPE_LIST  : moodsattr.AttributeConstructor='L'; break;
		case TYPE_REF   : moodsattr.AttributeConstructor='R'; break;
		case TYPE_TUPLE : moodsattr.AttributeConstructor='T'; break;
     	}

     	createUnnamedType( Attribute->subAttributes, offset,&unnamedOid, status);
     	INTERNAL_CHECK( status, "error creating unnamed type ");
	if(Attribute->type==TYPE_TUPLE) moodsattr.AttributeLength=*offset-size;
	else moodsattr.AttributeLength = S_OID;
     	memcpy( &moodsattr.AttrType, &unnamedOid, S_OID );
     	strcpy( moodsattr.AttrTypeName, " ");
     	moodsattr.ClassMember = 1 ;
     	curAttr.writeAttr( moodsattr, &tmpOid );
     	superList->insertToList( &tmpOid, status );
     	INTERNAL_CHECK( status, "error inserting super list" );
	if( Attribute->type  != TYPE_TUPLE  ) *offset = size + S_OID ;
     	MoodsAttr( Attribute->attributeList, offset, superList, status );
     	INTERNAL_CHECK( status, "error creating unnamed type ");
     } else {
	moodsattr.AttributeConstructor='N';
	getTypOid( Attribute->type, &tmpOid, status ) ;
	INTERNAL_CHECK( status, "can not find type entry" );
	memcpy( &moodsattr.AttrType, &tmpOid, S_OID );
	readType( tmpOid, &typeinfo, status );
	INTERNAL_CHECK( status , "can not read type entry" );
	strcpy( moodsattr.AttrTypeName, typeinfo.TypeName );
	if ( Attribute->size) { 
		moodsattr.AttributeLength = Attribute->size ;
		*offset = *offset + Attribute->size;
	} else {
		moodsattr.AttributeLength = typeinfo.Size ;
		*offset = *offset + typeinfo.Size ;
	}
	moodsattr.ClassMember = 1 ;
	curAttr.writeAttr( moodsattr, &tmpOid );
	superList->insertToList( &tmpOid, status );
	INTERNAL_CHECK( status , "can not insert to attribute list" );
	MoodsAttr( Attribute->subAttributes, offset, superList, status) ;
	INTERNAL_CHECK( status, "error on creating internal type entries");
	MoodsAttr( Attribute->attributeList, offset, superList, status) ;
	INTERNAL_CHECK( status, "error on creating internal type entries");
    }
    return TRUE;
} // MoodsAttr ENDS...            


int MoodsTypes::createIndex( char *Pclass, OID Pindexoid , CatBOOLEAN *Pstatus) {
OID typeoid;
Catalog typeinfo;
int l_type, l_size; 

	getTypOid( Pclass, &typeoid,Pstatus);
	CAT_CHECK( Pstatus, TYPE_NOT_EXIST, Pclass );

	readType( typeoid, &typeinfo , Pstatus) ;
	INTERNAL_CHECK( Pstatus, "internal type read error" );
/***************************************
	List indxList ( &typeinfo.List_Index , &l_type, &l_size , Pstatus);
	INTERNAL_CHECK( Pstatus, "can not construct list of indexes");

	indxList.insertToList( &Pindexoid, Pstatus);
	INTERNAL_CHECK( Pstatus, "can not insert to index list");


	typeinfo.ifIndex = typeinfo.ifIndex + 1 ;
	if( !updateType( typeoid, typeinfo )) return FALSE;
***************************************/
	return TRUE;
}


int MoodsTypes::dropIndex( char *Pclass, OID Pindexoid, CatBOOLEAN *Pstatus ) {
/**********
	OID typeoid,tmpoid;
	Catalog typeinfo;
	int l_type,l_size ,indx;


	getTypOid( Pclass, &typeoid,Pstatus);
	CAT_CHECK( Pstatus, TYPE_NOT_EXIST, Pclass );

	readType( typeoid, &typeinfo , Pstatus) ;
	INTERNAL_CHECK( Pstatus, "internal type read error" );

	List indxList ( &typeinfo.List_Index , &l_type, &l_size , Pstatus);
	INTERNAL_CHECK( Pstatus, "can not construct list of indexes");

	for( indx=0 ; indx < l_size ; indx++ ) { 
		indxList.getElement( &tmpoid, indx, Pstatus);
		INTERNAL_CHECK( Pstatus, "internal: can not get element from index list");
		if ( !memcmp( &Pindexoid, &tmpoid, S_OID ) ) { 
			// found.... so delete ...
			printf("index found and will be deleted\n");
			indxList.deleteFromList( indx,indx, Pstatus);
			INTERNAL_CHECK( Pstatus, "can not drop index from index list");
			typeinfo.ifIndex = typeinfo.ifIndex - 1;
			if( !updateType( typeoid, typeinfo )) return FALSE;
			return TRUE;
		}
	}
	return TRUE;
******************/
}



	  
                        
int MoodsTypes::addType( char * PclassName, LinkedList *Pinherits,
                          memberNode *Pmember, int User, CatBOOLEAN *Pstatus ) 
{
	Catalog ClassHolder;
	int err,attrOffset=0;
	OID InheritsOid,SCoid,CAoid,Faoid,typeoid,indexoid;
	void *my_entry;
	CatBOOLEAN doesTypeNotExist=0;

  if( !findType( PclassName, &doesTypeNotExist )) return FALSE;

  if ( doesTypeNotExist ) { // no type name conflict..
       strcpy(ClassHolder.TypeName, PclassName);
       ClassHolder.RefCount = 1;
       setClassType( &ClassHolder.ClassType, User ) ;
       List superList( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXATTR, Pstatus );
       INTERNAL_CHECK(Pstatus, "can not construct list");
       
		if( !strcmp( PclassName, "FunctionType" ) )
			memcpy( &ClassHolder.Instance_File,&DBrec.FunctionId, S_FID );
		else if( !strcmp( PclassName, "AttributeType" ) )
			memcpy( &ClassHolder.Instance_File,&DBrec.AttributeId, S_FID );
		else if( !strcmp( PclassName, "Catalog" ) )
			memcpy( &ClassHolder.Instance_File,&DBrec.CatalogId,S_FID );
		{
        mscat_CreateFile( ClassHolder.Instance_File, "error creating instance file" );
		}
	//displayFID( &ClassHolder.Instance_File );

       List SuperClass( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXCLASS, Pstatus);
       INTERNAL_CHECK(Pstatus, "can not construct list");

/***********************************
		 List indexlist( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXATTR , Pstatus );
		 INTERNAL_CHECK( Pstatus, "can not construct index list");

       indexlist.getListOid( &indexoid, Pstatus );
		 INTERNAL_CHECK( Pstatus , "can not get index list oid");

		 memcpy( &ClassHolder.List_Index , &indexoid , S_OID );

		 ClassHolder.ifIndex = 0 ; // initially no index defined ..
**************************************/
        

       if ( Pinherits != NULL ) { // there are some inherited classes ..
            // inherit from MoodsRoot first....

/****************** It is inherited previously
            getTypOid("MoodsRoot",&rootOid, Pstatus) ;

	    if ( !(*Pstatus) ) { // no MoodsRoot is defined yet... so no inherit no.
                 SuperClass.insertToList( &rootOid, Pstatus );
                 INTERNAL_CHECK( Pstatus, "can not insert to list" );
             
                 copyInheritedTypes( &rootOid, &superList, &attrOffset, Pstatus );
                 INTERNAL_CHECK( Pstatus, "fail on inherits..");
            } // else  printf( "NO MOODSROOT CLASS DEFINED\n") ;
************************************************/

            my_entry = Pinherits->getFirstEntry();
            
            while ( my_entry != NULL ) { // do others...
                   getTypOid(((struct inherits *)my_entry)->cname,&InheritsOid,Pstatus);
                   INTERNAL_CHECK( Pstatus, "can not get info on type");

                   SuperClass.insertToList(&InheritsOid, Pstatus);
                   INTERNAL_CHECK( Pstatus, "can not insert to list");

                   copyInheritedTypes( &InheritsOid, &superList, &attrOffset, Pstatus );
                   INTERNAL_CHECK( Pstatus, "can not copy attributes of super classes");

                   my_entry = Pinherits->getNextEntry();
            }

            SuperClass.getListOid( &SCoid, Pstatus );
            INTERNAL_CHECK( Pstatus, "error getting list oid" );

            memcpy( &ClassHolder.List_SuperClass, &SCoid, S_OID );

       } else { // no inherited class ...

		getTypOid("MoodsRoot", &rootOid, Pstatus);

		 if ( !(*Pstatus) ) { // ok , there is a MoodsRoot entry... so copy..
                 SuperClass.insertToList( &rootOid, Pstatus );
                 INTERNAL_CHECK( Pstatus, "can not insert to list");

                 copyInheritedTypes( &rootOid, &superList, &attrOffset, Pstatus );
                 INTERNAL_CHECK( Pstatus, "can not copy attributes of super classes");
            } //else { printf( "NO MOODSTYPE CLASS\n" ) ; } ;

            SuperClass.getListOid( &SCoid, Pstatus);
            INTERNAL_CHECK( Pstatus , "error on getting list oid");

            memcpy( &ClassHolder.List_SuperClass, &SCoid, S_OID );
       } 

       if ( Pmember != NULL ) { 
            MoodsAttr( Pmember, &attrOffset, &superList, Pstatus );
            INTERNAL_CHECK( Pstatus , " error on creating attribute entries..." );
       }
       superList.getListOid( &CAoid, Pstatus );
       INTERNAL_CHECK( Pstatus, "error getting attribute list oid");

       memcpy(&ClassHolder.List_Attributes, &CAoid, S_OID );
       ClassHolder.Size = attrOffset ; 

       List subclass( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXCLASS, Pstatus );
       INTERNAL_CHECK( Pstatus , " error creating sub class list" );
       
       subclass.getListOid( &CAoid, Pstatus );
       INTERNAL_CHECK( Pstatus , "error getting list oid of subclass list");
       
       memcpy( &ClassHolder.List_SubClass, &CAoid, S_OID );


       List funclist( &FunctionId, NEAR_FIRST_PHYSICAL, NULL, MAXFUNC, Pstatus ); 
       INTERNAL_CHECK( Pstatus , " error creating function list" );

       funclist.getListOid( &Faoid, Pstatus);
       INTERNAL_CHECK( Pstatus, "error getting list oid of function list");

       memcpy( &ClassHolder.List_Function, &Faoid, S_OID);

  //     createInstanceFile( &ClassHolder.Instance_File , Pstatus );
   //    CAT_CHECK( Pstatus , "error creating instance file");
   
       //memcpy( &ClassHolder.Statistics, &nullOid, S_OID );

       writeType( ClassHolder, &typeoid, Pstatus );
       INTERNAL_CHECK( Pstatus, "error writing type entry");

       SuperClass.getListOid( &SCoid, Pstatus );
       INTERNAL_CHECK( Pstatus , "error getting superclass list oid" );

       linkToSuper( SCoid, typeoid );
  } else {
       *Pstatus = 1 ;
	catalogError.setError( RUNTIME_ERROR, TYPE_ALR_EXIST, PclassName );
	return FALSE;
  } 

  // Everything OK up to now, Generate a header file for the class
  // CERTAN ASAIGIDAKI STRCMP'YE !I BEN KOYDUM SEVGILER YUKSEL
  *Pstatus = 0 ;
  if( strcmp( PclassName, "MoodsRoot" ) ) // if the class is not MoodsRoot
  {
     CreateHeader headerCreator;
     headerCreator.createheaderfile( PclassName, Pinherits, Pmember );
  }

  return TRUE;
} // END OF ADD TYPE ......             




int MoodsTypes::createEmptyClass( char * PclassName )
{
	Catalog ClassHolder;
	int err,attrOffset=0;
	OID SCoid,CAoid,Faoid,typeoid,indexoid;
	CatBOOLEAN status = 0;

	if( !findType( PclassName, &status ) ) return FALSE;

	if ( status ) { // no type name conflict..
		strcpy(ClassHolder.TypeName, PclassName);
		ClassHolder.RefCount = 1;
		//setClassType( &ClassHolder.ClassType, User ) ;
		List superList( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXATTR, &status );
		INTERNAL_CHECK(&status, "can not construct list");

		if( !strcmp( PclassName, "FunctionType" ) )
			memcpy( &ClassHolder.Instance_File,&DBrec.FunctionId, S_FID );
		else if( !strcmp( PclassName, "AttributeType" ) )
			memcpy( &ClassHolder.Instance_File,&DBrec.AttributeId, S_FID );
		else if( !strcmp( PclassName, "Catalog" ) )
			memcpy( &ClassHolder.Instance_File,&DBrec.CatalogId,S_FID );
		else {
			mscat_CreateFile( ClassHolder.Instance_File, "error creating instance file" );
		}

		List SuperClass( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXCLASS, &status);
		INTERNAL_CHECK(&status, "can not construct list");
/*********************
		List indexlist( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXATTR , &status );
		INTERNAL_CHECK( &status, "can not construct index list");

		indexlist.getListOid( &indexoid, &status );
		INTERNAL_CHECK( &status , "can not get index list oid");
		memcpy( &ClassHolder.List_Index , &indexoid , S_OID );

		ClassHolder.ifIndex = 0 ; // initially no index defined ..
**********************/
        
		SuperClass.getListOid( &SCoid, &status);
		INTERNAL_CHECK( &status , "error on getting list oid");
		memcpy( &ClassHolder.List_SuperClass, &SCoid, S_OID );

		superList.getListOid( &CAoid, &status );
		INTERNAL_CHECK( &status, "error getting attribute list oid");
		memcpy(&ClassHolder.List_Attributes, &CAoid, S_OID );

		List subclass( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXCLASS, &status );
		INTERNAL_CHECK( &status , " error creating sub class list" );
       
		subclass.getListOid( &CAoid, &status );
		INTERNAL_CHECK( &status , "error getting list oid of subclass list");
		memcpy( &ClassHolder.List_SubClass, &CAoid, S_OID );

		List funclist( &FunctionId, NEAR_FIRST_PHYSICAL, NULL, MAXFUNC, &status ); 
		INTERNAL_CHECK( &status , " error creating function list" );

		funclist.getListOid( &Faoid, &status);
		INTERNAL_CHECK( &status, "error getting list oid of function list");
		memcpy( &ClassHolder.List_Function, &Faoid, S_OID);

		//memcpy( &ClassHolder.Statistics, &nullOid, S_OID );

		ClassHolder.Size = 0;

		writeType( ClassHolder, &typeoid, &status );
		INTERNAL_CHECK( &status, "error writing type entry");

  }
  return TRUE;
}

int MoodsTypes::fillEmptyClass( char * PclassName, LinkedList *Pinherits,
                          memberNode *Pmember, int User, CatBOOLEAN *Pstatus )
{
	Catalog cat;
	int err,attrOffset=0,l_type, l_size;
	OID InheritsOid,SCoid,CAoid,Faoid,oid,indexoid;
	void *my_entry;

	if( !getTypOid( PclassName, &oid, Pstatus ) ) return FALSE;
	INTERNAL_CHECK( Pstatus, "type read error in fillEmptyClass.");

	if( !readType( oid, &cat, Pstatus ) ) return FALSE;
	INTERNAL_CHECK( Pstatus, "type read error in fillEmptyClass.");

	setClassType( &cat.ClassType, User ) ;

	List SuperClasses( &cat.List_SuperClass, &l_type, &l_size, Pstatus );
	INTERNAL_CHECK( Pstatus, "can not create list" );
	List Attributes( &cat.List_Attributes,  &l_type,&l_size, Pstatus );
	INTERNAL_CHECK( Pstatus, "can not create list" );	
	

	if ( Pinherits != NULL ) { // there are some inherited classes 
/********************************
		// inherit from MoodsRoot first....
		getTypOid("MoodsRoot",&rootOid, Pstatus) ;

		if ( !(*Pstatus) ){
			SuperClasses.insertToList( &rootOid, Pstatus );
			INTERNAL_CHECK( Pstatus, "can not insert to list" );

			copyInheritedTypes( &rootOid, &Attributes, &attrOffset, Pstatus);
			INTERNAL_CHECK( Pstatus, "fail on inherits..");
		} else  printf( "NO MOODSROOT CLASS DEFINED\n");
*********************************/

		my_entry = Pinherits->getFirstEntry();

		while ( my_entry != NULL ) { // do others...
			getTypOid(((struct inherits *)my_entry)->cname,&InheritsOid,Pstatus);
			INTERNAL_CHECK( Pstatus, "can not get info on type");

			SuperClasses.insertToList(&InheritsOid, Pstatus);
			INTERNAL_CHECK( Pstatus, "can not insert to list");
			copyInheritedTypes( &InheritsOid, &Attributes, &attrOffset, Pstatus );
			INTERNAL_CHECK( Pstatus, "can not copy attributes of super classes");

			my_entry = Pinherits->getNextEntry();
		}

	} else { // no inherited class ...

		getTypOid("MoodsRoot", &rootOid, Pstatus);

		if ( !(*Pstatus) ) { // ok , there is a MoodsRoot entry... so copy..
			SuperClasses.insertToList( &rootOid, Pstatus );
			INTERNAL_CHECK( Pstatus, "can not insert to list");

			copyInheritedTypes( &rootOid, &Attributes, &attrOffset, Pstatus);
			INTERNAL_CHECK( Pstatus, "can not copy attributes of super classes");
		} else { printf( "NO MOODSTYPE CLASS\n" ) ; } ;

	}

	if ( Pmember != NULL ) {
		MoodsAttr( Pmember, &attrOffset, &Attributes, Pstatus );
		INTERNAL_CHECK( Pstatus , " error on creating attribute entries...");
	}
	cat.Size = attrOffset ;

	if( updateType( oid, cat ) ) return FALSE;

	SuperClasses.getListOid( &SCoid, Pstatus );
	INTERNAL_CHECK( Pstatus , "error getting superclass list oid" );

	linkToSuper( SCoid, oid );
	*Pstatus = 0 ;

	CreateHeader headerCreator;
	headerCreator.createheaderfile( PclassName, Pinherits, Pmember );

	return TRUE;
}


void MoodsTypes::printAllAtt( AttrList *inAtt )
{
	if( !inAtt ) return ;
	printf(" For the Attribute : \n");
	printf(" Name   : %s \n", inAtt->entry.AttributeName );
	printf(" Type   : %s \n", inAtt->entry.AttrTypeName );
	printf(" Offset : %d \n", inAtt->entry.AttributeOffset );
	printf(" Length : %d \n", inAtt->entry.AttributeLength );
	printf(" Cons.  : %c \n", inAtt->entry.AttributeConstructor );
	printf(" MEMber : %x \n", inAtt->entry.ClassMember );
	printf(" NEXT SUB \n ");
	printAllAtt( inAtt->nextsub );
	printf( " NEXT \n ");
	printAllAtt( inAtt->next );
	printf("-----------\n");
	
}


/*

struct ForwardBackward *MoodsTypes::getIndexRecord( char *name )
{
	static struct ForwardBackward fb;
	KEY key1, key2;
	SMCURSOR cursor;
	int eof, err;

	INVALIDATE_CURSOR( cursor );

	key1.valuePtr = ( void * )malloc( MAXSTRLEN * 2 + 1 ); 
	key2.valuePtr = ( void * )malloc( MAXSTRLEN * 2 + 1 );
	key1.length = key2.length =  MAXSTRLEN * 2 + 1;
	memcpy( key1.valuePtr, name, MAXSTRLEN * 2 + 1 );
	memcpy( key2.valuePtr, name, MAXSTRLEN * 2 + 1);
	err = sm_FetchInit( &bjoinindices, BufferGroup,&key1, SM_EQ, &key2, SM_EQ, &cursor );	
	if( err  || CURSOR_IS_INVALID( cursor ) ){
           printf( "Error in initializing the index for fetch, inside getIndexRecord:BJoinIndex\n");
	   free( key1.valuePtr );
	   free( key2.valuePtr );
	   return NULL;
	}

	err = sm_FetchNext( &cursor, NULL, &fb, &eof );
	if( err || eof ){
	   printf("Index entry not found\n" );
	   free( key1.valuePtr );
	   free( key2.valuePtr );
	   return NULL;
	}

	return &fb;
}

int MoodsTypes::insertIndexName( char *name, struct ForwardBackward *fb )
{
	KEY key;
	int err;

	key.valuePtr = ( void * )malloc( MAXSTRLEN * 3 + 8 );
        key.length =  MAXSTRLEN * 3 + 8;	
	memcpy( key.valuePtr, name, MAXSTRLEN * 3 + 8 );

	err = sm_InsertEntry(&bjoinindices, BufferGroup, &key, fb );
	if( err ){
		printf( "Cannot insert the key into the index\n" );
		return 0;
	}

	return 1;
}

*/
