#include <mood_catalog.h>
#include <mood_error.h>
#include <userreq.h>
#include <keywords.h>
#include "linklist.h"

//      PDbname IN .   -> name of the interested database .....
//      PCfid   OUT.   -> associated catalog file identifier...
//      PStatus OUT.   -> operation success if 0 else fail.....

Database::Database()
{
	strcpy( dbname, "$$INVALIDDB$$");
}

int Database::inUse()
{
	if( !strcmp( dbname, "$$INVALIDDB$$") ) return FALSE;
	return TRUE;
}

void Database::setUnused()
{
	strcpy( dbname, "$$INVALIDDB$$");
}
                          
int Database::deleteDatabase(  char *dbName ) 
{
        int 		err;
        OID 		oid;
        USERDESC 	*UserDesc;
        struct DBrecord DBrec;
	char		command[120];

        if( !ms_LocateObject( &DBFile, CHAR, dbName, (int)((long)DBrec.dbname-(long)&DBrec), &oid ) )
		return FALSE;

	if( (OID_IS_INVALID( oid ) )){
		catalogError.setError( RUNTIME_ERROR,DB_NOT_EXIST, dbName);
                return FALSE;
        }

        mscat_ReadObject( oid, "Error reading object in Database::use" );
	memcpy( &DBrec, UserDesc->basePtr, sizeof( DBrec ) );
	mscat_ReleaseObject("Error in releasing the object");

	/* delete the associated files */
        mscat_DestroyFile( DBrec.CatalogId, "Cannot Destroy file" );
        mscat_DestroyFile( DBrec.AttributeId, "Cannot Destroy file" );
        mscat_DestroyFile( DBrec.FunctionId, "Cannot Destroy file" );
        mscat_DestroyFile( DBrec.SequenceId, "Cannot Destroy file" );
	mscat_DestroyFile( DBrec.Unsizedfile,"can not destroy Unsized file");
	mscat_DestroyIndex(DBrec.RefIID, "can not ref index" ); 

        //deleteBJoinIndices( &DBrec.bjoinindices );

	/* delete the object from the file */
	mscat_DestroyObject( oid, "Cannot destroy object" );

	/* set the no database in use flag */
	if( strcmp( DBrec.dbname, dbName ) == 0 ) noDBInUse = 1;

	sprintf( command, "rm  -r %s/DATABASES/%s", MoodHome, dbName );
	//printf(" Removing : %s\n", command );
	system( command );

	return TRUE;
}

int Database::useDatabase(  char *dbName )
{
	int 		err;
	OID 		oid;
	USERDESC 	*UserDesc;	
	struct DBrecord DBrec;

	if( !ms_LocateObject( &DBFile, CHAR, dbName, (int)((long)DBrec.dbname-(long)&DBrec), &oid ) ) return FALSE;

	if( (OID_IS_INVALID(oid))){
		catalogError.setError( RUNTIME_ERROR, DB_NOT_EXIST, dbName);
		return FALSE;
	}	

	mscat_ReadObject(oid, "Error in reading object in Database::use" );

	memcpy( &DBrec, UserDesc->basePtr, sizeof( DBrec ) );

	mscat_ReleaseObject("Error in releasing the object inside Database:use");

	memcpy( &::DBrec, &DBrec, sizeof( DBrec ) );
	memcpy( &CatalogID, &DBrec.CatalogId, S_FID );
	memcpy( &UnsizedFID, &DBrec.Unsizedfile, S_FID );
	memcpy( &RefIID, &DBrec.RefIID, sizeof( IID ) );

	if( noDBInUse == 1 ) noDBInUse = 0;

	sprintf( DatabaseHome, "%s/DATABASES/%s", MoodHome, dbName );
	//printf( "DatabaseHome : %s\n", DatabaseHome );

	return TRUE;
}


int Database::createType( MoodsTypes *moods, char *typeName, int typeSize, char classType, OID *attList, OID *superList )
{
        Catalog         basic_types;
        OID             tmpOid;
	CatBOOLEAN 	tmpStatus=0;

        strcpy( basic_types.TypeName, typeName);
        basic_types.Size   = typeSize;
        basic_types.ClassType = classType;
        memcpy( &basic_types.List_Attributes, attList, S_OID );
        memcpy( &basic_types.List_SuperClass, superList, S_OID );
        moods->writeType( basic_types, &tmpOid, &tmpStatus );
        //memcpy( &Type_Store[basic_count++], &tmpOid, S_OID );

        if ( tmpStatus ){
		 printf("creation of %s type failed\n" , typeName);
		 return 0;
	}
        //printf(" %s created....\n", typeName) ;
        return TRUE;
}


int Database::initDB( )
{
  // create basic types block
        MoodsTypes moods;
        Catalog basic_types ;
	memberNode member;
	CatBOOLEAN status=0;

	memset( &nullOid, 0, S_OID );

	// DO NOT CHANGE THE ORDER OF THE FOLLOWING STATEMENTS.
        // creation of basic types
        if( !createType( &moods, "INTEGER", sizeof(int),   'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "FLOAT",   sizeof(float), 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "BOOLEAN", sizeof(char) , 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "CHAR",    sizeof(char) , 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "STRING",  sizeof(char) , 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "OID",  sizeof(OID) , 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "IID",  sizeof(IID) , 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "FID",  sizeof(FID) , 'B', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "TUPLE",   0,  'T', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "SET",     S_OID ,  'S', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "LIST",    S_OID ,  'L', &nullOid, &nullOid ) ) return 0;
        if( !createType( &moods, "REF",     S_OID ,  'R', &nullOid, &nullOid ) ) return 0;
        //***** ALL BASIC TYPES ARE CREATED AT THE MOMENT **********
	
	member.type = 6;
	member.size = 0;
	strcpy( member.typeName, "TUPLE" );
	strcpy(member.memberName, " " );
	member.attributeList = NULL;
	member.subAttributes = new memberNode;
	member.subAttributes->type = 1;
	member.subAttributes->size = 0;
	strcpy( member.subAttributes->typeName, "INTEGER" );
	strcpy( member.subAttributes->memberName, "typeId" );
	member.subAttributes->attributeList = NULL;
	member.subAttributes->subAttributes = NULL;
	if( !moods.addType( "MoodsRoot", NULL, &member, 1, &status )){
		delete member.subAttributes;
		return FALSE;
	}	
	delete member.subAttributes;
	if( status ) return FALSE; 

	return TRUE;
}

void Database::initSeq( SeqTemp *seq, char *dbName )
{
	strcpy( seq->seqname, "__" );
	strcat( seq->seqname, dbName );
	strcat( seq->seqname, "__" );
	seq->minval = 0;
	seq->maxval = 10000;
	seq->initial = 0;
	seq->cyclic = 'N';
	seq->increment = 1;
	seq->curval = 0;		
}

int Database::createDatabase( char *dbName )
{
	int 		err,i;
	OID 		oid;
	struct DBrecord DBrecord;
	SeqTemp  	seq;
	char		command[120];

	if( !ms_LocateObject( &DBFile, CHAR, dbName, (int)((long)DBrecord.dbname-(long)&DBrecord), &oid ) )
		return FALSE;

	if( !(OID_IS_INVALID( oid )) ){
		catalogError.setError( RUNTIME_ERROR, DB_ALR_EXIST, dbName );
		return FALSE;

	}

	strcpy( DBrecord.dbname, dbName );

	/* create the related files and index */ 
	mscat_CreateFile( DBrecord.CatalogId,"Error in creating the file inside Database"); 
	mscat_CreateFile(DBrecord.AttributeId,"Error in creating the file inside Database");
	mscat_CreateFile(DBrecord.FunctionId,"Error in creating the file inside Database");
	mscat_CreateFile(DBrecord.SequenceId,"Error in creating the file inside Database");
	mscat_CreateFile(DBrecord.Unsizedfile,"Error in creating the file inside Database");

	err = sm_CreateIndex(VolumeId,BufferGroup,SM_BTREENDX,SM_string,15,2*sizeof(int),TRUE,&DBrecord.RefIID);
	ERROR_HANDLER("can not create index");

	/*err = sm_CreateIndex( VolumeId, BufferGroup, SM_HASHNDX, SM_string, 3 * MAXSTRLEN + 8, sizeof( IID ), FALSE, &DBrecord.bjoinindices );
	sm_check( err, "Error in creating index inside Database\n");*/
	
	/* write the record into the root file */
	mscat_CreateObject(DBFile, sizeof(DBrecord), &DBrecord, &oid, "Error in creating the DBrecord inside Database");
	initSeq( &seq, dbName );
	mscat_CreateObject(DBrecord.SequenceId, sizeof(seq), &seq, &oid, "Error in creating the sequence object inside Database");

	/* make the created database the current database */
	memcpy( &DBrec, &DBrecord, sizeof( DBrecord ) );

	if( initDB() ){

		FILE	*dbHeader, *clsHeader, *msTypeDefs;
		char	fileName[120];

		sprintf( DatabaseHome, "%s/DATABASES/%s", MoodHome, dbName );
		//printf( "DatabaseHome : %s\n", DatabaseHome );
	
		sprintf( command, "mkdir %s", DatabaseHome );
		system( command );
		strcat( command, "/shobj");
		system( command );
		//printf( "Creating : %s\n", command );

		sprintf( fileName, "%s/database.h", DatabaseHome  );
		dbHeader = fopen( fileName, "a" );

		sprintf( fileName, "%s/classes.h", DatabaseHome  );
		clsHeader = fopen( fileName, "a" );

		fprintf( clsHeader, "class MoodsRoot;\n");

		fprintf( dbHeader, "#include <sm_client.h>\n"); 
		//fprintf( dbHeader, "#define set_type  OID\n"); 
		//fprintf( dbHeader, "#define list_type OID\n"); 
		//fprintf( dbHeader, "#define ref_type  OID\n"); 
		fprintf( dbHeader, "#define integer int\n");
		fprintf( dbHeader, "#define string char *\n");
		fprintf( dbHeader, "typedef char boolean;\n\n");
		fprintf( dbHeader, "#include <ms_typedefs.h>\n\n" );
		fprintf( dbHeader, "#include <classes.h>\n\n" );
		fprintf( dbHeader, "\nclass MoodsRoot\n{\npublic :\n	int	typeId;\n};\n");

		fclose( dbHeader );
		fclose( clsHeader );

	        sprintf( fileName, "%s/ms_typedefs.h", DatabaseHome );
		msTypeDefs = fopen( fileName, "a");
		fclose( msTypeDefs );

                memcpy( &::DBrec, &DBrec, sizeof( DBrec ) );
                memcpy( &CatalogID, &DBrec.CatalogId, S_FID );
                memcpy( &UnsizedFID, &DBrec.Unsizedfile, S_FID );
                memcpy( &RefIID, &DBrec.RefIID, sizeof( IID ) );

		
		if( noDBInUse == 1 ) noDBInUse = 0;
		return TRUE;
	}
	
	return FALSE;
}

int Database::listDatabases( LinkedList	*dbList /* out */ )
{
	int 		err,i;
	BOOL 		eof;
	OID 		oid, oid1;
	OBJHDR 		ObjectHeader;
	struct DBrecord DBrec;
	USERDESC 	*UserDesc;
	char		*dbName;

	printf("LIST OF DATABASES\n");
	printf("-----------------\n");

	mscat_GetFirstOid(DBFile, oid, "Error in fetching the first oid inside Database");
	while( !eof ){
		mscat_ReadObject( oid,"Error in reading the object inside Database");
		memcpy( &DBrec, UserDesc->basePtr, sizeof( DBrec ) );
		dbName = (char *) malloc( MAXSTRLEN ) ;
		strcpy( dbName, DBrec.dbname );
		dbList->insert( STRCONS, ( void * ) dbName );
		mscat_ReleaseObject("Error in releasing the object inside Database");
		mscat_GetNextOid( oid, oid1, "Error in fetching the next oid inside Database");
		memcpy( &oid, &oid1, S_OID );
	}

	return TRUE;
}
