//#include <strings.h>
#include <string.h>
#include "mood_catdef.h"
#include "mood_catalog.h"
#include "keywords.h"
#include "lists.h"
#include "linklist.h"
#include "sign.h"
 
extern int User;

int MoodsTypes::searchSign(char *Pclsname, char *f_name, char **argTypes,
			   int arg_count, CatBOOLEAN *found, FunctionType *out_ft, 
			   int *fcn_offset, int first_cls_to_search) 
{
	FunctionType funcdata;
	Catalog      catdata,internType;
	int          err,l_typ,l_size,m_typ,m_size, indx;
	OID          typeoid,funcoid;
	CatBOOLEAN   status;
        char         fcn_call_str[MAXSTRLEN], Psign[2*MAXSTRLEN];
        int i, currentOffset;

        *fcn_offset=0;

	*found = FALSE;
	if( Pclsname ) {
           // construct the function call prototype 
           strcpy(fcn_call_str, Pclsname);
           strcat(fcn_call_str, "::");
           strcat(fcn_call_str, f_name);
        }
        else strcpy(fcn_call_str, f_name);
        strcat(fcn_call_str, "(");
        for (i=0; i<arg_count; i++) {
            strcat(fcn_call_str, argTypes[i]);
            if (i<(arg_count-1)) strcat(fcn_call_str, ",");
        }
        strcat(fcn_call_str, ")");

        FindSignature newSign(fcn_call_str); 

        //Psign=(char *)malloc(MAXSTRLEN);
	//fprintf(myalloc, "%p char\n", Psign );
        strcpy(Psign, newSign.Signature);
 

	if( !getTypOid( Pclsname, &typeoid, &status)) return FALSE;
	INTERNAL_CHECK( &status, "can not find type entry");
 
	if( !readType( typeoid, &catdata, &status)) return FALSE;
	INTERNAL_CHECK( &status, "can not read type entry");
 
	List funclist( &catdata.List_Function, &l_typ, &l_size, &status );
	INTERNAL_CHECK( &status, "can not construct function list");
 
	for( indx=0 ; indx < l_size ; indx++ ) 
	{
		// compare signatures of this class's functions...
		funclist.getElement(  &funcoid, indx, &status );
		INTERNAL_CHECK( &status, "can not receive element from func list");
 
		readFunc( funcoid, &funcdata, &status);
		INTERNAL_CHECK( &status , " can not read function data");
 
		if ( !strcmp( funcdata.signature, Psign ) ) {
			memcpy( out_ft, &funcdata, sizeof( FunctionType ) );
			*found = TRUE;
			return TRUE;
		}
	}

	List superCls( &catdata.List_SuperClass, &m_typ, &m_size, &status) ;

	currentOffset = 0;
 
	for ( indx = 0; indx < m_size ; indx++ ) 
	{
		int retOffset = 0;

		superCls.getElement( &typeoid, indx, &status );

		INTERNAL_CHECK( &status, "internal-error can not receive element from list");
 
		if( !readType( typeoid, &internType, &status )) return FALSE;
		INTERNAL_CHECK( &status, "imkansiz-internal-error");

		if(!searchSign(internType.TypeName, f_name, argTypes, arg_count, found, out_ft, &retOffset, 0)) 
			return FALSE;

		if( *found == TRUE )  {
			*fcn_offset = currentOffset + retOffset;
			return TRUE;
		}
		else currentOffset += internType.Size ;

	}
 
	return TRUE;
}

int MoodsTypes::search_signature( char *Psign, CatBOOLEAN *found ) 
{
	OID funcid, nextid ;
	FunctionType funcintern;
	int err;
	BOOL eof;

	*found = FALSE; // set as not found

        mscat_GetFirstOid( FunctionId, funcid, "can't getting first oid" );

	while( !eof )
	{
		mscat_ReadObject( funcid, "error reading function entry" );
		memcpy( &funcintern, UserDesc->basePtr, sizeof(FunctionType) );
		if ( !strcmp(funcintern.signature, Psign) ) {
			*found = TRUE;
			return TRUE;
		}

		mscat_ReleaseObject( "on release object" );
		mscat_GetNextOid(funcid, nextid, "on getting next function's oid" );
		memcpy( &funcid , &nextid, sizeof (OID) ) ;
	}

	return TRUE;
} // END of search_signature ...


int MoodsTypes::deleteFunction(char *Pclsname, char *Psign,CatBOOLEAN *status, FunctionType *ft)
{
        FunctionType funcdata;
        Catalog      catdata;
        int          err,l_typ,l_size,indx,found=0;
        OID          typeoid,funcoid;
        //CatBOOLEAN   stat=0;

        if( !getTypOid( Pclsname, &typeoid, status)) return FALSE;
        CAT_CHECK( status, TYPE_NOT_EXIST, Pclsname );

        if( !readType( typeoid, &catdata, status)) return FALSE;
        INTERNAL_CHECK( status, "can not read type entry");

        List funclist( &catdata.List_Function, &l_typ, &l_size, status );
        INTERNAL_CHECK( status, "can not construct function list");

        for( indx=0 ; indx < l_size ; indx++ ) {
             // compare signatures of this class's functions...
             funclist.getElement(  &funcoid, indx, status );
             INTERNAL_CHECK( status, "can not receive element from funclist");

             if( !readFunc( funcoid, &funcdata, status)) return FALSE;
             INTERNAL_CHECK( status , " can not read function data");

             if ( !strcmp( funcdata.signature, Psign ) ) {
		found=1;
		break;
	     }
        }

        if(found) {
	     *ft = funcdata;
             mscat_DestroyObject(funcoid, "can not delete attribute");
             err=funclist.deleteFromList(indx, indx, status );
             INTERNAL_CHECK(status,"can not delete from list");
             *status=TRUE;
        }
        else {
	      catalogError.setError( RUNTIME_ERROR, FUNC_NOT_EXIST, "");
	      return FALSE;
	}

        return TRUE;
}


int MoodsTypes::addFunc( FunctionType Pfunc, CatBOOLEAN *Pstatus) 
{
   OID 		funcOid, typeOid, nullOid, listsOid;
   int 		err;
   Catalog	typeinfo;
   CatBOOLEAN   isTypeNotExist, stat;
   TYPEID	l_typ;
   SIZTYP	l_size;

   memset( &nullOid, 0, S_OID );

   if( !findType( Pfunc.className,  &isTypeNotExist ) ) return FALSE;

   if ( isTypeNotExist == 0 ) {

      // class exists ...
      if( !getTypOid( Pfunc.className, &typeOid, Pstatus )) return FALSE;

      if( !readType(typeOid, &typeinfo, Pstatus)) return FALSE;
      INTERNAL_CHECK( Pstatus, "can not read type info in addFunc");

      // start search of function swignature...
      if( !search_signature( Pfunc.signature, &stat )) return FALSE;

      if ( !stat ) {

         // function decleration does not exist...
         // insert function info & put Oid to function list of type..
         mscat_CreateObject(FunctionId,sizeof(FunctionType),&Pfunc,&funcOid, "error occured while creating function entry");

         if( !memcmp( &typeinfo.List_Function, &nullOid, sizeof(OID) )) {

            // if no functions inserted to list before.. create new one...
            List funcList( &CatalogId, NEAR_FIRST_PHYSICAL, NULL, MAXFUNC, Pstatus);
            INTERNAL_CHECK( Pstatus, "list construction");

            // we should update catalog entry....
            funcList.insertToList( &funcOid, Pstatus );
            INTERNAL_CHECK( Pstatus, "insertion to the list");

            funcList.getListOid( &listsOid, Pstatus );
            INTERNAL_CHECK( Pstatus, "getting list oid");

            memcpy ( &typeinfo.List_Function, &listsOid, sizeof(OID)) ;

            // I should overwrite current catalog entry...
            mscat_ReadObject( typeOid, "reading type ");
            mscat_WriteObject( sizeof(typeinfo), &typeinfo, "overwriting type" );

            // ok. function entry written & added to the catalog info of class..

         } else { // there is a function list in catalog entry...

            // reading function  list ...
            List funcList( &typeinfo.List_Function, &l_typ, &l_size, Pstatus );
            INTERNAL_CHECK( Pstatus, "list construction");

            // update list ( insert new func info oid ) ..
            funcList.insertToList( &funcOid, Pstatus );
            INTERNAL_CHECK( Pstatus, "insertion to list");
         } 
 
      } else {
	char	msg[120];
	sprintf( msg, "%s-%s", Pfunc.className, Pfunc.funcName );
	catalogError.setError( RUNTIME_ERROR, FUNC_ALR_EXIST, msg );
	return  FALSE;
      }
	
   } else {
	catalogError.setError( RUNTIME_ERROR, TYPE_NOT_EXIST, Pfunc.className );
	return FALSE;
   }

   return TRUE;
} // END of addFunc.........




MoodsTypes::readFunc( OID PfuncOid, FunctionType *Pfunc, CatBOOLEAN *Pstatus)
{
        int err;
 
        *Pstatus = 1;
        mscat_ReadObject( PfuncOid, "reading function object");
        memcpy( Pfunc, UserDesc->basePtr, sizeof( FunctionType ) );
        mscat_ReleaseObject("on release function object" );
        *Pstatus = 0 ;
        return TRUE;
}


int MoodsTypes::signCheck(char *Pclsname, char *Psign)
{
        FunctionType funcdata;
        Catalog      catdata;
        int          err,l_typ,l_size,indx;
        OID          typeoid,funcoid;
        CatBOOLEAN   status=0;
 
        if( !getTypOid( Pclsname, &typeoid, &status)) return FALSE;
        CAT_CHECK( &status, TYPE_NOT_EXIST, Pclsname );
 
        if( !readType( typeoid, &catdata, &status)) return FALSE;
        INTERNAL_CHECK( &status, "can not read type entry");
 
        List funclist( &catdata.List_Function, &l_typ, &l_size, &status );
        INTERNAL_CHECK( &status, "can not construct function list");
 
        for( indx=0 ; indx < l_size ; indx++ ) {
             // compare signatures of this class's functions...
             funclist.getElement(  &funcoid, indx, &status );
             INTERNAL_CHECK( &status, "can not receive element from func list");
 
             if( !readFunc( funcoid, &funcdata, &status)) return FALSE;
             INTERNAL_CHECK( &status , " can not read function data");
 
             if ( !strcmp( funcdata.signature, Psign ) ) return 0;
        }
        return TRUE;
}

int MoodsTypes::listFunction( char *Pclsname, LinkedList *fList )
{

        FunctionType *funcdata;
        Catalog      catdata;
        int          err,l_typ,l_size,indx;
        OID          typeoid,funcoid;
        CatBOOLEAN   status=0;
 
        if( !getTypOid( Pclsname, &typeoid, &status)) return FALSE;
        CAT_CHECK( &status, TYPE_NOT_EXIST, Pclsname );
 
        if( !readType( typeoid, &catdata, &status)) return FALSE;
        INTERNAL_CHECK( &status, "can not read type entry");
 
        List funclist( &catdata.List_Function, &l_typ, &l_size, &status );
        INTERNAL_CHECK( &status, "can not construct function list");
 
        for( indx=0 ; indx < l_size ; indx++ ) {

             // compare signatures of this class's functions...
             funclist.getElement(  &funcoid, indx, &status );
             INTERNAL_CHECK( &status, "can not receive element from func list");

	     funcdata = new FunctionType();
 
             if( !readFunc( funcoid, funcdata, &status)) return FALSE;
             INTERNAL_CHECK( &status , " can not read function data");

	     fList->insert( FUNCTION_TYPE_ITEM, (void *) funcdata );

        }

        return TRUE;
}


int MoodsTypes::signCheck(char *Pclsname, char *Psign, FunctionType *Pfun, CatBOOLEAN
 *Pstatus)
{
        Catalog      catdata;
        int          err,l_typ,l_size,indx;
        OID          typeoid,funcoid;
 
        if( !getTypOid( Pclsname, &typeoid, Pstatus)) return FALSE;
        CAT_CHECK( Pstatus, TYPE_NOT_EXIST, Pclsname );
 
        if( !readType( typeoid, &catdata, Pstatus)) return FALSE;
        CAT_CHECK( Pstatus, TYPE_NOT_EXIST, "");
 
        List funclist( &catdata.List_Function, &l_typ, &l_size, Pstatus );
        INTERNAL_CHECK( Pstatus, "can not construct function list");
 
        for( indx=0 ; indx < l_size ; indx++ ) {
 
             // compare signatures of this class's functions...
 
             funclist.getElement(  &funcoid, indx, Pstatus );
             INTERNAL_CHECK( Pstatus, "can not receive element from func list");
 
             if( !readFunc( funcoid, Pfun, Pstatus)) return FALSE;
             INTERNAL_CHECK( Pstatus , " can not read function data");
 
             if ( !strcmp( Pfun->signature, Psign ) ) {
                  *Pstatus = 0;
                  return TRUE;
             }
        }
 
        *Pstatus = 1 ;
        return TRUE;
}


int MoodsTypes::getFuncBySign(char *Pclsname, char *Psign, FunctionType *Pfunc, CatBOOLEAN *Pstatus )
{
     signCheck( Pclsname, Psign, Pfunc, Pstatus);
     return TRUE;
}

int MoodsTypes::searchFuncName( char *PClsName, char *PfuncName,
                     FunctionType *Pfunc, CatBOOLEAN *Pstatus)
{
   OID  typeOid,funcOid;
   Catalog typeEntry,internType;
   int  l_typ, l_size, m_typ, m_size, indx;
 
   if( !getTypOid( PClsName, &typeOid, Pstatus)) return FALSE;
   INTERNAL_CHECK( Pstatus, "class of function non-existant" );
 
   if( !readType( typeOid, &typeEntry, Pstatus )) return FALSE;
   INTERNAL_CHECK( Pstatus, "internal-error ## fatal");
 
   List funcList( &typeEntry.List_Function, &l_typ, &l_size, Pstatus );
   INTERNAL_CHECK( Pstatus, "can not construct function list ");
 
   for ( indx=0; indx < l_size ; indx++ ) {
      funcList.getElement( &funcOid, indx, Pstatus );
      INTERNAL_CHECK( Pstatus, "internal-error can not receive element from list");
 
      if( !readFunc( funcOid, Pfunc, Pstatus )) return FALSE;
      INTERNAL_CHECK( Pstatus, "imkansiz-internal-error");
 
      if ( !strcmp( PfuncName, Pfunc->funcName ) ) {
         Pstatus = 0 ;
         return TRUE;
      }
   }
 
   List superCls( &typeEntry.List_SuperClass, &m_typ, &m_size, Pstatus) ;
 
   for ( indx = 0; indx < m_size ; indx++ ) {
      superCls.getElement( &typeOid, indx, Pstatus );
      INTERNAL_CHECK( Pstatus, "internal-error can not receive element from list");
 
      if( !readType( typeOid, &internType, Pstatus )) return FALSE;
      INTERNAL_CHECK( Pstatus, "imkansiz-internal-error");
 
      searchFuncName( internType.TypeName, PfuncName, Pfunc, Pstatus );
      if ( ! (*Pstatus) ) return TRUE;
   }
   *Pstatus = 1;
   return TRUE;
// update this routine to get the offset of real start address
// of the class attributes in near future pls. ask to mehmet altinel.
}

