#include <initialize.h>
extern int User;


createType( MoodsTypes moods, char *typeName, int typeSize, char classType, OID *attList, OID *superList, CatBOOLEAN *tmpStatus)
{
	Catalog 	basic_types; 
	OID 		tmpOid;

        strcpy( basic_types.TypeName, typeName);
        basic_types.Size   = typeSize;
        basic_types.ClassType = classType;
        memcpy( &basic_types.List_Attributes, attList, sizeof( OID ) );
        memcpy( &basic_types.List_SuperClass, superList, sizeof( OID ) );
        moods.writeType( basic_types, &tmpOid, tmpStatus );
        memcpy( &Type_Store[basic_count++], &tmpOid, sizeof( OID ) );

        if ( *tmpStatus ) cout << "creation of", typeName," type failed\n" ;
        else cout << typeName, " created....\n" ;
        *tmpStatus = 0 ;
}

void init_db(CatBOOLEAN *tmpStatus) 
{ // init_db block
	FID 	tmpFid, CatalogFile;
	OID 	tmpOid;
	OID 	*nullOid;

	// fill nullOid with all 0 
	nullOid = (OID *)malloc ( sizeof (OID) ) ;
	memset( (char *)nullOid , 0 , sizeof( OID ) );


// create a database  & delete current db. *********
{ // delete database block
	Database  current(DATABASE, &tmpFid  , tmpStatus);

	if ( *tmpStatus == 0 ) {
		MoodsTypes old(tmpFid);
		old.deleteFiles();
		current.deleteDB( tmpStatus ); 
	}
 
	if ( *tmpStatus )  cout << "database could not be deleted\n" ;
	else cout << "current database is destroyed\n" ;

	*tmpStatus = 0 ;
} // end of delete database block



{ // create database block 
	int dsize;
	Database  newdb(DATABASE, &tmpFid , tmpStatus );

	if (*tmpStatus) cout << "error  creating database\n" ;
	else cout << "new database is created..\n" ;

	cout << "initialize\n" ;
	cout << "fid.page=" << tmpFid.pid.page << "volid=" << tmpFid.pid.volid ;
	cout << "\n" ;

	dsize = sizeof(FID); 
	sm_GetRootEntry(VolumeId, DATABASE, &tmpFid, &dsize); 

	cout << "reread of root entry\n" ;
	cout << "fid.page=" << tmpFid.pid.page << "volid=" << tmpFid.pid.volid ;
	cout << "\n" ;

	// copy database (moodstypes (catalog) ) file id.
	memcpy( &CatalogFile, &tmpFid, sizeof( FID ) );
	*tmpStatus = 0 ;
} // end of create database block

{ // create sequence block
	
	Sequence newseq;
	if( !newseq.initSequence( SEQNAME, SEQ_INITAL, SEQ_MIN , SEQ_MAX, SEQ_CYC, SEQ_INC, tmpStatus))
		return FALSE;
	cout << "sequence created\n" ;
	// new database is created
} // end of create sequence block



{  // create basic types block
	MoodsTypes moods(CatalogFile) ;
        *tmpStatus = 0 ; 
  
	Catalog basic_types ; 
	// creation of basic types
	createType( moods, "INTEGER", sizeof(int),   'B', nullOid, nullOid, tmpStatus );
	createType( moods, "FLOAT",   sizeof(float), 'B', nullOid, nullOid, tmpStatus );
	createType( moods, "BOOLEAN", sizeof(char) , 'B', nullOid, nullOid, tmpStatus );
	createType( moods, "CHAR",    sizeof(char) , 'B', nullOid, nullOid, tmpStatus );
	createType( moods, "STRING",  sizeof(char) , 'B', nullOid, nullOid, tmpStatus );
	createType( moods, "OID",     sizeof(OID) ,  'B', nullOid, nullOid, tmpStatus );
	createType( moods, "IID",     sizeof(IID) ,  'B', nullOid, nullOid, tmpStatus );
	createType( moods, "FID",     sizeof(FID) ,  'B', nullOid, nullOid, tmpStatus );
	createType( moods, "TUPLE",   sizeof(OID) ,  'T', nullOid, nullOid, tmpStatus );
	createType( moods, "SET",     sizeof(OID),   'S', nullOid, nullOid, tmpStatus );
	createType( moods, "LIST",    sizeof(OID),   'L', nullOid, nullOid, tmpStatus );
	createType( moods, "REF",     sizeof(OID),   'R', nullOid, nullOid, tmpStatus );
	//***** ALL BASIC TYPES ARE CREATED AT THE MOMENT **********
} // end of create basic type block

	// Burada comment out edilmis MoodsRoot creation'i vardi --- CERTAN
	// Zannediyorum MoodsRoot elle create ediliyor !!!!!!!!

	cout << "database is initialized\n";

} // end of init_db block
