/**********************************************************************
* MoodView ,The Graphical User Interface To MOODS
* Copyright (c) 1994 Scientific and Technical Research Council of Turkiye
*                    Software Research and Development Center, Ankara
* All Rights Reserved.
*
* Permission to use, copy, modify and distribute this software and its
* documentation is hereby granted, provided that both the copyright
* notice and this permission notice appear in all copies of the
* software, derivative works or modified versions, and any portions
* thereof, and that both notices appear in supporting documentation.
*
* THE SOFTWARE RESEARCH AND DEVELOPMENT CENTER ALLOWS FREE USE OF THIS
* SOFTWARE IN ITS "AS IS" CONDITION.
* THE CENTER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
* WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
*
* The MOODS Project Group requests users of this software to return
* any improvements or extensions that they make to:
*
*   MOODS Project Group
*   TUBITAK Software Research and Development Center
*   Department of Computer Engineering
*   Middle East Technical University
*   Ankara, 06531
*
*        or budak@karakoy.srdc.metu.edu.tr
*
* In addition, the MOODS Project Group requests that users grant the
* Software Research and Development Center rights to redistribute these
* changes.
**********************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "chb.h"

#define VERTSIZE (strlen(tree[i][orders[j]].name)*7+40)

extern vertex **tree;
int           i,j;


/*-------------------------------------------------------------
**  coord2
*------------------------------------------------------------*/
void coord2(vertex *a,unsigned id,int *x,int *y)
{
   int i=0;

   for(;a[i].id != id;i++);
   
   *x=a[i].x;
   *y=a[i].y;
}


/*-------------------------------------------------------------
**  coorAvg
*------------------------------------------------------------*/
void  coorAvg(vertex *a,unsigned t,int *x)
{
      int i,t1=0;
      *x=0;

      for(i=0;i<levelLength(a);i++)
	if(intchr(a[i].child,t,a[i].no_of_child))
	 (*x)+=a[i].x,t1++;
      (*x)/=t1;
}


/*-------------------------------------------------------------
** posCompare
*------------------------------------------------------------*/
int posCompare(void *a,void *b)
{
   unsigned *x=(unsigned *)a;
   unsigned *y=(unsigned *)b;
   unsigned conX=tree[i][*x].no_of_parent;
   unsigned conY=tree[i][*y].no_of_parent;

   if(!strcmp(tree[i][*x].name,"du") && !strcmp(tree[i][*y].name,"du"))
      return(0);
   if(!strcmp(tree[i][*x].name,"du"))
      return(-1);

   if(conY==conX)
      return(0);
   if(conY>conX)
      return(1);
   return(-1);
}

/*-------------------------------------------------------------
** posCompare2 
*------------------------------------------------------------*/
int posCompare2(void *a,void *b)
{
   unsigned *x=(unsigned *)a;
   unsigned *y=(unsigned *)b;
   unsigned conX=tree[i][*x].no_of_parent;
   unsigned conY=tree[i][*y].no_of_parent;

   if(!strcmp(tree[i][*x].name,"du") && !strcmp(tree[i][*y].name,"du"))
      return(0);
   if(!strcmp(tree[i][*x].name,"du"))
      return(1);

   if(conY==conX)
      return(0);
   if(conY>conX)
      return(-1);
   return(1);
}

/*-------------------------------------------------------------
** position 
*------------------------------------------------------------*/
void position()
{
    int x,y,t1,vert,vmax=0,levlen[50];
    unsigned t,dummy1;
    unsigned * orders;
    
    for(i=0;tree[i][0].id;i++)
    { 
     for(vert=0,j=0;tree[i][j].id;j++){
	  vert+=strlen(tree[i][j].name)*7+50;
      }
     levlen[i] = vert;
     vmax=vmax>vert ? vmax:vert; 
   } 

 for(i=0;tree[i][0].id;i++)
    {
     vert = (vmax - levlen[i])/2 + 100;
     for(j=0;tree[i][j].id;j++){
          tree[i][j].y = i*100+15;
          tree[i][j].x = vert;
          vert+=strlen(tree[i][j].name)*7+50;
      }
     vmax=vmax>vert ? vmax:vert; 
   }
}
