#ifndef __MOOD_ALG_H
#define __MOOD_ALG_H

#include "dbi.h"
#include "dld.h"

typedef union {
    struct {
       int attr_len;
       int attr_offset;
    } Attr_Inp;
    struct {
       class ExecStruct *Args[15];
       Params *ParBuf;
       Function *FcnInfo;
       int argnum;
       int offset;
       char Fname[MAX_ATTR_NAME_LEN];
    } Fcn_Inp;
} Exec_Arg;

class ExecStruct {
  public :
    ExecStruct(void) {
         Left = NULL;
         Right = NULL;
         First = 0;
         ExecRight = 1;
         method = 0;
         Result = (char*) malloc(sizeof(CONSTANT));
    }
    ~ExecStruct(void) {
         free(Result);
         if (method) {
            delete Op_Inp.Fcn_Inp.ParBuf;
            delete Op_Inp.Fcn_Inp.FcnInfo;
         }
    }
    void (*ExecFunc)(ExecStruct *);
    Exec_Arg Op_Inp;
    char First, ExecRight;
    int operand_type;
    char method;
    ExecStruct *Left;
    ExecStruct *Right;
    char *Result;
};

typedef JOIN_ARG  EXPR_TYPE;

typedef struct {
    int AttrIndx;
    BULK_SCHEMA *Schema;
} MatArg;

#endif //__MOOD_ALG_H
