#ifndef __OPT_DEFS_H
#define __OPT_DEFS_H
/* 
* Volcano Optimizer Generator
* ===========================
*  
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/opt_defs.h,v 1.7 92/11/18 01:32:46 bill Exp Locker: bill $
*  
*/

#define OKAY		0

#if (!defined(FALSE) || !defined(TRUE))
#define FALSE 		0
#define TRUE 		!FALSE	
#endif

typedef enum {TRACE_ON, TRACE_OFF} TRACE ;

typedef enum {COPY, NO_COPY} COPY_VALUE ; 

typedef enum {GREATER_THAN=0, LESS_THAN=1, EQUAL_TO=2,
              GREATER_THAN_OR_EQUAL_TO=3, LESS_THAN_OR_EQUAL_TO=4,
              NOT_EQUAL_TO=5, COMPARE_NOT_SET=6} COMPARE ;

#include <stdio.h>
#include <stddef.h>

#if defined(__cplusplus)
#include <string.h>
#else
#include <strings.h>
#endif
#if defined(__cplusplus)
#include <malloc.h>
#include <libc.h>
/********************************************************************
*
* Burasi sonradan Ilker Tarafindan eklendi
*
*/
#include "dbi.h"
extern int attr_in_set( char*, BULK_SCHEMA*);
extern int select_in_set( SELECT_ARG*, BULK_SCHEMA*);
extern int all_select_in_set( SELECT_ARG*, BULK_SCHEMA*);
extern JOIN_ARG  *Find_Join_Arg(JOIN_ARG*);
#endif

/********************************************************************/
/*typedef int BOOLEAN ;*/
#ifndef BOO_LEAN
#define BOO_LEAN
#define BOOLEAN int
#endif

#ifndef NULL
#define NULL		0
#endif

#define REG 		register

#define EMPTY		0
#define DELETED		-1
#define OCCUPIED	1
#define FORWARD		1
#define BACKWARD	-1

#define INDENT_LEVEL	2

#define findent(fp,indent_value) {\
    int i ;\
    for (i = indent_value - 1 ;  -- i >= 0 ; )\
        (void) fprintf (fp, " ") ;\
}

#define indent(indent_value) {\
    int i ;\
    for (i = indent_value - 1 ;  -- i >= 0 ; )\
        (void) printf (" ") ;\
}

#define printi		indent (indent_value) ; (void) printf  

#define report		(void) printf ("File %s, Line %d: ",\
					 __FILE__, __LINE__) ;\
			  (void) printf  

#define reporti		printi ("File %s, Line %d: ",\
					 __FILE__, __LINE__) ;\
			  (void) printf  

#define increment_indent(i)	indent_value += i ;
#define decrement_indent(i)	indent_value -= i ;

#define FAIL(x)		{ reporti("error %d, %s\n", x, error_text (x)) ;\
			  decrement_indent(INDENT_LEVEL) ;\
			  return (x) ; }

#define CHECK(cond)	{ if ((error = (cond)) != OKAY) FAIL (error) ; }

#define CALL(function)	{\
     increment_indent(INDENT_LEVEL);\
     CHECK (function);\
     decrement_indent(INDENT_LEVEL);}

#ifndef offsetof
# define offsetof(struct_type, member) \
	 ((int) & (((struct_type *) 0) -> member))
#endif

#ifndef baseof
# define baseof(p,member,struct_type) \
		    ((struct_type *) (((char *) p) \
			- offset (struct_type, member)))
#endif

/* number of slots in a (locally defined) array */
# define slotsof(a)	(sizeof (a) / sizeof (a [0]))

#define check_limit(x,max) \
        if (x >= max) \
        {\
            fprintf (stderr,\
                 "File %s, line %d: defined constant exceeded\n",\
                 __FILE__, __LINE__) ;\
            abort ();\
        }


/* error codes */

# define ERR_OPTIMIZER_FAILED		-1 
# define ERR_OPTIMIZER_INTERNAL_ERROR	-2 
# define ERR_NULL_POINTER		-10
# define ERR_INDEX_OUT_OF_RANGE		-11
# define ERR_POINTER_PROBLEM		-12
# define ERR_UNKNOWN_PROPERTY_VALUE	-20
# define ERR_UNKNOWN_OPERATOR		-21
# define ERR_UNKNOWN_SET_ID		-23
# define ERR_UNKNOWN_VALUE		-24
# define ERR_INVALID_VALUE		-25
# define ERR_UNKNOWN_ALGORITHM		-26
# define ERR_UNKNOWN_RULE_GROUP		-27
# define ERR_NOT_FOUND		        -30	
# define ERR_MEM_ALLOC_FAILED		-40
# define ERR_NOT_INITIALIZED		-50
# define ERR_ALREADY_INITIALIZED	-51
# define ERR_SANITY_CHECK		-80
# define ERR_PROPERTIES_FILLED		-90
# define ERR_NOT_IMPLEMENTED		-99

#endif
