#ifndef __SIGN_H
#define __SIGN_H

#include "keywords.h"

#ifndef F_MAX_FO_NAME_LEN
#define F_MAX_FO_NAME_LEN 80
#endif

typedef struct ModTypeDef {
     int Modifier;
     int vecsize;
     struct ModTypeDef *next;
} ModType;

typedef struct ArgTypeDef {
     char BaseName[50];
     ModType  *ModHead;
     int base;
     struct ArgTypeDef *next;
} ArgType;

typedef struct {
     char *ClName;
     char *FuncName;
     ArgType *ArgHead;
} FuncType;

class FindSignature {
 private:
    ArgType *ArgTypeHead;
    ModType *Type, *backtype, *ModTypeHead;
    char *EatSpace( char *p);
    void InsertModList(int mod, int vecsize);
    int check(ArgType *type1, ArgType *type2);
    int GetBase(char *BaseStr);
 public:
    char Signature[F_MAX_FO_NAME_LEN];
    FindSignature() { };
    FindSignature(char *Inp);
    FindSignature(char *, char *, int *);
};

#endif
