/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/expr_str.c,v 1.16 92/11/18 01:32:54 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"
#include <math.h>

extern TRACE			trace ;
extern int			indent_value ;

STORAGE_SEG_ANCHOR		**base_ssa_table = NULL ;
int				ss_count ;

#if defined(GET_STATS)
extern int              num_mallocs ;
extern int              num_frees ;
extern int              num_reallocs ;
#endif

extern int opt_arity [] ;


#if defined(__cplusplus) || defined (ANSI)
extern char     *error_text (int) ;
extern STATUS print_phy_expr_list_elem (PHY_EXPR_LIST_ELEM *,
                                 int) ;
static STATUS initialize_storage (STORAGE_SEG_ANCHOR **, int) ;
STATUS init_ss_anchor () ;
BOOLEAN exists_in_subtree (LOG_EXPR_LIST_ELEM *, OPERATOR,
    OPERATOR_ARGUMENT *) ;
STATUS print_hash_chain (LOG_EXPR_LIST_ELEM *, BOOLEAN, int) ;
STATUS print_eq_class (EQ_CLASS *, BOOLEAN, int) ;
STATUS get_equivalent_form_lele (STORAGE_SEG_ANCHOR *,
LOG_EXPR_LIST_ELEM *,
    double [],
    int, QUERY **) ;
STATUS count_expressions(STORAGE_SEG_ANCHOR *, EQ_CLASS *,
    double *, int *) ;
STATUS       get_equivalent_form (STORAGE_SEG_ANCHOR *,
                                LOG_EXPR_LIST_ELEM *,
                                int, QUERY **) ;
STATUS print_log_expr_list_elem (LOG_EXPR_LIST_ELEM *, BOOLEAN) ;
STATUS print_log_expr (LOG_EXPR *, BOOLEAN) ;
STATUS find_log_expr_list_elem (STORAGE_SEG_ANCHOR *,
    LOG_EXPR *,
    int,
    LOG_EXPR_LIST_ELEM *,
    LOG_EXPR_LIST_ELEM **) ;
STATUS dump_eq_class_table (STORAGE_SEG_ANCHOR *, int) ;
STATUS check_log_prop ( STORAGE_SEG_ANCHOR *,
    LOG_EXPR_LIST_ELEM *,
    EQ_CLASS *,
    LOGICAL_PROPERTY **) ;
STATUS check_sys_prop ( STORAGE_SEG_ANCHOR *,
    LOG_EXPR_LIST_ELEM *,
    EQ_CLASS *,
    SYSTEM_PROPERTY **) ;
#else
extern char     *error_text () ;
extern char *malloc () ;
extern STATUS print_phy_expr_list_elem () ;
static STATUS initialize_storage () ;
static STATUS init_eq_class () ;
STATUS init_ss_anchor () ;
BOOLEAN exists_in_subtree () ;
extern STATUS print_hash_chain () ;
extern STATUS print_eq_class () ;
STATUS get_equivalent_form_lele () ;
STATUS count_expressions() ;
STATUS get_equivalent_form () ;
extern STATUS print_log_expr_list_elem () ;
extern STATUS print_log_expr () ;
STATUS find_log_expr_list_elem () ;
STATUS dump_eq_class_table () ;
STATUS check_log_prop () ;
STATUS check_sys_prop () ;
#endif

#if defined(__cplusplus) || defined (ANSI)
STATUS init_ss_anchor ()
#else
STATUS init_ss_anchor ()
#endif
{
    int			i ;

    if (base_ssa_table != NULL)
	FAIL (ERR_SANITY_CHECK) ;

    base_ssa_table = (STORAGE_SEG_ANCHOR **) malloc ((unsigned) 
			(MAX_GROUPS * sizeof (STORAGE_SEG_ANCHOR *))) ;

    if (base_ssa_table == NULL)
    {
	FAIL (ERR_MEM_ALLOC_FAILED) ;
    }

    for (i = MAX_GROUPS; --i >= 0;)
    {
	base_ssa_table[i] = NULL ;
    }

    ss_count = 0 ;

    return (OKAY) ;
}

#if defined(__cplusplus) || defined (ANSI)
STATUS get_rule_group_ssa (int rule_group, STORAGE_SEG_ANCHOR **ssa)
#else
STATUS get_rule_group_ssa (rule_group, ssa)
int			rule_group ;
STORAGE_SEG_ANCHOR	**ssa ;
#endif
{
    int		i ;
    STATUS	error ;

    *ssa = NULL ;

    if (ss_count == 0)
    {
	CALL (init_ss_anchor ()) ;
    }
    else
    {
	for (i = ss_count; --i >= 0;)
	{
	    if (base_ssa_table[i] -> rule_group == rule_group) 
		*ssa = base_ssa_table[i] ;
	}
    }

    if (*ssa == NULL)
    {

	if (ss_count >= MAX_GROUPS)
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

	 CALL (initialize_storage (&(base_ssa_table[ss_count]), 
		rule_group)) ;

	*ssa = base_ssa_table[ss_count] ;

	++ ss_count ;

    }

    return (OKAY) ;

}

#ifdef KEEP_TRANS_INFO
#if defined(__cplusplus) || defined (ANSI)
STATUS insert_trans_list(
			 LOG_EXPR_LIST_ELEM *lele,int rule_num,
                         LOG_EXPR_LIST_ELEM *transp)
#else
STATUS insert_trans_list(lele,rule_num,transp)
STORAGE_SEGMENT_ANCHOR 	*ssa ;
LOG_EXPR_LIST_ELEM	*lele, *transp ;
int			rule_num ;
#endif
{
    TRANS_INFO		*tip = &(lele -> trans_info) ;

    ++ ((tip) -> count) ;

    if (tip -> trans_list_ptr == NULL)
    {
	tip -> trans_list_ptr = (TRANS_LIST *) 
                malloc ((unsigned) sizeof (TRANS_LIST)) ; 	
    }
    else
    {
	if ((tip) -> count > (tip) -> list_size) 
	{ 
	    TRANS_LIST  *temp ; 
	    temp = (TRANS_LIST *) realloc 
		((char *) ((tip) -> trans_list_ptr), 
		(unsigned) (2 * ((tip) -> list_size) * 
			      sizeof (TRANS_LIST))); 
#ifdef GET_STATS
	    ++ num_reallocs ; 
#endif
	    if (temp != (tip) -> trans_list_ptr) 
		(tip) -> trans_list_ptr = temp ;
	    ((tip) -> list_size) *= 2 ; 
	} 
    }

    (tip) -> trans_list_ptr -> 
	    trans_list[((tip) -> count) - 1].rule_id 
		= (short) (rule_num);  

    (tip) -> trans_list_ptr -> 
	    trans_list[((tip) -> count) - 1].trans_ptr = (transp); 

    return (OKAY) ;

}
#endif

#if defined(__cplusplus) || defined (ANSI)
STATUS link_eq_classes (STORAGE_SEG_ANCHOR *ssa, int eqci1, int eqci2)
#else
STATUS link_eq_classes (ssa, eqci1, eqci2)
STORAGE_SEG_ANCHOR	*ssa ;
int			eqci1, eqci2 ;
#endif
{
   /*
    EQ_CLASS	*temp_eq_class ;
    STATUS 	error ;
   */

    printf ("\nWarning - need to link equivalence classes, but this is \n") ;
    printf ("          not implemented yet. May miss optimal plan.\n\n") ;
    return (OKAY) ;

   /*
    printf ("Need to link equivalence classes - not implemented yet.\n") ;
    printf ("Equivalence class index 1 = %d, Equivalence class index 2 = %d\n",
		eqci1, eqci2) ;
    return (ERR_NOT_IMPLEMENTED) ;
   */
}

#if defined(__cplusplus) || defined (ANSI)
BOOLEAN exists_in_subtree (LOG_EXPR_LIST_ELEM *lele, 
			   OPERATOR op,
                           OPERATOR_ARGUMENT *op_arg)
#else
BOOLEAN exists_in_subtree (lele, op, op_arg)
LOG_EXPR_LIST_ELEM	*lele ;
OPERATOR		op ;
OPERATOR_ARGUMENT	*op_arg ;
#endif
{
    int			i ;
    COMPARE		compare_arg ; 
    LOG_EXPR_LIST_ELEM 	*temp_lele  ;

    if (lele == NULL)
	return (FALSE) ;

    for (temp_lele = lele; temp_lele != NULL; temp_lele = temp_lele -> next)
    {
	if (op == temp_lele -> expr.my_operator)
	{
	    if (op_arg != NULL)
	    {
		compare_operator_args (&(temp_lele -> expr.argument),
				       &(temp_lele -> expr.my_operator),
				       op_arg,
				       &op,
				       &compare_arg) ;
		if (compare_arg == EQUAL_TO)
		    return (TRUE);
				    
	    }
	    else
		return (TRUE) ;
	}

	for (i = -1; ++i < opt_arity[(int) (temp_lele -> expr.my_operator)];)
	    if (lele -> expr.input != NULL)
	    {
		BOOLEAN	check ;
		check = exists_in_subtree (lele -> expr.input[i], op, op_arg) ;
		if (check == TRUE)
		    return (TRUE) ;
	    }
    }

    return (FALSE) ;
   
}

#if defined(__cplusplus) || defined (ANSI)
static STATUS init_eq_class (STORAGE_SEG_ANCHOR *ssa, EQ_CLASS **eq_ptr) 
#else
static STATUS init_eq_class (ssa, eq_ptr) 
STORAGE_SEG_ANCHOR	*ssa ;
EQ_CLASS 		**eq_ptr ;
#endif
{
#ifdef USE_PE_HASH
    int i ;
#endif

#if SAFETY>=1
    if (eq_ptr == NULL)
	FAIL (ERR_NULL_POINTER) ;
#endif
 
    init_logical_prop (&((*eq_ptr) -> logical_property)) ; 

    init_sys_prop (&((*eq_ptr) -> system_property)) ;

    (*eq_ptr) -> trans_flag = NO_TRANSFORMATIONS ;

    init_log_expr_list (&((*eq_ptr) -> log_expr_list)) ;
    init_phy_expr_list (&((*eq_ptr) -> phy_expr_list)) ; 

#ifdef USE_PE_HASH
    for (i = PE_HT_SIZE; --i >= 0;)
    {
	(*eq_ptr) -> phy_expr_list.hash_table[i].first = NULL ;
#ifdef GET_STATS
	(*eq_ptr) -> phy_expr_list.hash_table[i].count = 0 ;
#endif 
    }        
#endif 

#ifdef GET_STATS
    (*eq_ptr) -> count = -1 ;
#endif 

    if (ssa -> eq_class_count >= ssa -> eq_class_table_size)
    {
        EQ_CLASS_NODE *temp ;
	temp = (EQ_CLASS_NODE *) realloc ((char *) (ssa -> base_eq_class_table),
			    (unsigned) (2 * ssa -> eq_class_table_size *
					sizeof (EQ_CLASS_NODE))) ;
	if (temp != ssa -> base_eq_class_table)
	    ssa -> base_eq_class_table = temp ;
	(ssa -> eq_class_table_size) *= 2 ;
    }

    ssa -> base_eq_class_table [ssa -> eq_class_count].eq_ptr = (*eq_ptr) ;
    ssa -> base_eq_class_table [ssa -> eq_class_count].flag = OCCUPIED ;
    (*eq_ptr) -> eq_class_index  = ssa -> eq_class_count ;

    ++ (ssa -> eq_class_count) ;

    return (OKAY) ;

}

/*-----------------------------------------------------------------------------*/

#ifdef PRINT_OUTPUT
#ifdef GET_STATS
#if defined(__cplusplus) || defined (ANSI)
STATUS get_hash_stats (STORAGE_SEG_ANCHOR *ssa, 
                       BOOLEAN print, long *ret_total)
#else
STATUS get_hash_stats (ssa, print, ret_total)
STORAGE_SEG_ANCHOR	*ssa ;
BOOLEAN 		print ;
long			*ret_total ;
#endif
{
    int		i, total = 0 ;

    for (i = -1 ; ++i < HASH_TABLE_SIZE ;)
    {
	if (print == TRUE)
	{
	    printi("Entry = %d, entries = %ld\n", i, 
		ssa -> base_hash_table[i].entries) ;
	}
        total += ((int) (ssa -> base_hash_table[i].entries)) ;
    }

    if (print == TRUE)
    {
	printi ("Total = %d\n", total) ;
    }

    *ret_total = total ;

    return (OKAY) ;

}

#if defined(__cplusplus) || defined (ANSI)
STATUS get_eq_class_stats (STORAGE_SEG_ANCHOR *ssa, 
                                BOOLEAN print, long *ret_log_total,
				long *ret_phy_total)
#else
STATUS get_eq_class_stats (ssa, print, ret_log_total,
				ret_phy_total)
STORAGE_SEG_ANCHOR	*ssa ;
BOOLEAN 		print ;
long			*ret_log_total, *ret_phy_total ;
#endif
{
    int		i, j, total_log = 0, total_phy = 0 ;

    for (i = -1 ; ++i < ssa -> eq_class_count;)
    {
	total_log += 
	  ((int) (ssa -> base_eq_class_table[i].eq_ptr -> log_expr_list.count)) ;
	total_phy += 
	  ((int) (ssa -> base_eq_class_table[i].eq_ptr -> phy_expr_list.count)) ;
        if (print == TRUE)
	{
	    printi 
	     ("  Eq class = %d, log. expr. count = %d, phy. expr. count = %d.\n",
		 i, ssa -> base_eq_class_table[i].eq_ptr -> log_expr_list.count,
		 ssa -> base_eq_class_table[i].eq_ptr -> phy_expr_list.count) ;
	}
#ifdef USE_PE_HASH
        if (print == TRUE)
	{
	    for (j = -1; ++j < PE_HT_SIZE;) 
		printi ("    bucket = %d, entries = %d\n", j, 
		  ssa -> base_eq_class_table[i].eq_ptr -> phy_expr_list.hash_table[j].count) ;
	}
#endif
    }

    *ret_log_total = total_log ;
    *ret_phy_total = total_phy ;

    return (OKAY) ;

}
#endif
#endif

#ifdef PRINT
/*
#if defined(__cplusplus) || defined (ANSI)
STATUS dump_hash_table(STORAGE_SEG_ANCHOR *ssa, int direction) 	
#else
STATUS dump_hash_table(ssa, direction) 	
STORAGE_SEG_ANCHOR	*ssa ;
int direction ;
#endif
{
    int i ;
    STATUS error  ;

#ifdef GET_STATS
    for (i = -1 ; ++i < ssa -> hash_table_size ;)
    {
	printi ("bucket = %d, entries = %d\n", i, 
		 ssa -> base_hash_table[i].entries) ;
    }
#endif

    printi ("** entering dump hash table: direction = %d\n", direction) ;

    for (i = -1 ; ++i < ssa -> hash_table_size ;)
    {
        {printi ("entry %d\n", i) ;}
        if (direction == FORWARD)
	{
	    CALL (print_hash_chain (ssa -> base_hash_table[i].first, TRUE,
                                     direction)) ; 
	}
	else
	{
	    if (direction != BACKWARD)
	    {
		FAIL (ERR_SANITY_CHECK) ;
	    }
	    else
	    {
		CALL (print_hash_chain (ssa -> base_hash_table[i].last, TRUE,
		       direction)) ; 
	    }
	}
    }

    printi ("** exiting dump hash table\n") ;

    return (OKAY) ;

}
*/

#if defined(__cplusplus) || defined (ANSI)
STATUS dump_eq_class_table (STORAGE_SEG_ANCHOR *ssa, int direction)
#else 
STATUS dump_eq_class_table (ssa, direction)
STORAGE_SEG_ANCHOR	*ssa ;
int 			direction ;
#endif
{
    STATUS error ;
    int j ;

    printi ("** entering dump eq. class table: direction = %d\n", direction ) ;

    for (j = -1 ; ++j <= ssa -> eq_class_count;)
    {
        printi ("table entry %d\n", j) ;

        if (ssa -> base_eq_class_table[j].flag == DELETED)
        {
            printi ("  entry DELETED\n") ;
        }
        else if (ssa -> base_eq_class_table[j].flag == EMPTY)
        {
            printi ("  entry EMPTY\n") ;
        }
        else
        {
	    if (ssa -> base_eq_class_table[j].flag != OCCUPIED)
	    {
		FAIL (ERR_SANITY_CHECK) ;
	    }
	    else
	    {
		CALL (print_eq_class (ssa -> base_eq_class_table[j].eq_ptr,
		       TRUE, direction)) ;
	    }
        }
    }

    printi ("** exiting dump eq. class table\n") ;

    return (OKAY) ;
}
#endif

/*-----------------------------------------------------------------------------*/

#if defined(__cplusplus) || defined (ANSI)
static STATUS initialize_storage (STORAGE_SEG_ANCHOR **ssa, int rule_group)
#else 
static STATUS initialize_storage (ssa, rule_group)
STORAGE_SEG_ANCHOR	**ssa ;
int			rule_group ;
#endif
{
    REG int i ;
    EQ_CLASS_NODE	*eq_class_table ;

    if (*ssa != NULL)
	FAIL (ERR_ALREADY_INITIALIZED) ;

    *ssa = (STORAGE_SEG_ANCHOR *) 
	      malloc ((unsigned) sizeof (STORAGE_SEG_ANCHOR)) ;

    (*ssa) -> rule_group = rule_group ;

    (*ssa) -> base_hash_table = (HASH_INDEX_ENTRY *) malloc
		((unsigned) (HASH_TABLE_SIZE * sizeof (HASH_INDEX_ENTRY))) ;

    for (i = -1 ; ++i < HASH_TABLE_SIZE ;)
    {
	(*ssa) -> base_hash_table[i].first = NULL ;
	(*ssa) -> base_hash_table[i].last = NULL ;
#ifdef GET_STATS
        (*ssa) -> base_hash_table[i].entries = 0 ;
#endif
    }

    (*ssa) -> hash_table_size = HASH_TABLE_SIZE ;

    allocate_eq_class_table (eq_class_table) ;

    (*ssa) -> base_eq_class_table = eq_class_table ;
    (*ssa) -> eq_class_table_size = EQ_CLASS_TABLE_SIZE ; 
    (*ssa) -> eq_class_count = 0 ;

    for (i = -1 ; ++i < EQ_CLASS_TABLE_SIZE ;)
    {
	(*ssa) -> base_eq_class_table[i].eq_ptr = NULL ;
	(*ssa) -> base_eq_class_table[i].flag = EMPTY ;
    }

    return (OKAY) ;

}

#ifdef GET_STATS
#if defined(__cplusplus) || defined (ANSI)
STATUS get_equivalent_form (STORAGE_SEG_ANCHOR *ssa, LOG_EXPR_LIST_ELEM *lele_in, 
                            int id, QUERY **query)
#else 
STATUS get_equivalent_form (ssa, lele_in, id, query)
STORAGE_SEG_ANCHOR	*ssa ;
LOG_EXPR_LIST_ELEM	*lele_in ;
int			id ;
QUERY			**query ;
#endif
{
    int			i ;
    LOG_EXPR_LIST_ELEM	*lele ;
    double		inputs_count[MAX_OPERATOR_ARITY] ; 
    int 		start, end ;
    EQ_CLASS		*temp_eq_class, *eq_class ;
    BOOLEAN		found = FALSE ;
    STATUS 		error ;

    *query = NULL ;

    if (lele_in == NULL)
    {
	if (id > 1)
	{
	    FAIL (ERR_INVALID_VALUE) ;
	}
	return (OKAY) ;
    }

    end = 0 ;

    get_eq_class_addr (ssa, lele_in -> eq_class_index,
		       &eq_class) ;

    start = end = 0 ;

    for (lele = eq_class -> log_expr_list.first;
         lele != NULL;
	 lele = lele -> next)
    {
	int 	max_ref ;
	double 	count_expr ;

	count_expr = 1 ;

	for (i = -1; ++i < opt_arity[(int) (lele -> expr.my_operator)];)
	{
	    if (lele -> expr.input[i] == NULL)
	    {
		inputs_count[i] = 1 ;
	    }
	    else
	    {
		get_eq_class_addr (ssa, lele->expr.input[i]->eq_class_index,
				   &temp_eq_class) ;
		count_expressions (ssa, temp_eq_class, &inputs_count[i], 
				   &max_ref) ;
	    }
	    count_expr *= (inputs_count[i]) ;
	}

	start = end + 1 ;
	end = start + (int) count_expr - 1 ;

	if (id <= end && id >= start)
	{
	    CALL (get_equivalent_form_lele (ssa, lele, &inputs_count[0],
				      id - (start - 1), query)) ;;
	    if (*query)
	    {
		found = TRUE ;
		break ;
	    }
	    else
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	}
    }

    if (found == FALSE)
    {
	printi ("Error - invalid form id = %d\n", id) ;
	FAIL (ERR_INVALID_VALUE) ;
    }

    return (OKAY) ;    
}

#define mult_rest_array(a,start,num_elem,result) {\
	int 	i_ziz ; \
	(result) = 1; \
	for (i_ziz = (start) - 1 ; ++ i_ziz < (num_elem);) \
	    (result) *= ((int) a[i_ziz]) ;}

#if defined(__cplusplus) || defined (ANSI)
STATUS get_equivalent_form_lele (STORAGE_SEG_ANCHOR *ssa, LOG_EXPR_LIST_ELEM *lele_in, 
                                 double inputs_count[], 
				 int id, QUERY **query)
#else
STATUS get_equivalent_form_lele (ssa, lele_in, inputs_count, 
				 id, query)
STORAGE_SEG_ANCHOR	*ssa ;
LOG_EXPR_LIST_ELEM	*lele_in ;
double			inputs_count[] ; 
int			id ;
QUERY			**query ;
#endif
{
    int		i ;
    int		id_left ;
    EQ_CLASS	*temp_eq_class ;
    STATUS 	error ; 

    allocate_query (*query) ; 
    (*query) -> my_operator = lele_in -> expr.my_operator ;
    copy_operator_arg (&((*query) -> argument), 
			&(lele_in -> expr.argument)) ;
    get_eq_class_addr (ssa, lele_in -> eq_class_index,
		       &temp_eq_class) ;

    id_left = id ;
    for (i = -1 ; ++i < opt_arity[(int) (lele_in -> expr.my_operator)];)
    {
	QUERY	*input_query ;

	if (i + 1 == opt_arity[(int) (lele_in -> expr.my_operator)])
	{
	    CALL (get_equivalent_form (ssa, lele_in -> expr.input[i], id_left, 
					&input_query)) ;
	}
	else
	{
	    int base, which_input ;
	    mult_rest_array (inputs_count, i + 1, 
			     opt_arity[(int) (lele_in -> expr.my_operator)], base) ;
	    which_input = (int) ceil ((double) id_left / (double) base) ;
	    CALL (get_equivalent_form (ssa, lele_in -> expr.input[i], 
					which_input, 
					&input_query)) ;
	    id_left -= ((which_input - 1) * base) ;
	}

	if (! (input_query))
	{
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	}

	(*query) -> input[i] = input_query ;
	    
    }

    return (OKAY) ;
}
#endif

#ifdef GET_STATS
#if SAFETY>=2
#ifdef KEEP_TRANS_INFO
#if defined(__cplusplus) || defined (ANSI)
STATUS check_trans_ptrs (LOG_EXPR_LIST_ELEM *lele)
#else
STATUS check_trans_ptrs (lele)
LOG_EXPR_LIST_ELEM  *lele ;
#endif
{
    int 	j ;
    TRANS_LIST	*tlp = lele -> trans_info.trans_list_ptr ; 

    for (j = lele -> trans_info.count; --j >= 0;)
    {	
	if (tlp -> trans_list[j].rule_id < 0)
	{ 
	    FAIL (ERR_SANITY_CHECK) ;
	} 
	if (tlp -> trans_list[j].trans_ptr -> eq_class_index 
		!= lele -> eq_class_index) 
	{ 
	    FAIL (ERR_SANITY_CHECK) ;
	} 
	    
    }	

    return (OKAY) ;

}
#endif
#endif
#endif

#ifdef GET_STATS
#if defined(__cplusplus) || defined (ANSI)
STATUS count_expressions(STORAGE_SEG_ANCHOR *ssa, EQ_CLASS *eq_class, 
			 double *ret_count, int *ret_max_ref)
#else
STATUS count_expressions(ssa, eq_class, ret_count, ret_max_ref)
STORAGE_SEG_ANCHOR	*ssa ;
EQ_CLASS		*eq_class ;
double			*ret_count ;
int			*ret_max_ref ;
#endif
{
    int 		i ;
    LOG_EXPR_LIST_ELEM	*lele ;
#if defined(KEEP_TRANS_INFO)
    STATUS 		error ;
#endif

    if (eq_class->count == -1)
    {
	eq_class -> count = 0 ;
	for (lele = eq_class->log_expr_list.first;lele != NULL;
		lele = lele -> next)
	{
	    double 	count_expr, temp ;

#ifdef KEEP_TRANS_INFO
	    CALL (check_trans_ptrs (lele)) ;
#endif

	    count_expr = 1 ;
	    if (lele -> ref_count > *ret_max_ref)
		*ret_max_ref = lele -> ref_count ;
	    for (i = -1; ++i < MAX_OPERATOR_ARITY;)
	    {
		EQ_CLASS	*temp_eq_class ;
		if (lele -> expr.input[i] == NULL)
		    continue ;
		get_eq_class_addr (ssa,lele->expr.input[i]->eq_class_index,
				    &temp_eq_class) ;
		count_expressions (ssa, temp_eq_class, &temp, ret_max_ref) ;
		count_expr = count_expr * temp ;
	    }
	    eq_class->count += count_expr ;
	    
	}
    }

    *ret_count = eq_class->count ;
    return (OKAY) ;
}
#endif

#if SAFETY>=2
#if defined(__cplusplus) || defined (ANSI)
STATUS check_storage(STORAGE_SEG_ANCHOR *ssa, long *ret_count)
#else
STATUS check_storage(ssa, ret_count)
STORAGE_SEG_ANCHOR	*ssa ;
long			*ret_count ;
#endif
{
    int 		i, j ;
    LOG_EXPR_LIST_ELEM	*lele, *lele2 ;
    BOOLEAN 		same ;
    long		count = 0 ;
    STATUS 		error ;

    for (i = -1 ; ++i <= ssa -> eq_class_count;)
        for (lele = ssa -> base_eq_class_table[i].eq_ptr->log_expr_list.first; ;
	     lele = lele -> next)
	{
	    same = TRUE ;
	    if (lele == NULL)
	    {
		same = FALSE ;
		break ;
	    }
	    ++ count ;
	    for (j = -1 ; ++j <= ssa -> eq_class_count;)
		for (lele2 = ssa -> base_eq_class_table[j].eq_ptr->log_expr_list.first; ;
			lele2 = lele2 -> next)
		{
		    if (lele2 == NULL)
		    {
			same = FALSE ; break ;
		    }
		    if (lele != lele2)
		    {
			if (lele -> expr.my_operator == lele2 -> expr.my_operator)
			{
			    COMPARE comp ;
			    int k ;
			    CALL (compare_operator_args (&(lele -> expr.argument),
					&(lele -> expr.my_operator), 
					&(lele2 -> expr.argument),
					&(lele2 -> expr.my_operator), &comp)) ;
			    if (comp == EQUAL_TO)
			    {
				for (k = -1; 
					++k < opt_arity[(int) (lele->expr.my_operator)];)
				    if (lele -> expr.input[k] != lele2 -> expr.input[k])
				    {
					same = FALSE ;
					break ;
				    }
			    }
			    else same = FALSE ;
			} 
			else same = FALSE ;
		    }
		    else same = FALSE ;
		}
	    if (same == TRUE) 
	    {
		print_log_expr_list_elem (lele, TRUE) ;
		print_log_expr_list_elem (lele2, TRUE) ;
		FAIL (ERR_SANITY_CHECK) ;
	    }
	}
    *ret_count = count ;
    return (OKAY) ;
}
#endif

/*-----------------------------------------------------------------------------*/

#ifndef USE_MACROS
#if defined(__cplusplus) || defined (ANSI)
STATUS modify_dominated_pele (STORAGE_SEG_ANCHOR *ssa, 
                              PHY_EXPR_LIST_ELEM *pele, 
			      PHY_EXPR *phy_expr,
			      LOG_EXPR_LIST_ELEM *lele)
#else
STATUS modify_dominated_pele (ssa, pele, phy_expr, lele)
STORAGE_SEG_ANCHOR	*ssa ;
PHY_EXPR_LIST_ELEM 	*pele ;
PHY_EXPR	 	*phy_expr ;
LOG_EXPR_LIST_ELEM 	*lele ;
#endif
{
    PV_COMPARE		pv_compare ;

#if SAFETY>=1
    if (pele == NULL || phy_expr == NULL || lele == NULL)
  	FAIL (ERR_NULL_POINTER) ;
    if (phy_expr -> derived_pele != NULL)
    {
	LOGICAL_PROPERTY	*lp ;
	SYSTEM_PROPERTY		*sp ;

        sp = &(ssa->base_eq_class_table[pele->eq_class_index].eq_ptr->system_property) ;
        lp = &(ssa->base_eq_class_table[pele->eq_class_index].eq_ptr->logical_property) ;

	compare_property_vec (&(phy_expr -> derived_pele -> property_vector),
				     &(pele -> property_vector), 
				     sp, 
				     lp, 
				     &pv_compare) ;
	if (pv_compare != PV1_COV_PV2 && pv_compare != PV_EQUAL)
	    FAIL (ERR_SANITY_CHECK) ;
    }
#endif

    if (pele -> expr == phy_expr)
	return (OKAY) ;

    if (pele -> expr && (-- (pele -> expr -> ref_count) == 0))
	deallocate (pele -> expr) ;

    pele -> expr = phy_expr ;
    ++ (phy_expr -> ref_count) ;
    pele -> lele = lele ;

    return (OKAY) ;

}
#endif

/*-----------------------------------------------------------------------------*/

#if defined(__cplusplus) || defined (ANSI)
STATUS insert_phy_expr_list_elem (STORAGE_SEG_ANCHOR *ssa, 
				int eq_class_index,
				PROPERTY_VECTOR *pv,
				PROPERTY_VECTOR *excl_pv,
				PHY_EXPR *phy_expr,
				COPY_VALUE copy,
				LOG_EXPR_LIST_ELEM *lele, 
                                PHY_EXPR_LIST_ELEM **ret_pele) 
#else
STATUS insert_phy_expr_list_elem (ssa, eq_class_index,
				pv,
				excl_pv,
				phy_expr,
				copy,
				lele,
                                ret_pele) 
STORAGE_SEG_ANCHOR	*ssa ;
int    			eq_class_index ;
PROPERTY_VECTOR		*pv ;
PROPERTY_VECTOR		*excl_pv ;
PHY_EXPR		*phy_expr ;
COPY_VALUE		copy ;
LOG_EXPR_LIST_ELEM 	*lele ;
PHY_EXPR_LIST_ELEM 	**ret_pele ;
#endif
{
    EQ_CLASS			*eq_class ;
    PHY_EXPR_LIST_ELEM 		*pele ;
#ifdef USE_PE_HASH
    int				bucket ;
#endif

#if SAFETY>=1
    if (ssa == NULL)
        FAIL (ERR_NOT_INITIALIZED) ;
    if (pv == NULL || excl_pv == NULL)
	FAIL (ERR_NULL_POINTER) ;
    if (eq_class_index < 0 || eq_class_index > ssa -> eq_class_count)
	FAIL (ERR_INDEX_OUT_OF_RANGE) ;
    if (ssa -> base_eq_class_table [eq_class_index].flag != OCCUPIED)
	FAIL (ERR_SANITY_CHECK) ;
    if (ssa -> base_eq_class_table [eq_class_index].eq_ptr == NULL)
	FAIL (ERR_NULL_POINTER) ;
#endif

    eq_class = ssa -> base_eq_class_table [eq_class_index].eq_ptr ;

    allocate_phy_expr_list_elem (pele) ;

    switch (copy)
    {
	case (COPY):
	    FAIL (ERR_NOT_IMPLEMENTED) ;
	case (NO_COPY):
	    pele -> expr = phy_expr ;
	    if (phy_expr != NULL)
		++ (phy_expr -> ref_count) ;
	    break ;
	default:
	    FAIL (ERR_UNKNOWN_VALUE) ;
    }

    if (eq_class -> phy_expr_list.first == NULL)
	eq_class -> phy_expr_list.first = pele ;
    else
	(eq_class -> phy_expr_list.last) -> next = pele ;

    pele -> prev = eq_class -> phy_expr_list.last ;
    eq_class -> phy_expr_list.last = pele ;

    copy_property_vec (&(pele -> property_vector), pv) ;
    copy_property_vec (&(pele -> excl_property_vector), excl_pv) ;

    pele -> eq_class_index = eq_class_index ; 
#ifdef GET_STATS
    ++(eq_class -> phy_expr_list.count) ;
#endif
#ifdef USE_PE_HASH
    pe_hash_fct(pv, excl_pv, &(eq_class->logical_property), 
		&(eq_class->system_property), &bucket);
    if (eq_class -> phy_expr_list.hash_table[bucket].first != NULL)    
	pele -> hash_next = 
		eq_class -> phy_expr_list.hash_table[bucket].first ; 
    eq_class -> phy_expr_list.hash_table[bucket].first = pele ; 
#ifdef GET_STATS
    ++(eq_class -> phy_expr_list.hash_table[bucket].count) ; 
#endif
#endif

    pele -> lele = lele ;

    *ret_pele = pele ;

    return (OKAY);

}

/*-----------------------------------------------------------------------------*/

#ifndef USE_MACROS
#if defined(__cplusplus) || defined (ANSI)
STATUS find_phy_expr_list_elem (STORAGE_SEG_ANCHOR *ssa, 
				int eq_class_index, 
				PHY_EXPR_LIST_ELEM *begin,
				PROPERTY_VECTOR *pv,
				PV_COMPARE pv_compare_value,
				PROPERTY_VECTOR *pv_excl,
				PV_COMPARE pv_compare_value_excl,
				PV_EXCL_COMPARE pv_excl_compare_value, 
				COST *cost,
				COMPARE cost_compare_value,
                                PHY_EXPR_LIST_ELEM **ret_pele) 
#else
STATUS find_phy_expr_list_elem (ssa, eq_class_index, begin,
				pv,
				pv_compare_value,
				pv_excl,
				pv_compare_value_excl,
				pv_excl_compare_value, 
				cost,
				cost_compare_value,
                                ret_pele) 
STORAGE_SEG_ANCHOR      *ssa ;
int    			eq_class_index ;
PHY_EXPR_LIST_ELEM	*begin ;
PROPERTY_VECTOR		*pv ;
PV_COMPARE		pv_compare_value ;
PROPERTY_VECTOR		*pv_excl ;
PV_COMPARE		pv_compare_value_excl ;
PV_EXCL_COMPARE		pv_excl_compare_value ;
COST			*cost ;
COMPARE			cost_compare_value ;
PHY_EXPR_LIST_ELEM 	**ret_pele ;
#endif
{
    EQ_CLASS			*eq_class ;
    PHY_EXPR_LIST_ELEM 		*start ;
    REG PHY_EXPR_LIST_ELEM 	*pele ;
    STATUS 			error ;
#ifdef USE_PE_HASH
    int				bucket ;
#endif

#if SAFETY>=1
    if (ssa == NULL)
        FAIL (ERR_NOT_INITIALIZED) ;
    if (pv == NULL)
	FAIL (ERR_NULL_POINTER) ;
    if (pv_compare_value == PV_NOT_COMPARABLE
		||
        pv_compare_value == PV_COMPARE_NOT_SET)
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    if (eq_class_index < 0 || eq_class_index > ssa -> eq_class_count)
	FAIL (ERR_INDEX_OUT_OF_RANGE) ;
    if (ssa -> base_eq_class_table [eq_class_index].flag != OCCUPIED)
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    if (ssa -> base_eq_class_table [eq_class_index].eq_ptr == NULL)
	FAIL (ERR_NULL_POINTER) ;
#endif

    eq_class = ssa -> base_eq_class_table [eq_class_index].eq_ptr ;

    if (begin == NULL)
    {
#ifdef USE_PE_HASH
	pe_hash_fct(pv, pv_excl, &(eq_class->logical_property), 
		    &(eq_class->system_property), &bucket);
        start = eq_class -> phy_expr_list.hash_table[bucket].first ;
#else
        start = eq_class -> phy_expr_list.last ;
#endif
    }
    else
    {
#ifdef USE_PE_HASH
        start = begin -> hash_next ;
#else
        start = begin -> prev ;
#endif
    }

   /* Loop through physical expression list elements. */
    for (pele = start ; pele != NULL ;)
    {
	PV_COMPARE 	test_pv_compare ; 
	COMPARE    	test_cost_compare ;
	PV_EXCL_COMPARE test_pv_excl_compare ;
	BOOLEAN		t1, t2, t3, t4 ;
	
        t1 = t2 = t3 = t4 = TRUE ;

	if (cost_compare_value != COMPARE_NOT_SET && pele -> expr)
	{
	    compare_cost (cost, &(pele -> expr -> cost), 
			    &test_cost_compare) ; 
	    switch (cost_compare_value)
	    {
		case (GREATER_THAN_OR_EQUAL_TO):
		    t1 = (test_cost_compare == GREATER_THAN ||
				test_cost_compare == EQUAL_TO) ;
		    break ;
		case (LESS_THAN_OR_EQUAL_TO):
		    t1 = (test_cost_compare == LESS_THAN ||
				test_cost_compare == EQUAL_TO) ;
		    break ;
		default:
		    t1 = (test_cost_compare == cost_compare_value) ;
	    }  /* switch */
        }

        if (t1) 
	{
	    compare_property_vec (pv, &(pele -> property_vector),
				    &(eq_class -> system_property),
				    &(eq_class -> logical_property),
				    &test_pv_compare) ;

	    t2 = ((test_pv_compare == pv_compare_value) 
		    || 
		  (test_pv_compare == PV_EQUAL && 
		   pv_compare_value == PV1_COV_PV2)
		    || 
		  (test_pv_compare == PV_EQUAL && 
		   pv_compare_value == PV2_COV_PV1)) ;
	}

        if (t1 && t2 && pv_excl_compare_value != PV_EXCL_NOT_SET)
	{
	    CALL (compare_excl_property_vec (
			        &(pele -> property_vector),
                                pv_excl, 
				&(eq_class -> system_property),
				&(eq_class -> logical_property),
				&test_pv_excl_compare)) ;
	    t3 = (test_pv_excl_compare == pv_excl_compare_value) ;
	}

	if (t1 && t2 && t3 &&
		 pv_compare_value_excl != PV_COMPARE_NOT_SET)
	{
	    compare_property_vec (pv_excl,
					 &(pele -> excl_property_vector),
					 &(eq_class -> system_property),
					 &(eq_class -> logical_property),
				         &test_pv_compare) ;

	    t4 = ((test_pv_compare == pv_compare_value_excl) 
		    || 
		  (test_pv_compare == PV_EQUAL &&
		     pv_compare_value_excl == PV1_COV_PV2)
		    || 
		  (test_pv_compare == PV_EQUAL &&
			 pv_compare_value_excl == PV2_COV_PV1)) ;
	    
	}

	if (t1 && t2 && t3 && t4)
	    break ;

#ifdef USE_PE_HASH
        pele = pele -> hash_next ;
#else
        pele = pele -> prev ;
#endif

    } /* for */

    *ret_pele = pele ;

    return (OKAY) ;    

}
#endif

/*-----------------------------------------------------------------------------*/

#if defined(__cplusplus) || defined (ANSI)
STATUS find_log_expr_list_elem (STORAGE_SEG_ANCHOR *ssa, 
				LOG_EXPR *log_expr, 
				int eq_class_index, 
				LOG_EXPR_LIST_ELEM *begin, 
				LOG_EXPR_LIST_ELEM **ret_lep) 
#else
STATUS find_log_expr_list_elem (ssa, log_expr, eq_class_index, begin, 
                                ret_lep) 
STORAGE_SEG_ANCHOR	*ssa ;
LOG_EXPR 		*log_expr ;
int    			eq_class_index ;
LOG_EXPR_LIST_ELEM	*begin ;
LOG_EXPR_LIST_ELEM 	**ret_lep ;
#endif
{
    EQ_CLASS			*eq_class ;
    LOG_EXPR_LIST_ELEM 		*start ;
    REG LOG_EXPR_LIST_ELEM 	*lep ;
    OPERATOR 			op1 ;
    STATUS 			error ;

#if DEBUG>=2
    if (trace == TRACE_ON) 
    {
	printi ("in find_log_expr_list_elem, expression:\n") ;
	CALL (print_log_expr (log_expr, TRUE)) ;
	fflush (stdout) ;
    }
#endif

#if SAFETY>=1
    if (ssa == NULL)
        FAIL (ERR_NOT_INITIALIZED) ;
    if (log_expr == NULL)
       FAIL (ERR_NULL_POINTER) ; 
#endif

    if (eq_class_index != (int) -1)
    {
#if SAFETY>=1
	if (eq_class_index < -1 || eq_class_index > ssa -> eq_class_count)
	    FAIL (ERR_INDEX_OUT_OF_RANGE) ;
	if (ssa->base_eq_class_table [eq_class_index].flag != OCCUPIED)
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	if (ssa->base_eq_class_table [eq_class_index].eq_ptr == NULL)
	    FAIL (ERR_NULL_POINTER) ;
#endif
	eq_class = ssa->base_eq_class_table [eq_class_index].eq_ptr ;
    }
    else
	eq_class = NULL ;

   /* Start point for search could be eq_class or through hash table. */
    if (eq_class != NULL) 
    {
       if (begin == NULL) 
	   start = eq_class -> log_expr_list.last ;
       else
           start = begin -> prev ;
    }
    else
    {
	if (begin == NULL) 
     	{	
	    long 	bucket ;
	    hash_fct (log_expr, bucket) ;
	    start = ssa -> base_hash_table[bucket].last ; 
	}
	else
	    start = begin -> hash_prev ;
    }

   /* Get operator of logical expression searching for. */ 
    op1 = log_expr -> my_operator ;

   /* Loop through logical expression elements. */
    for (lep = start ; lep != NULL ;)
    {
        LOG_EXPR *lep_log_expr ;

       /* Set pointer to logical expression in this node. */
        lep_log_expr = &(lep -> expr) ;

       /* Compare operators first. Macro in opt.h. */
	if (lep_log_expr -> my_operator == op1)
        { 
            int num_inputs, i ;
            BOOLEAN found ;
	    COMPARE comp ;
	    
	    num_inputs = opt_arity [(int) op1] ;
            found = TRUE ;
            
           /* Compare inputs (logical expressions). */
	    for (i = num_inputs ; --i >= 0 ; )
               /* If not equal, quit. */
                if (log_expr -> input[i] != lep_log_expr -> input[i]) 
                {
                    found = FALSE ;
		    break ; 
                }

           /* If operators and inputs match, check operator arguments. */
            if (found == TRUE)
            {
               CALL (compare_operator_args (&(log_expr -> argument),
				     &(log_expr -> my_operator),
                                     &(lep_log_expr -> argument), 
				     &(lep_log_expr -> my_operator),
                                     &comp)) ;
               if (comp == EQUAL_TO)
                  break ;
            }

        }

	if (eq_class != NULL) 
	   lep = lep -> prev ;
	else
	   lep = lep -> hash_prev ; 

    }

    *ret_lep = lep ;

#if DEBUG>=2
    if (trace == TRACE_ON) 
    {
	if (lep)
	{
	    printi ("expression found\n") ;
	}
	else
	{
	    printi ("expression not found\n") ;
	}

	printi ("exiting find_log_expr_list_elem\n") ;
    }
#endif

    return (OKAY) ;    

}
/*-----------------------------------------------------------------------------*/

#if defined(__cplusplus) || defined (ANSI)
STATUS insert_log_expr (STORAGE_SEG_ANCHOR *ssa, 
			LOG_EXPR *log_expr, 
			int eq_class_index,
		        int *return_eq_class_index,
			LOG_EXPR_LIST_ELEM **ret_lele,
			BOOLEAN search_flag)
#else
STATUS insert_log_expr (ssa, log_expr, eq_class_index,
		        return_eq_class_index,
			ret_lele,
			search_flag)
STORAGE_SEG_ANCHOR	*ssa ;
LOG_EXPR		*log_expr ;
int 			eq_class_index ;
int 			*return_eq_class_index ; 
LOG_EXPR_LIST_ELEM	**ret_lele ;
BOOLEAN			search_flag ;
#endif
{
    LOG_EXPR_LIST_ELEM 	*found_loc = NULL ;
    EQ_CLASS 		*eq_class ;
    int 		i ;
    STATUS 		error ;

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("in insert_log_expr\n") ;
	printi ("log. expr. to insert:\n") ;
	CALL (print_log_expr (log_expr, TRUE)) ;
    }
#endif

#if SAFETY>=1
    if (log_expr == NULL)
        FAIL (ERR_NULL_POINTER) ;
#endif

   /* Set return eq. class to default value (NULL). */
    *return_eq_class_index = (int) -1 ;
    *ret_lele = NULL ;

   /* See if expression already exists in the storage structure. */
    if (search_flag == TRUE)
	CALL (find_log_expr_list_elem (ssa, log_expr, (int) -1, 
					(LOG_EXPR_LIST_ELEM *) NULL, 
					&found_loc));

    if (eq_class_index != -1)
    {
#if SAFETY>=1
	if (eq_class_index < -1 || eq_class_index > ssa -> eq_class_count)
	    FAIL (ERR_INDEX_OUT_OF_RANGE) ;
	if (ssa -> base_eq_class_table [eq_class_index].flag != OCCUPIED)
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	if (ssa -> base_eq_class_table [eq_class_index].eq_ptr == NULL)
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif
	eq_class = ssa -> base_eq_class_table [eq_class_index].eq_ptr ;
	if (found_loc != NULL)
	    if (eq_class_index != found_loc -> eq_class_index)
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	if (eq_class -> trans_flag == TRANSFORMATIONS_COMPLETE)
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

    }
    else
	eq_class = NULL ;

   /* Expression not in hash table. */
    if (found_loc == NULL)
    {
	LOG_EXPR_LIST_ELEM *new_lep ;
	EQ_CLASS *temp_eq_class ; 

       /* Allocate a logical expression list element. */
	allocate_log_expr_list_elem (new_lep) ;
	*ret_lele = new_lep ;

       /* If equivalence class not defined, allocate a new one. */
	if (eq_class == NULL)
	{
	    allocate_eq_class (ssa, &temp_eq_class) ;

	    temp_eq_class -> log_expr_list.first = new_lep ; 

            new_lep -> eq_class_index = ssa -> eq_class_count - 1 ;

           /* Set return value of eq. class. */
	    
	    *return_eq_class_index = ssa -> eq_class_count - 1 ; 

	}
	else  /* Equivalence class was passed to function. */
	{
	    temp_eq_class = ssa -> base_eq_class_table [eq_class_index].eq_ptr ;
            (temp_eq_class -> log_expr_list.last) -> next = new_lep ;
	    new_lep -> eq_class_index = eq_class_index ;
	    *return_eq_class_index = eq_class_index ; 
	}

       /* Insert. */

#ifdef GET_STATS
	++(temp_eq_class -> log_expr_list.count) ;
#endif
	new_lep -> prev = temp_eq_class -> log_expr_list.last ;
	temp_eq_class -> log_expr_list.last = new_lep ;

	new_lep -> expr.my_operator = log_expr -> my_operator ;
	for (i = opt_arity[(int) (log_expr -> my_operator)]; --i >= 0; ) 
	{
	    new_lep -> expr.input[i] = log_expr -> input[i] ;
#ifdef GET_STATS
	    if (log_expr -> input[i] != NULL)
		++ (log_expr -> input[i] -> ref_count);
#endif
	}
	copy_operator_arg (&(new_lep -> expr.argument), 
			   &(log_expr -> argument)) ;
        new_lep -> next = NULL ;
        new_lep -> hash_next = NULL ;

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
        printi ("insert log. expr:\n") ;
        CALL (print_log_expr (&(new_lep -> expr), TRUE)) ;
    }
#endif

       /* If new equivalence class, derive logical and */
       /* system properties.                           */
        if (eq_class == NULL)
        {
	    LOGICAL_PROPERTY	*temp_log_prop ;
	    SYSTEM_PROPERTY	*temp_sys_prop ;
	    CALL (check_log_prop (ssa, new_lep, temp_eq_class,
				   &temp_log_prop)) ;
	    CALL (check_sys_prop (ssa, new_lep, temp_eq_class,
				   &temp_sys_prop)) ;
	}

       /* Insert in hash chain. */
        {
	    long temp ;
	    hash_fct (log_expr, temp) ;
   
            if (ssa -> base_hash_table[temp].first == NULL)
		ssa -> base_hash_table[temp].first = new_lep ;
            else
            {
		new_lep -> hash_prev = ssa -> base_hash_table[temp].last ;
		(ssa -> base_hash_table[temp].last) -> hash_next = new_lep ;
	    }

            ssa -> base_hash_table[temp].last = new_lep ;
#ifdef GET_STATS
            ++ (ssa -> base_hash_table[temp].entries) ;
#endif

        }

    }

    else /* Expression was found in storage structure. */
    {
	EQ_CLASS *found_eq_class 
	  = ssa -> base_eq_class_table [found_loc -> eq_class_index].eq_ptr ;

#if SAFETY>=1
	if (found_eq_class == NULL) 
	    FAIL (ERR_NULL_POINTER) ;
#endif

	if (eq_class != NULL && found_eq_class != eq_class)
	{

#if DEBUG>=2
	if (trace == TRACE_ON)
	{
	    printi ("* unequal eq. classes: \n") ;
	    printi ("    found eq_class: \n") ;
	    CALL (print_eq_class (found_eq_class, TRUE, FORWARD)) ;
	    printi ("    passed eq_class: \n") ;
	    CALL (print_eq_class (eq_class, TRUE, FORWARD)) ;
	    printi ("    have to link  eq. classes\n") ; 
	}
#endif

           /* Set return value to pass back to calling routine.  */
           /* Calling routine must know about existing eq. class. */

	    *return_eq_class_index = found_loc -> eq_class_index ; 
	    *ret_lele = found_loc ;

           /* eq_class (passed to this function) could be NULL, signifying  */
           /* a subexpression instead of a transformation. But if it is not */
           /* NULL, need to link equivalence classes.                       */

            if (eq_class != NULL)
            {
                printi ("Need to link equivalence classes.\n") ;
                FAIL (ERR_NOT_IMPLEMENTED) ;

            }  /* expression was found, eq_class != NULL and eq. classes */
               /* not equal.                                             */
	    else  /* else - expresion was found, eq_class passed = NULL */
	    {
#if DEBUG>=2
		if (trace == TRACE_ON)
		{
		    printi ("expression exists in storage structure, eq. class == NULL\n") ;
		    printi ("just return\n") ;
		}
#endif
	    } /* else - expresion was found, eq_class passed = NULL */

        }
	else   /* Expression already exists in storage structure and eq. classes match. */
        {

#if DEBUG>=2
	    if (trace == TRACE_ON)
	    {
		printi ("expression exists in storage structure, eq. classes match\n") ;
		printi ("just return\n") ;
	    }
#endif

	}

    }

#if DEBUG>=2
    if (trace == TRACE_ON)
    {
	printi ("exiting insert_log_expr\n") ;
    }
#endif

    return (OKAY) ;
										
}

/*-----------------------------------------------------------------------------*/

#ifdef PRINT
#if defined(__cplusplus) || defined (ANSI)
STATUS dump_storage ()
#else 
STATUS dump_storage ()
#endif
{
    int 		i ;
    STORAGE_SEG_ANCHOR	*ssa ;
    STATUS 		error ;

    printi ("\n\n **** DUMPING STORAGE!!! LOOK OUT!!! ***\n") ;

    for (i = -1; ++i < ss_count; )
    {
	ssa = base_ssa_table [i] ;
	printi ("\n** Dumping storage segment %d\n", i) ;
	printi ("     Rule group: ") ; print_rule_group (ssa -> rule_group) ;
	printi ("     Base hash table address = %#x\n", 
			ssa -> base_hash_table) ;
	printi ("     Hash table size = %d\n", ssa -> hash_table_size) ;
	printi ("     Base eq. class table address = %#x\n", 
			ssa -> base_eq_class_table) ;
	printi ("     Eq. class table size = %d\n", 
			ssa -> eq_class_table_size) ;
#ifdef GET_STATS
	printi ("     Eq. class count = %d\n", ssa -> eq_class_count) ;
#endif
	printi ("     Address of original query internal rep. = %#x\n", 
			ssa -> original_lele) ;
#ifdef GET_STATS
	printi ("     Calls to find best plan = %d\n", ssa -> calls_to_fbp) ;
	printi ("     Calls to optimize = %d\n\n", ssa -> calls_to_optimize) ;
#endif

	CALL (dump_eq_class_table (ssa, FORWARD)) ;

/*
    CALL (dump_hash_table (ssa, FORWARD)) ;
*/

    }

    printi ("\n\n **** DONE DUMPING STORAGE!!! PHEW!!! ***\n") ;

    return (OKAY) ;

}
#endif
