/* 
* Volcano Optimizer Generator 
* =========================== 
*   
* $Header: /tmp_mnt/home/chainsaw/bill/optgen/optgen/RCS/optimize.c,v 1.16 92/11/18 01:32:51 bill Exp Locker: bill $ 
*
*/ 
 
#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"


typedef struct INPUT_DEPTH
    {
	int		input_no ;
	int		depth ;
    } INPUT_DEPTH ;

int			opt_indent = 10 ;

#if defined (ANSI)
void qsort (void **, int, int, auto int (*) (void *, void *)) ;
#endif

#if defined(__cplusplus) || defined (ANSI)
extern void add_cost(COST*,COST*,COST*);
extern char     *error_text (int) ;
extern STATUS modify_dominated_pele (STORAGE_SEG_ANCHOR *,
                              PHY_EXPR_LIST_ELEM *,
                              PHY_EXPR *, LOG_EXPR_LIST_ELEM *) ;
extern STATUS print_phy_expr_list_elem (PHY_EXPR_LIST_ELEM *) ;
extern STATUS find_phy_expr_list_elem (STORAGE_SEG_ANCHOR *,
                                int,
                                PHY_EXPR_LIST_ELEM *,
                                PROPERTY_VECTOR *,
                                PV_COMPARE,
                                PROPERTY_VECTOR *,
                                PV_COMPARE,
                                PV_EXCL_COMPARE,
                                COST *,
                                COMPARE,
                                PHY_EXPR_LIST_ELEM **) ;
extern STATUS insert_phy_expr_list_elem (STORAGE_SEG_ANCHOR *,
    int,
    PROPERTY_VECTOR *,
    PROPERTY_VECTOR *,
    PHY_EXPR *,
    COPY_VALUE,
    LOG_EXPR_LIST_ELEM *,
    PHY_EXPR_LIST_ELEM **) ;
extern STATUS find_best_plan ( LOG_EXPR *,
    LOG_EXPR_LIST_ELEM *,
    PROPERTY_VECTOR *,
    PV_COMPARE,
    PROPERTY_VECTOR *,
    PV_EXCL_COMPARE,
    COST *,
    int,
    EQ_CLASS *,
    int,
    STORAGE_SEG_ANCHOR *,
    OPT_RETURN *) ;
extern STATUS match_impl_rule(LOG_EXPR_LIST_ELEM *,
    LOG_EXPR *, int,
    STORAGE_SEG_ANCHOR *,
    int,
    LOG_EXPR_LIST_ELEM *[],
    ALGORITHM *,
    ALGORITHM_ARGUMENT *,
    int *) ;
extern STATUS do_any_good(ALGORITHM *,
    OPERATOR *,
    OPERATOR_ARGUMENT *,PROPERTY_VECTOR *,
    SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *,PROPERTY_VECTOR *,
    OPERATOR [],
    ALGO_APPL_RETURN *) ;
STATUS estimate_cost(ALGORITHM ,ALGORITHM_ARGUMENT *,
    SYSTEM_PROPERTY *,LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **,LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *,PROPERTY_VECTOR *,
    PROPERTY_VECTOR **,
    COST *) ;
extern STATUS get_input_pv(ALGORITHM,
    ALGORITHM_ARGUMENT *,PROPERTY_VECTOR *,
    PROPERTY_VECTOR *,
    int,int,PROPERTY_VECTOR **,
    PROPERTY_VECTOR **,
    SYSTEM_PROPERTY **,LOGICAL_PROPERTY **,
    PHY_EXPR_LIST_ELEM **,
    COST **,BOOLEAN *) ;
extern STATUS derive_phy_prop(ALGORITHM,
    ALGORITHM_ARGUMENT *,PROPERTY_VECTOR **,
    SYSTEM_PROPERTY *,
    LOGICAL_PROPERTY *,
    SYSTEM_PROPERTY **,LOGICAL_PROPERTY **,
    PROPERTY_VECTOR *,PROPERTY_VECTOR *) ;
extern STATUS get_enforcer(int,ALGORITHM *) ;
static int find_depth (LOG_EXPR_LIST_ELEM *) ;
#if DEBUG>=1 && defined (PRINT)
STATUS print_log_expr (LOG_EXPR *log_expr,BOOLEAN inputs);
#endif
static int find_depth (LOG_EXPR_LIST_ELEM *) ;
static int compare_depth (INPUT_DEPTH *, INPUT_DEPTH *) ;
#else
extern void qsort () ;
extern char     *error_text () ;
extern char *malloc () ;
extern STATUS modify_dominated_pele () ;
extern STATUS find_phy_expr_list_elem () ;
extern STATUS print_phy_expr_list_elem () ;
extern STATUS insert_phy_expr_list_elem () ;
static int find_depth () ;
static int compare_depth () ;
extern STATUS find_best_plan () ;
extern STATUS match_impl_rule() ;
extern STATUS do_any_good() ;
extern void qsort() ;
extern STATUS do_any_good() ;
extern STATUS get_input_pv() ;
extern STATUS derive_phy_prop() ;
extern STATUS get_enforcer() ;
static int find_depth () ;
#if DEBUG>=1 && defined (PRINT)
STATUS print_log_expr ();
#endif
#endif

extern int		opt_arity [] ;
extern int		algo_arity [] ;

#ifdef GET_STATS
BOOLEAN			plan_yet = FALSE ;
COST 			first_plan_cost ;
extern int              num_mallocs ;
extern int              num_frees ;
#endif
extern COST		zero_cost ;

extern TRACE		trace ;
extern int		indent_value ;
 
#if DEBUG>=1
extern int		level ;
#endif

#if defined(__cplusplus) || defined (ANSI)
STATUS optimize (LOG_EXPR_LIST_ELEM *lele, PROPERTY_VECTOR *needed_pv, 
		 PROPERTY_VECTOR *excl_pv, COST *cost_limit,
		 int eq_class_index, 
		 EQ_CLASS *eq_class, PHY_EXPR_LIST_ELEM *covering_plan,
		 int rule_group, 
		 STORAGE_SEG_ANCHOR *ssa,
		 OPT_RETURN *opt_return)
#else
STATUS optimize (lele, needed_pv, 
		 excl_pv, cost_limit,
		 eq_class_index, 
		 eq_class, covering_plan,
		 rule_group, 
		 ssa,
		 opt_return)
LOG_EXPR_LIST_ELEM	*lele ; 
PROPERTY_VECTOR    	*needed_pv ;
PROPERTY_VECTOR    	*excl_pv ;
COST			*cost_limit ;
int			eq_class_index ;
EQ_CLASS		*eq_class ;
PHY_EXPR_LIST_ELEM	*covering_plan ;
int			rule_group ;
STORAGE_SEG_ANCHOR  	*ssa ;
OPT_RETURN		*opt_return ;
#endif
{
    LOG_EXPR			*log_expr ; 
    ALGORITHM			algorithm_or_enforcer ;
    ALGO_APPL_RETURN		test_algorithm_return ;
    int				count ; 
    COST			min_cost ;
    COST			remaining_cost_limit ;
    COST			current_plan_cost ;
    COST			cost_estimate ;
    COST			algorithm_cost ;
    LOG_EXPR_LIST_ELEM		*temp_lele ;
    OPT_RETURN			input_opt_return [MAX_ALGORITHM_ARITY],
				*ptr_to_input_opt_return = NULL ;	
    COST			*input_ret_cost [MAX_ALGORITHM_ARITY],
				**ptr_to_input_ret_cost ;
    PHY_EXPR_LIST_ELEM		*input_ret_pele [MAX_ALGORITHM_ARITY],
				**ptr_to_input_ret_pele ;
    PROPERTY_VECTOR		*input_pv_ptr [MAX_ALGORITHM_ARITY],
				**ptr_to_input_pv_ptr = NULL ;
    PROPERTY_VECTOR		input_pv [MAX_ALGORITHM_ARITY],
				*ptr_to_input_pv = NULL ;
    PROPERTY_VECTOR		*input_excl_pv_ptr [MAX_ALGORITHM_ARITY],
				**ptr_to_input_excl_pv_ptr = NULL ;
    PROPERTY_VECTOR		input_excl_pv [MAX_ALGORITHM_ARITY],
				*ptr_to_input_excl_pv = NULL ;
    LOGICAL_PROPERTY		*input_log_prop [MAX_OPERATOR_ARITY],
				**ptr_to_input_log_prop = NULL;
    SYSTEM_PROPERTY		*input_sys_prop [MAX_OPERATOR_ARITY],
				**ptr_to_input_sys_prop = NULL ;
    LOG_EXPR_LIST_ELEM		*inputs_to_search[MAX_ALGORITHM_ARITY],
				**ptr_to_inputs_to_search = NULL ;
    PV_COMPARE			test_pv_compare ;
    ALGORITHM_OR_ENFORCER	which = ALGORITHM_IS_CURRENT ;
    INPUT_DEPTH			input_depth [MAX_OPERATOR_ARITY] ;
    BOOLEAN			optimization_possible = FALSE ;
    BOOLEAN			plan_found = FALSE ;
    int 			num_inputs ;
    PHY_EXPR_LIST_ELEM		*temp_pele = NULL ;
    BOOLEAN			mark_complete_on_exit ;
    COMPARE			cost_compare ;
    int 			process_input_count ;
    BOOLEAN			new_algorithm_or_enforcer ;
    BOOLEAN			dynamic = FALSE ;
    PROGRESS_FLAG		temp_progress_flag ;
    STATUS 			error ;

#ifdef GET_STATS
    BOOLEAN			first_call = FALSE ;
    ++ (ssa -> calls_to_optimize) ;
    if (ssa -> calls_to_optimize == 1)
    {
	init_cost (&first_plan_cost) ;
	first_call = TRUE ;
    }
#endif

    copy_cost (&min_cost, cost_limit) ;
    copy_cost (&remaining_cost_limit, &zero_cost) ;
    copy_cost (&current_plan_cost, &zero_cost) ;
    copy_cost (&algorithm_cost, &zero_cost) ;

#if DEBUG>=1 
    if (trace == TRACE_ON)
    {
	printi ("L%d opt: Entering optimize. Expression:\n", level) ;
    }
#endif

#if SAFETY>=1
    if (lele == NULL)
	FAIL (ERR_NULL_POINTER) ;

    if (needed_pv == NULL || excl_pv == NULL)
	FAIL (ERR_NULL_POINTER) ;

    if (eq_class_index < -1 || eq_class_index > ssa -> eq_class_count)
	FAIL (ERR_INDEX_OUT_OF_RANGE) ;

    if (eq_class == NULL)
        FAIL (ERR_NULL_POINTER) ; 

    if (eq_class -> eq_class_index != eq_class_index)
    {
	printi ("eq_class -> eq_class_index = %d\n", 
					eq_class -> eq_class_index) ;
	printi ("              but eq_class = %d\n", eq_class_index) ;
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
    }

    if (opt_return == NULL)
	FAIL (ERR_NULL_POINTER) ;
#endif

    log_expr = &(lele -> expr) ;

    opt_return -> pele = NULL ;
    opt_return -> error = OPTIMIZATION_FAILED ;
    opt_return -> reason = REASON_NOT_SET ;

#if DEBUG>=1 && defined (PRINT)
    if (trace == TRACE_ON)
    {
        increment_indent(opt_indent-2) ;
	CALL (print_log_expr (log_expr, TRUE)) ;
        decrement_indent(opt_indent-2) ;
	printi ("L%d opt: Property vector:\n", level) ;
        increment_indent(opt_indent) ;
	print_property_vec (needed_pv) ;
        decrement_indent(opt_indent) ;
	printi ("L%d opt: Excluding property vector:\n", level) ;
        increment_indent(opt_indent) ;
	print_property_vec (excl_pv) ;
        decrement_indent(opt_indent) ;
	printi ("L%d opt: Cost limit :\n", level) ; 
        increment_indent(opt_indent) ;
	print_cost (cost_limit) ;
        decrement_indent(opt_indent) ;
	printi ("L%d opt: Equivalence class = %d\n", level, eq_class_index) ;
#ifdef GET_STATS
	printi ("L%d opt: Calls to optimize = %d\n", level, ssa -> calls_to_optimize) ;
#endif
    }
#endif

   /* Loop over all algorithms and enforcers. */
    count = -1 ;
    init_algorithm_arg ( &(test_algorithm_return.algorithm_argument) ) ;
    CALL (match_impl_rule (lele, log_expr, rule_group, ssa, 
			    ++count, &inputs_to_search[0], 
			    &algorithm_or_enforcer, 
			    &(test_algorithm_return.algorithm_argument), &count)) ;

    new_algorithm_or_enforcer = TRUE ;
    process_input_count = 0 ;

    while (algorithm_or_enforcer != (ALGORITHM) NO_MORE)
    {
	REG int i, j ;

	if (new_algorithm_or_enforcer == TRUE) 
	{
	    REG int ti ;
	    OPERATOR	input_operator[MAX_OPERATOR_ARITY] ;

	    for (ti = opt_arity [(int) (log_expr -> my_operator)] ; --ti >= 0;)
		input_operator[ti] = log_expr -> input[ti] -> expr.my_operator ;	

	   /* See if algorithm or enforcer applies. */
	
#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		printi 
		 ("L%d opt: Calling do_any_good for algorithm or enforcer = ", level);
		print_algorithm (algorithm_or_enforcer) ;
	    }
#endif
            test_algorithm_return.enforcer_inputs = -1 ;
            test_algorithm_return.reestimate_cost = FALSE ;
	    CALL (do_any_good (&algorithm_or_enforcer, 
                                &(log_expr -> my_operator),
				&(log_expr -> argument),
				needed_pv,
				&(eq_class -> system_property),
				&(eq_class -> logical_property),
				excl_pv, 
				&input_operator[0],
				&test_algorithm_return)) ;
#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		printi 
		 ("L%d opt: do_any_good function returned ", level);
		switch (test_algorithm_return.apply_truth_value)
		{
		    case (TRUE): printf ("TRUE\n") ; break ;
		    case (FALSE): printf ("FALSE\n") ; break ;
		    default: FAIL (ERR_INVALID_VALUE) ;
		}
	    }
#endif
	}

        if (test_algorithm_return.apply_truth_value == TRUE)
        {
#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		if (new_algorithm_or_enforcer == TRUE) 
		{
		    printi ("L%d opt: ** trying new algorithm or enforcer\n",
                            level) ;
		}
		else
		{
		    printi 
                      ("L%d opt: ** processing inputs for algorithm or enforcer again\n",
                             level) ;
		    printi ("L%d opt: ** process_input_count = %d\n", 
                             level, process_input_count) ;
		}
		printi ("L%d opt: algorithm or enforcer = ", level); 
		print_algorithm (algorithm_or_enforcer) ;
#if DEBUG>=2
		printi ("L%d opt: with argument:\n", level); 
		increment_indent(opt_indent) ;
		print_algorithm_arg (&(test_algorithm_return.algorithm_argument),
					&algorithm_or_enforcer) ;
		decrement_indent(opt_indent) ;
#endif
		printi ("L%d opt: applies for operator = ", level) ; 
		print_operator (log_expr -> my_operator) ;
		printi ("L%d opt: with argument\n", level) ;
		increment_indent(opt_indent) ;
		print_operator_arg (&(log_expr -> argument),
						&(log_expr -> my_operator)) ;;
		decrement_indent(opt_indent) ;
		printi ("L%d opt: and property vector:\n", level) ;
		increment_indent(opt_indent) ;
		print_property_vec (needed_pv) ;
		decrement_indent(opt_indent) ;
		printi ("L%d opt: and process input count = %d\n", level,
			     test_algorithm_return.process_input_count) ; 
	    }
#endif

	    if (new_algorithm_or_enforcer == TRUE) 
	    {
		if (which == ENFORCER_IS_CURRENT 
			&& test_algorithm_return.enforcer_inputs != -1		
			&& test_algorithm_return.enforcer_inputs != 1)
		{
#if SAFETY>=1
		    if (test_algorithm_return.enforcer_inputs <= 0) 
		    {
			FAIL (ERR_INVALID_VALUE) ;
		    }
#endif
		    num_inputs = test_algorithm_return.enforcer_inputs ;
		    ptr_to_input_opt_return = (OPT_RETURN *) malloc 
			((unsigned) (test_algorithm_return.enforcer_inputs *
				     (sizeof (OPT_RETURN)))) ; 
		    if (ptr_to_input_opt_return == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_ret_cost = (COST **) malloc
				     (sizeof (COST *)) ;
		    if (ptr_to_input_ret_cost == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_ret_pele = (PHY_EXPR_LIST_ELEM **) malloc
                        ((unsigned) (test_algorithm_return.enforcer_inputs * 
				     (sizeof (PHY_EXPR_LIST_ELEM *)))) ;
		    if (ptr_to_input_ret_pele == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_pv_ptr = (PROPERTY_VECTOR **) malloc  
                        ((unsigned) (test_algorithm_return.enforcer_inputs * 
                                     (sizeof (PROPERTY_VECTOR *)))) ; 
		    if (ptr_to_input_pv_ptr == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_pv = (PROPERTY_VECTOR *) malloc   
                        ((unsigned) (test_algorithm_return.enforcer_inputs *  
                                     (sizeof (PROPERTY_VECTOR)))) ; 
		    if (ptr_to_input_pv == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_excl_pv_ptr = (PROPERTY_VECTOR **) malloc
                        ((unsigned) (test_algorithm_return.enforcer_inputs *
                                     (sizeof (PROPERTY_VECTOR *)))) ; 
		    if (ptr_to_input_excl_pv_ptr == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_excl_pv = (PROPERTY_VECTOR *) malloc
                        ((unsigned) (test_algorithm_return.enforcer_inputs *
                                     (sizeof (PROPERTY_VECTOR)))) ; 
		    if (ptr_to_input_excl_pv == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_log_prop = (LOGICAL_PROPERTY **) malloc 
                        ((unsigned) (test_algorithm_return.enforcer_inputs * 
                                     (sizeof (LOGICAL_PROPERTY *)))) ;  
		    if (ptr_to_input_log_prop == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_input_sys_prop = (SYSTEM_PROPERTY **) malloc
                        ((unsigned) (test_algorithm_return.enforcer_inputs *
                                     (sizeof (SYSTEM_PROPERTY *)))) ; 
		    if (ptr_to_input_sys_prop == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    ptr_to_inputs_to_search = (LOG_EXPR_LIST_ELEM **) malloc
                        ((unsigned) (test_algorithm_return.enforcer_inputs *
                                     (sizeof (LOG_EXPR_LIST_ELEM *)))) ;
		    if (ptr_to_inputs_to_search == NULL)
		    {
			FAIL (ERR_MEM_ALLOC_FAILED) ;
		    }
		    dynamic = TRUE ;
		}
		else
		{
		    num_inputs = algo_arity [(int) algorithm_or_enforcer] ;

		    if (ptr_to_input_opt_return == NULL || dynamic == TRUE)
		    {
			ptr_to_input_opt_return = &(input_opt_return [0]) ;
			ptr_to_input_pv_ptr = &(input_pv_ptr [0]) ;
			ptr_to_input_ret_cost = &(input_ret_cost[0]) ;
			ptr_to_input_ret_pele = &(input_ret_pele[0]) ;
			ptr_to_input_pv = &(input_pv [0]) ;
			ptr_to_input_excl_pv_ptr = &(input_excl_pv_ptr [0]) ;
			ptr_to_input_excl_pv = &(input_excl_pv [0]) ;
			ptr_to_input_log_prop = &(input_log_prop [0]) ;
			ptr_to_input_sys_prop = &(input_sys_prop [0]) ;
			ptr_to_inputs_to_search = &(inputs_to_search [0]) ;
		    }

		    dynamic = FALSE ;

		    if (num_inputs == 0)
		    {
			input_sys_prop[0] = NULL ; 
			input_log_prop[0] = NULL ; 
		    }
		}

	    }

            if (dynamic == FALSE)
	    {
		for (i = MAX_ALGORITHM_ARITY; --i >= 0; )
		{
		    ptr_to_input_ret_pele [i] = NULL ;
		    ptr_to_input_ret_cost [i] = NULL ;
		}
	    }
	    else
	    {
		for (i = num_inputs; --i >= 0; )
		{
		    ptr_to_input_ret_pele [i] = NULL ;
		    ptr_to_input_ret_cost [i] = NULL ;
		}
	    }

	    for (i = num_inputs; --i >= 0; )
	    {
		EQ_CLASS	*input_eq_class ;

	 	init_property_vec (&ptr_to_input_pv[i]) ; 
	 	ptr_to_input_pv_ptr[i] = &ptr_to_input_pv[i] ;  
		init_property_vec (&ptr_to_input_excl_pv[i]) ;
		ptr_to_input_excl_pv_ptr[i] = &ptr_to_input_excl_pv[i] ;
		ptr_to_input_ret_cost [i] = NULL ;
		ptr_to_input_ret_pele [i] = NULL ;

		if (which == ALGORITHM_IS_CURRENT && new_algorithm_or_enforcer == TRUE) 
		{
		    if ((input_depth[i].depth =
				 ptr_to_inputs_to_search[i] -> depth) == -1)
			input_depth[i].depth = find_depth (ptr_to_inputs_to_search[i]) ;

		    if (input_depth[i].depth + 1 > lele -> depth)
			lele -> depth = input_depth[i].depth + 1 ;	

		    input_depth[i].input_no = i ;
		}
		else if (which == ENFORCER_IS_CURRENT 
			    && new_algorithm_or_enforcer == TRUE) 
		{
		    ptr_to_input_sys_prop[i] = &(eq_class -> system_property) ; 
		    ptr_to_input_log_prop[i] = &(eq_class -> logical_property) ; 
		    ptr_to_inputs_to_search[i] = lele ;  
		}

	    }

	    if (which == ALGORITHM_IS_CURRENT && new_algorithm_or_enforcer == TRUE) 
	    {
		for (i = opt_arity[(int) (log_expr -> my_operator)]; --i >= 0; )
		{
		    EQ_CLASS        *input_eq_class ;
		    get_eq_class_addr (ssa, log_expr -> input[i] -> eq_class_index,
                                       &input_eq_class) ;
		    ptr_to_input_sys_prop[i] = &(input_eq_class -> system_property) ;
                    ptr_to_input_log_prop[i] = &(input_eq_class -> logical_property) ;
		}
	    }

	    if (new_algorithm_or_enforcer == TRUE) 
	    {
		if (which == ALGORITHM_IS_CURRENT) 
		{
#if defined(__cplusplus) || defined (ANSI)
		    if (num_inputs > 1) 
			qsort ((void **) &(input_depth[0]), num_inputs,
				sizeof (INPUT_DEPTH), 
                                (int (*) (void *, void *)) compare_depth) ;
#else
			qsort ((char *) &(input_depth[0]), num_inputs,
				sizeof (INPUT_DEPTH), 
                                compare_depth) ;
#endif
		}

		CALL (estimate_cost (algorithm_or_enforcer, 
					&(test_algorithm_return.algorithm_argument),
					&(eq_class -> system_property),
					&(eq_class -> logical_property),
					&ptr_to_input_sys_prop[0],			    
					&ptr_to_input_log_prop[0],			    
					needed_pv, 
					(PROPERTY_VECTOR *) NULL,
					(PROPERTY_VECTOR **) NULL,
					&cost_estimate)) ;
	    }

	    copy_cost (&algorithm_cost, &cost_estimate) ;
           
	    subtract_cost (&min_cost, &algorithm_cost, &remaining_cost_limit) ;
	   
	    copy_cost (&current_plan_cost, &algorithm_cost) ;

/*
            if (algorithm_cost.cost.io < 0)
               algorithm_cost.cost.io = 0.0000000001;
*/

#if SAFETY>=1
	    compare_cost (&algorithm_cost, &zero_cost, &cost_compare) ; 
	    
	    if (cost_compare == LESS_THAN)
	    {
		printi ("Algorithm = ") ; print_algorithm (algorithm_or_enforcer) ;
		FAIL (ERR_INVALID_VALUE) ;
	    }
#endif

#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		printi ("L%d opt: Cost estimate :\n", level) ; 
		increment_indent(opt_indent) ;
                print_cost (&algorithm_cost) ;
		decrement_indent(opt_indent) ;
		printi ("L%d opt: Remaining cost limit :\n", level) ; 
		increment_indent(opt_indent) ;
                print_cost (&remaining_cost_limit) ;
		decrement_indent(opt_indent) ;
		printi ("L%d opt: Current plan cost :\n", level) ; 
		increment_indent(opt_indent) ;
                print_cost (&current_plan_cost) ;
		decrement_indent(opt_indent) ;
		printi ("L%d opt: Current minimum cost :\n", level) ; 
		increment_indent(opt_indent) ;
                print_cost (&min_cost) ;
		decrement_indent(opt_indent) ;
	    }
#endif

           /* changed 11-09-92 */
           /* compare_cost (&current_plan_cost, cost_limit, &cost_compare) ; */
            compare_cost (&current_plan_cost, &min_cost, &cost_compare) ; 
	   
	    if (cost_compare == GREATER_THAN || cost_compare == EQUAL_TO) 
	    {
#if DEBUG>=1
		if (trace == TRACE_ON)
		{
		    printi (
			"L%d opt: Estimated Algorithm cost >= current minimum cost, abandon algorithm\n",
                             level) ;
		}
#endif
		optimization_possible = TRUE ;

	    }
	    else /* More remaining cost. */
	    {
		OPT_RETURN_VALUE	input_opt_flag =
					 OPTIMIZATION_SUCCESSFUL;
		if (which == ALGORITHM_IS_CURRENT || which == ENFORCER_IS_CURRENT)
		{ 
		    int 	cost_failures, failures ;

		    cost_failures = 0 ;
		    failures = 0 ;

#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			if (which == ALGORITHM_IS_CURRENT)
			{
			    printi 
			      ("L%d opt: Algorithm used, more remaining cost, so will optimize inputs\n",
				level) ;
			}
			else 
			{
			    printi 
			      ("L%d opt: Enforcer used, more remaining cost, so will optimize inputs\n",
				level) ;
			}
		    }
#endif
		    for (j = num_inputs; --j >= 0; )
		    {
			if (which == ALGORITHM_IS_CURRENT)
			    i = input_depth[j].input_no ;
			else if (which == ENFORCER_IS_CURRENT)
			    i = j ;
			else
			{
			    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
			}
			if (ptr_to_inputs_to_search[i] != NULL)
			{
			    compare_cost (cost_limit, &current_plan_cost,
					  &cost_compare) ; 
			    if (cost_compare == GREATER_THAN) 
			    {
				BOOLEAN	fail ;

				fail = FALSE ;
				CALL (get_input_pv (algorithm_or_enforcer, 
					&(test_algorithm_return.algorithm_argument),
					needed_pv, excl_pv, i, process_input_count, 
					&ptr_to_input_pv_ptr[0], &ptr_to_input_excl_pv_ptr[0],
					&(ptr_to_input_sys_prop[0]), &(ptr_to_input_log_prop[0]),
					ptr_to_input_ret_pele, ptr_to_input_ret_cost,
					&fail)) ;

				if (fail != TRUE) /* DBI aborted search */
				{
#if DEBUG>=1
				    if (trace == TRACE_ON)
				    {
					printi ("L%d opt: Optimizing input %d\n", level, i) ;
				    }
#endif

				    CALL (find_best_plan
					     (&(ptr_to_inputs_to_search[i] -> expr),
					      ptr_to_inputs_to_search[i],
					      ptr_to_input_pv_ptr[i], 
					      PV_EQUAL, 
					      ptr_to_input_excl_pv_ptr[i],
					      PV_EXCL_TRUE,
					      &remaining_cost_limit,
					      ptr_to_inputs_to_search[i] -> eq_class_index,
					      ssa -> base_eq_class_table[ptr_to_inputs_to_search[i]
							     -> eq_class_index].eq_ptr,
					      rule_group,
					      ssa,
					      &(ptr_to_input_opt_return[i])
					 )
				      ) ;

#if DEBUG>=1
				    if (trace == TRACE_ON)
				    {
					printi (
				 	  "L%d opt: Returned from search of input %d:\n", 
						 level, i) ;
				    }
#endif
				}
				else
				{
				    ptr_to_input_opt_return[i].reason 
					= OPTIMIZATION_NOT_POSSIBLE;
				    ptr_to_input_opt_return[i].error = OPTIMIZATION_FAILED ;
#if DEBUG>=1
				    if (trace == TRACE_ON)
				    {
					printi (
				 	  "L%d opt: Will fail on input %d\n", 
						 level, i) ;
					printi (
					  "         DBI get_input_pv function signaled failure.\n") ;
				    }
#endif
				}
			    }
			    else
			    {
				ptr_to_input_opt_return[i].reason = COST_LIMIT_EXCEEDED;
				ptr_to_input_opt_return[i].error = OPTIMIZATION_FAILED ;
#if DEBUG>=1
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: No more cost, did not search input %d:\n", 
                                             level, i) ;
				}
#endif
			    }

			   /* If optimization of input failed, record failure  */
			   /* and abandon search.                              */
			    if (ptr_to_input_opt_return[i].error == OPTIMIZATION_FAILED)
			    {
#if DEBUG>=1
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Search of input %d FAILED.\n", level, i) ;
				    printi ("L%d opt: Reason: ", level) ; 
				    print_failure_reason (ptr_to_input_opt_return[i].reason) ;
				}
#endif
				input_opt_flag = OPTIMIZATION_FAILED ;
				++failures ;
				if (ptr_to_input_opt_return[i].reason 
					!= OPTIMIZATION_NOT_POSSIBLE)
				    ++cost_failures ;
				ptr_to_input_pv_ptr[i] = NULL ;
				ptr_to_input_ret_pele[i] = NULL ;
				ptr_to_input_ret_cost[i] = NULL ;
				break ;
			    }  /* if */
			    else  /*  search on input successful */
			    {
#if DEBUG>=1
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Search of input %d SUCCESSFUL.\n", 
                                             level, i) ;
				}
#endif
#if SAFETY>=1
			       /* Make sure returned pv covers needed pv. */
				compare_property_vec 
				       (&(ptr_to_input_opt_return[i].pele -> property_vector),
				    ptr_to_input_pv_ptr[i],
				    &(eq_class -> system_property),
				    &(eq_class -> logical_property),
				    &test_pv_compare) ;

				if (test_pv_compare != PV1_COV_PV2
				    && test_pv_compare != PV_EQUAL)
				{
				    printi ("Property vector:\n") ;
				    increment_indent(opt_indent) ;
				    print_property_vec (
				      &(ptr_to_input_opt_return[i].pele->property_vector)) ;
				    decrement_indent(opt_indent) ;
				    printi (
				       "        does not cover or equal property vector\n") ;
				    increment_indent(opt_indent) ;
				    print_property_vec (ptr_to_input_pv_ptr[i]) ;
				    decrement_indent(opt_indent) ;
				    FAIL (ERR_SANITY_CHECK) ;
				}
				if (ptr_to_input_opt_return[i].pele == NULL)
				{
				    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
				}
#endif

				subtract_cost (&remaining_cost_limit,  
				       &(ptr_to_input_opt_return[i].pele -> expr -> cost),
					       &remaining_cost_limit) ;
				add_cost (&current_plan_cost, 
					  &(ptr_to_input_opt_return[i].pele -> expr -> cost),
					  &current_plan_cost) ;
#if DEBUG>=1
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Remaining cost limit now :\n", 
                                             level) ; 
				    increment_indent(opt_indent) ;
				    print_cost (&remaining_cost_limit) ;	
				    decrement_indent(opt_indent) ;
				    printi ("L%d opt: Return cost now :\n", 
                                             level) ; 
				    increment_indent(opt_indent) ;
				    print_cost (&current_plan_cost) ;	
				    decrement_indent(opt_indent) ;
				}
#endif
				compare_cost (&current_plan_cost, cost_limit,
						 &cost_compare) ; 

			       /* Let user decide if current plan cost beats limit - was a sanity check. */
				if (cost_compare == GREATER_THAN || cost_compare == EQUAL_TO) 
				{
				    ++failures ;
				    ++cost_failures ;
				    input_opt_flag = OPTIMIZATION_FAILED ;
#if DEBUG>=1
				    if (trace == TRACE_ON)
					{
					    printi (
                                              "L%d opt: Failing on input %d:\n", level, i) ;
					    printi (
                                              "         Even though input was successfully\n") ;
					    printi (
				  	      "         optimized, return cost > cost limit\n");
					    printi (
				  	      "         Check cost calculations???\n");
					    printi ("L%d opt: Cost limit :\n", 
						     level) ; 
					    increment_indent (opt_indent) ;
					    print_cost (cost_limit) ;	
					    decrement_indent (opt_indent) ;
					    printi ("L%d opt: Return cost now :\n", 
						     level) ; 
					    increment_indent (opt_indent) ;
					    print_cost (&current_plan_cost) ;	
					    decrement_indent (opt_indent) ;
					}
#endif
				    break ;
				}

				ptr_to_input_pv_ptr[i] =
				   &(ptr_to_input_opt_return[i].pele -> property_vector) ;
				ptr_to_input_ret_pele[i] = ptr_to_input_opt_return[i].pele ;
				ptr_to_input_ret_cost[i] = &(ptr_to_input_opt_return[i].pele -> expr -> cost) ;

			    } /* else search on input successful */

			}  /* if */
			else /* input is NULL */
			{
			    /* input is null so skip it */ 
			}
				    
		    }  /* for to loop over inputs */
		    if (cost_failures == failures)
			optimization_possible = TRUE ;
		}  /* if algorithm or enforcer used */

                compare_cost (&current_plan_cost, &min_cost, &cost_compare) ;

	       /* Check to see if beat best plan found so far. */
	        if (input_opt_flag == OPTIMIZATION_SUCCESSFUL 
			&&	
		    (cost_compare == LESS_THAN)) 
			 /* || (cost_compare == EQUAL_TO && plan_found == FALSE))) */
		{
		    PROPERTY_VECTOR		derived_pv ;
		    PHY_EXPR_LIST_ELEM		*needed_pele = NULL ;
		    PHY_EXPR_LIST_ELEM		*derived_pele = NULL ;
		    PHY_EXPR			*temp_phy_expr ;
		    PV_EXCL_COMPARE		test_excl_pv_compare ;
		    PV_COMPARE			derived_and_needed_pv_comp ;
		    REG int			k ;

#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi ("L%d opt: Optimization successful.\n",
                                             level) ;
			printi ("         Will derive property vector.\n") ;
		    }
#endif


		   /* derive new property vector */
		    CALL (derive_phy_prop (algorithm_or_enforcer,
				&(test_algorithm_return.algorithm_argument),	
				&ptr_to_input_pv_ptr[0],
				&(eq_class -> system_property),
				&(eq_class -> logical_property),
				&ptr_to_input_sys_prop[0],
				&ptr_to_input_log_prop[0],
				needed_pv,
				&(derived_pv))) ;

#if SAFETY>=1
		   /* Make sure derived pv covers needed pv. */
		    compare_property_vec 
			   (&(derived_pv),
			    needed_pv, 
			    &(eq_class -> system_property),
			    &(eq_class -> logical_property),
			    &test_pv_compare) ;

                    if (test_pv_compare != PV_EQUAL
                        && test_pv_compare != PV1_COV_PV2)
		    {
			printi ("Property vector:\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (
			    &(derived_pv)) ;
			decrement_indent(opt_indent) ;
			printi (
			   "        does not cover or equal property vector\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (needed_pv) ;
			decrement_indent(opt_indent) ;
			FAIL (ERR_SANITY_CHECK) ;
		    }

		    derived_and_needed_pv_comp = test_pv_compare ;

		   /* Make sure derived pv excludes excl pv. */
		    compare_excl_property_vec 
			   (&(derived_pv),
			    excl_pv,
			    &(eq_class -> system_property),
			    &(eq_class -> logical_property),
			    &test_excl_pv_compare) ;

                    if (test_excl_pv_compare != PV_EXCL_TRUE)
		    {
			printi ("Property vector:\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (
			    &(derived_pv)) ;
			decrement_indent(opt_indent) ;
			printi (
			   "         does not exclude property vector\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (excl_pv) ;
			decrement_indent(opt_indent) ;
			printi ("         Need property vector:\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (needed_pv) ;
			decrement_indent(opt_indent) ;
			FAIL (ERR_SANITY_CHECK) ;
		    }
#endif

		    if (test_algorithm_return.reestimate_cost == TRUE)
		    {

#if DEBUG>=1
			if (trace == TRACE_ON)
			{
			    printi ("L%d opt: Will reestimate cost.\n",
						 level) ;
			}
#endif

			subtract_cost (&current_plan_cost, &cost_estimate, 
				       &current_plan_cost) ;

			CALL (estimate_cost (algorithm_or_enforcer, 
						&(test_algorithm_return.algorithm_argument),
						&(eq_class -> system_property),
						&(eq_class -> logical_property),
						&ptr_to_input_sys_prop[0],
						&ptr_to_input_log_prop[0],
						needed_pv, 
						&(derived_pv),
						&ptr_to_input_pv_ptr[0],
						&cost_estimate)) ;

			add_cost (&current_plan_cost, &cost_estimate, 
				       &current_plan_cost) ;

			subtract_cost (&min_cost, &current_plan_cost, 
				   &remaining_cost_limit) ;

#if DEBUG>=1
			if (trace == TRACE_ON)
			{
			    printi ("L%d opt: Re-estimated cost :\n", level) ;
			    increment_indent(opt_indent) ;
			    print_cost (&cost_estimate) ;
			    decrement_indent(opt_indent) ;
			    printi ("L%d opt: New current plan cost :\n", level) ;
			    increment_indent(opt_indent) ;
			    print_cost (&current_plan_cost) ;
			    decrement_indent(opt_indent) ;
			    printi ("L%d opt: Minimum cost :\n", level) ;
			    increment_indent(opt_indent) ;
			    print_cost(&min_cost);
			    decrement_indent(opt_indent) ;
			    printi ("L%d opt: Remaining cost limit :\n", level) ;
			    increment_indent(opt_indent) ;
			    print_cost(&remaining_cost_limit);
			    decrement_indent(opt_indent) ;
			    printi ("L%d opt: Original cost limit :\n", level) ;
			    increment_indent(opt_indent) ;
			    print_cost(cost_limit);
			    decrement_indent(opt_indent) ;
			}      
#endif
     
			compare_cost (&current_plan_cost, cost_limit, &cost_compare) ;
		       
			if (cost_compare == GREATER_THAN || cost_compare == EQUAL_TO)
			{
#if DEBUG>=1
			    if (trace == TRACE_ON)
			    {
				printi (
				 "L%d opt: Reestimated cost >= cost limit, abandon algorithm\n",
					 level) ;
			    }
#endif
			    input_opt_flag = OPTIMIZATION_FAILED ;
			    cost_compare = GREATER_THAN ;
			}
		    }  /* if re-estimate cost */

		    if (input_opt_flag == OPTIMIZATION_SUCCESSFUL)
		    {

			plan_found = TRUE ;
			optimization_possible = TRUE ;

#ifdef USE_MACROS
			mfind_phy_expr_list_elem (eq_class, 
				(PHY_EXPR_LIST_ELEM *) NULL, &(derived_pv),
				excl_pv, &derived_pele) ; 
#else
			CALL (find_phy_expr_list_elem (ssa, eq_class_index,
				    (PHY_EXPR_LIST_ELEM *) NULL, &(derived_pv),
				    PV_EQUAL, excl_pv, PV_EQUAL, PV_EXCL_NOT_SET,
				    (COST *) NULL, COMPARE_NOT_SET, 
				    &derived_pele)) ;
#endif

#if SAFETY>=1
			if (derived_pele)
			{
#ifdef USE_MACROS
			    mfind_phy_expr_list_elem (eq_class, 
				derived_pele, &(derived_pv),
				excl_pv, &temp_pele) ; 
#else
			    CALL (find_phy_expr_list_elem (ssa, eq_class_index,
				    derived_pele, &(derived_pv),
				    PV_EQUAL, excl_pv, PV_EQUAL, PV_EXCL_NOT_SET,
				    (COST *) NULL, COMPARE_NOT_SET, 
				    &temp_pele)) ;
#endif
			    if (temp_pele) 
			    {
				FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
			    }
			}
#endif

			if (derived_pele == NULL 
				    || 
			    derived_pele -> expr == NULL)
			{

#if DEBUG>=2
			    if (trace == TRACE_ON)
			    {
				if (!derived_pele) 
				{
				    printi ("L%d opt: Entry with these properties does\n",
							 level) ;
				    printi ("         not exist.\n") ;
				}
				else
				{
				    printi ("L%d opt: Entry with these properties does\n",
							 level) ;
				    printi ("         exist but no plan exists.\n") ;
				}
				printi ("         Allocating storage for new plan.\n") ;
			    }
#endif

			    allocate_phy_expr (temp_phy_expr) ;

			    temp_phy_expr -> algorithm = algorithm_or_enforcer ;
			    copy_algorithm_arg (&(temp_phy_expr -> algorithm_argument),
					    &(test_algorithm_return.algorithm_argument)) ;	
			    copy_cost (&(temp_phy_expr -> cost), &current_plan_cost) ;

			    for (k = MAX_ALGORITHM_ARITY; --k >= 0; )
			    {
				if (k < num_inputs)
				    temp_phy_expr -> input[k] 
					= ptr_to_input_opt_return[k].pele ;
				else
				    temp_phy_expr -> input[k] = NULL ;
			    }

			    if (derived_pele == NULL)
			    {
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Inserting new node for derived properties.\n",
							     level) ;
				}
#endif
				CALL (insert_phy_expr_list_elem (ssa, eq_class_index,
					&(derived_pv), excl_pv, temp_phy_expr,
					NO_COPY, lele, &derived_pele)) ;
				derived_pele -> progress_flag = INITIALIZED_ONLY ;
			    }
			    else
			    {
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Inserting new plan.\n",
							     level) ;
				} 
#endif
				derived_pele -> expr = temp_phy_expr ;
				derived_pele -> lele = lele ;
				++ (derived_pele -> expr -> ref_count) ;
			    }

			    derived_pele -> expr -> derived_pele = derived_pele ;

#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Will check for dominated plans.\n",
							     level) ;
				} 
#endif
			    for (temp_pele = eq_class -> phy_expr_list.first;
				    temp_pele != NULL; temp_pele = temp_pele -> next)
			    {
				if (temp_pele == derived_pele) continue ;
	    
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Checking pele:\n") ;
				    CALL (print_phy_expr_list_elem (temp_pele)) ;
				} 
#endif
				if (temp_pele -> expr)
				{
				    compare_cost (&(derived_pele -> expr -> cost),
						  &(temp_pele -> expr -> cost),
						  &cost_compare) ; 
				}
				else
				    cost_compare = LESS_THAN ;

				if (cost_compare == LESS_THAN || cost_compare == EQUAL_TO)
				{ 
				    PV_COMPARE	temp_pv_compare ;
				    compare_property_vec (&(derived_pele -> property_vector),
					    &(temp_pele -> property_vector), 
					    &(eq_class -> system_property), 
					    &(eq_class -> logical_property), 
					    &(temp_pv_compare)) ;	

				    if (temp_pv_compare == PV1_COV_PV2)
				    {
					compare_property_vec 
					    (&(derived_pele -> excl_property_vector),
						&(temp_pele -> excl_property_vector), 
						&(eq_class -> system_property), 
						&(eq_class -> logical_property), 
						&(temp_pv_compare)) ;	

					if (temp_pv_compare == PV1_COV_PV2)
					{
#if DEBUG>=2
					    if (trace == TRACE_ON)
					    {
						printi ("L%d opt: pele dominated will modify.\n") ;
					    } 
#endif
#ifdef USE_MACROS
					    mmodify_dominated_pele (temp_pele, 
								derived_pele -> expr,
								lele) ;
#else
					    CALL (modify_dominated_pele (ssa, temp_pele, 
								derived_pele -> expr,
								lele)) ;
#endif
					}
					    
				    }
				}
			    }
			}  /* no derived_pele or derived_pele expr == NULL */
			else  /* derived already exists and expr. not null */
			{
#if DEBUG>=2
			    if (trace == TRACE_ON)
			    {
				printi ("L%d opt: Entry with these properties does\n",
						     level) ;
				printi ("         exist and plan exists.\n") ;
			    }
#endif
			    compare_cost (&(derived_pele -> expr -> cost),
					  &(current_plan_cost),
					  &cost_compare) ; 

			    if (cost_compare == LESS_THAN)
			    {
				printi (
				 "Error detected: Plan already in storage with cost :\n") ;
				increment_indent(opt_indent) ;
				print_cost (&(derived_pele -> expr -> cost)) ;
				decrement_indent(opt_indent) ;
				printi (" and property vector \n")  ;
				increment_indent(opt_indent) ;
				print_property_vec (&(derived_pele -> property_vector)) ;
				decrement_indent(opt_indent) ;
				printi (" and is less than current plan cost :\n") ;
				increment_indent(opt_indent) ;
				print_cost (&(current_plan_cost)) ;
				decrement_indent(opt_indent) ;
				printi ("for currently derived property vector\n") ;
				increment_indent(opt_indent) ;
				print_property_vec (&(derived_pv)) ;
				decrement_indent(opt_indent) ;
#ifdef GET_STATS
				printi ("Calls to optimize = %d\n", 
						ssa -> calls_to_optimize) ;
#endif
				printi ("Current equivalence class : %d\n", 
						eq_class_index) ;
				FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ; 
			    }
			    
			    if (derived_pele -> expr -> ref_count == 1)
			    {
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Ref count of existing plan = 1.\n",
							 level) ;
				    printi ("         Will overwrite plan.\n") ;
				}
#endif
				derived_pele -> expr -> algorithm = algorithm_or_enforcer ;
				derived_pele -> lele = lele ;
				copy_algorithm_arg (&(derived_pele -> expr -> algorithm_argument),
						&(test_algorithm_return.algorithm_argument)) ;	
				copy_cost (&(derived_pele -> expr -> cost), &current_plan_cost) ;

				for (k = MAX_ALGORITHM_ARITY; --k >= 0; )
				{
				    if (k < num_inputs)
					derived_pele -> expr -> input[k] 
					    = ptr_to_input_opt_return[k].pele ;
				    else
					derived_pele -> expr -> input[k] = NULL ;
				}

				derived_pele -> expr -> derived_pele = derived_pele ;
			    }
			    else
			    {
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Ref count of existing plan > 1.\n",
							 level) ;
				    printi ("         Will modify all dominated nodes.\n") ;
				}
#endif
				allocate_phy_expr (temp_phy_expr) ;

				temp_phy_expr -> algorithm = algorithm_or_enforcer ;
				copy_algorithm_arg (&(temp_phy_expr -> algorithm_argument),
						&(test_algorithm_return.algorithm_argument)) ;	
				copy_cost (&(temp_phy_expr -> cost), &current_plan_cost) ;

				for (k = MAX_ALGORITHM_ARITY; --k >= 0; )
				{
				    if (k < num_inputs)
					temp_phy_expr -> input[k] 
					    = ptr_to_input_opt_return[k].pele ;
				    else
					temp_phy_expr -> input[k] = NULL ;
				}

#ifdef USE_MACROS
				mmodify_dominated_pele (derived_pele, 
						    temp_phy_expr, lele) ;
#else
				CALL (modify_dominated_pele (ssa, derived_pele, 
							temp_phy_expr, lele)) ;
#endif

#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Modified derived pele.\n",
							 level) ;
				}
#endif
			       /*
				derived_pele -> progress_flag = INITIALIZED_ONLY ;
                               */
				derived_pele -> expr -> derived_pele = derived_pele ;

				for (temp_pele = eq_class -> phy_expr_list.first;
					temp_pele != NULL; temp_pele = temp_pele -> next)
				{
				    if (temp_pele == derived_pele) continue ;
		
#if DEBUG>=2
				    if (trace == TRACE_ON)
				    {
					printi ("L%d opt: Checking pele:\n") ;
					CALL (print_phy_expr_list_elem (temp_pele)) ;
				    }
#endif
				    if (temp_pele -> expr)
				    {
					compare_cost (&(derived_pele -> expr -> cost),
						      &(temp_pele -> expr -> cost),
						      &cost_compare) ; 
				    }
				    else
					cost_compare = LESS_THAN ;

				    if (cost_compare == LESS_THAN || cost_compare == EQUAL_TO)
				    { 
					PV_COMPARE	temp_pv_compare ;
					compare_property_vec 
					    (&(derived_pele -> property_vector),
						&(temp_pele -> property_vector), 
						&(eq_class -> system_property), 
						&(eq_class -> logical_property), 
						&(temp_pv_compare)) ;	

					if (temp_pv_compare == PV1_COV_PV2)
					{
					    compare_property_vec 
						(&(derived_pele -> excl_property_vector),
						    &(temp_pele -> excl_property_vector), 
						    &(eq_class -> system_property), 
						    &(eq_class -> logical_property), 
						    &(temp_pv_compare)) ;	

					   /* added equal comparison 11-4-92 */
					    if (temp_pv_compare == PV1_COV_PV2 || 
						temp_pv_compare == PV_EQUAL)
					    {
#if DEBUG>=2
						if (trace == TRACE_ON)
						{
						    printi ("L%d opt: pele dominated will modify.\n") ;
						}
#endif

#ifdef USE_MACROS
						mmodify_dominated_pele (temp_pele, 
								    derived_pele -> expr,
								    lele) ;
#else
						CALL (modify_dominated_pele (ssa, temp_pele, 
								derived_pele -> expr,
								lele)) ;
#endif
					    }
					    
					}
				    }
				}
			    }
			}

			if (derived_and_needed_pv_comp != PV_EQUAL)
			{
#ifdef USE_MACROS
			    mfind_phy_expr_list_elem (eq_class, 
				(PHY_EXPR_LIST_ELEM *) NULL, needed_pv,
				excl_pv, &needed_pele) ; 
#else
			    CALL (find_phy_expr_list_elem (ssa, eq_class_index,
				    (PHY_EXPR_LIST_ELEM *) NULL, needed_pv,
				    PV_EQUAL, excl_pv, PV_EQUAL, PV_EXCL_NOT_SET,
				    (COST *) NULL, COMPARE_NOT_SET, 
				    &needed_pele)) ;
#endif



			    if (needed_pele)
			    {
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: Needed pele already exists.\n") ;
				}
#endif

#if SAFETY>=1
#ifdef USE_MACROS
				mfind_phy_expr_list_elem (eq_class, 
							    needed_pele, needed_pv,
							    excl_pv, 
							    &temp_pele) ; 
#else
				CALL (find_phy_expr_list_elem (ssa, eq_class_index,
								needed_pele, needed_pv,
								PV_EQUAL, excl_pv, PV_EQUAL,
								PV_EXCL_NOT_SET,
								(COST *) NULL, COMPARE_NOT_SET, 
								&temp_pele)) ;
#endif
				if (temp_pele) 
				{
				    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
				}
#endif
			    }
			    else  /* no needed_pele */
			    {
#if DEBUG>=2
				if (trace == TRACE_ON)
				{
				    printi ("L%d opt: No needed pele exists. Will insert.\n") ;
				}
#endif

				CALL (insert_phy_expr_list_elem (ssa, eq_class_index,
								    needed_pv,
								    excl_pv, 
								    derived_pele -> expr,
								    NO_COPY,
								    lele, 
								    &needed_pele)) ;
			    }
			}

		       /* Set return values. */
			if (derived_pele == NULL)
			{
			    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
			}

			if (derived_pele -> expr -> derived_pele == NULL)
			{
			    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
			}

			opt_return -> pele = derived_pele -> expr -> derived_pele ;
			opt_return -> error = OPTIMIZATION_SUCCESSFUL ;
			opt_return -> reason = REASON_NOT_SET ;

			copy_cost (&min_cost, &current_plan_cost) ;

#ifdef GET_STATS
			if (first_call == TRUE && plan_yet == FALSE)
			{
			    copy_cost (&first_plan_cost, &current_plan_cost) ;
			    plan_yet = TRUE ;
			}
#endif
		    } /* if input_opt_flag == OPTIMIZATION_SUCCESSFUL
			 for re-estimation or no re-estimation */
		    
		}  /* if to check current_plan_cost < min_cost */
		else 
		{
		    if (input_opt_flag == OPTIMIZATION_SUCCESSFUL)
		    {
			optimization_possible = TRUE ;
#if DEBUG>=1
			if (trace == TRACE_ON)
			{
			    printi 
			     ("L%d opt: Optimization successful but did not beat minimum cost.\n",
                              level) ;
			}
#endif
		    }
		    else
		    {
#if DEBUG>=1
			if (trace == TRACE_ON)
			{
			    printi ("L%d opt: Optimization failed.\n", level) ;
			}
#endif
		    }
		}  /* else did not beat minimum or optimization failed */
	    }  /* else more remaining cost */
            
        }  /* if to see if algorithm applies */

       /* Get next algorithm or enforcer. */
	
	if (test_algorithm_return.apply_truth_value == FALSE
	    || (++process_input_count) == test_algorithm_return.process_input_count)
	{
	    process_input_count = 0 ;
	    new_algorithm_or_enforcer = TRUE ;

	    if (dynamic == TRUE)
	    {
		deallocate (ptr_to_input_opt_return) ;
		deallocate (ptr_to_input_pv_ptr) ;
		deallocate (ptr_to_input_pv) ;
		deallocate (ptr_to_input_excl_pv_ptr) ;
		deallocate (ptr_to_input_excl_pv) ;
		deallocate (ptr_to_input_log_prop) ;
		deallocate (ptr_to_input_sys_prop) ;
		deallocate (ptr_to_inputs_to_search) ;
	    }

	    if (which == ALGORITHM_IS_CURRENT)
	    {
		init_algorithm_arg ( &(test_algorithm_return.algorithm_argument) ) ;
		CALL (match_impl_rule (lele, log_expr, rule_group, ssa,
					++count, 
					&inputs_to_search[0], 
					&algorithm_or_enforcer, 
					&(test_algorithm_return.algorithm_argument),
					&count)) ;

		if (algorithm_or_enforcer == (ALGORITHM) NO_MORE)
		{
		    which = ENFORCER_IS_CURRENT ;
		    count = -1 ;
		}
	    }
	    if (which == ENFORCER_IS_CURRENT)
	    {
		CALL (get_enforcer (++count, &algorithm_or_enforcer)) ; 
	    }
	}
	else
	    new_algorithm_or_enforcer = FALSE ;

    }  /* while to get algorithm or enforcer */ 

   /* Find best plan for all transformations. */
    if (eq_class -> trans_flag != TRANSFORMATIONS_COMPLETE)
    {
	FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

       /*
	if (eq_class -> trans_flag != NO_TRANSFORMATIONS)
	{
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	}

	CALL (generate_all_transformations (lele, rule_group, ssa)) ;
       */
    }

    mark_complete_on_exit = FALSE ;

#ifdef USE_MACROS
    mfind_phy_expr_list_elem (eq_class, 
	(PHY_EXPR_LIST_ELEM *) NULL, needed_pv,
	excl_pv, &temp_pele) ; 
#else
    CALL (find_phy_expr_list_elem (ssa, eq_class_index,
	    (PHY_EXPR_LIST_ELEM *) NULL, needed_pv,
	    PV_EQUAL, excl_pv, PV_EQUAL, PV_EXCL_NOT_SET,
	    (COST *) NULL, COMPARE_NOT_SET, 
	    &temp_pele)) ;
#endif

    if (temp_pele == NULL || temp_pele -> progress_flag == COMPLETE || 
		temp_pele -> progress_flag == INITIALIZED_ONLY)
    {

	if (temp_pele == NULL)
	{
	    CALL (insert_phy_expr_list_elem (ssa, eq_class_index,
			needed_pv, excl_pv, (PHY_EXPR *) NULL,
			NO_COPY, lele, &temp_pele)) ;
	    temp_pele -> progress_flag = IN_PROGRESS ;
	    temp_progress_flag = IN_PROGRESS ;
	}
	else
	{
	    temp_progress_flag = temp_pele -> progress_flag ;
	    cost_compare = GREATER_THAN ;

	    if (temp_pele -> failure_exists == TRUE)
	    {

#if SAFETY>=1
		if (temp_pele -> fail_reason == OPTIMIZATION_NOT_POSSIBLE)
		{
#ifdef PRINT
		    printi ("fail node:\n") ;
		    CALL (print_phy_expr_list_elem (temp_pele)) ;
#endif
                    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
                }
#endif

		if (cost_not_set (&(temp_pele -> fail_cost)))
		{
		    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
		}

		compare_cost (&(temp_pele -> fail_cost), cost_limit, &cost_compare) ;

#if SAFETY>=1
		if (cost_compare == GREATER_THAN)
		{
#ifdef PRINT
		    printi ("fail node:\n") ;
		    CALL (print_phy_expr_list_elem (temp_pele)) ;
		    printi ("current cost limit = ") ; print_cost (cost_limit) ;
#endif
                    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
                }
#endif

	    }

	    if (temp_pele -> failure_exists == FALSE ||
		     cost_compare == LESS_THAN) 
	    {
		temp_pele -> progress_flag = IN_PROGRESS ;
	    }

	    if (temp_pele -> progress_flag == INITIALIZED_ONLY)
		temp_pele -> progress_flag = IN_PROGRESS ;
	}

	mark_complete_on_exit = TRUE ;
	ptr_to_input_opt_return = &(input_opt_return [0]) ;
	ptr_to_input_pv_ptr = &(input_pv_ptr [0]) ;
	ptr_to_input_pv = &(input_pv [0]) ;
	ptr_to_input_excl_pv_ptr = &(input_excl_pv_ptr [0]) ;
	ptr_to_input_excl_pv = &(input_excl_pv [0]) ;
	ptr_to_input_log_prop = &(input_log_prop [0]) ;
	ptr_to_input_sys_prop = &(input_sys_prop [0]) ;
	ptr_to_inputs_to_search = &(inputs_to_search [0]) ;
		
	for (temp_lele = eq_class -> log_expr_list.first ;
	     temp_lele != NULL ;
	     temp_lele = temp_lele -> next)
	{

	    if (temp_lele != lele)
	    {
	       /*
		if (temp_progress_flag == COMPLETE)
		{
	       */
#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi (
			    "L%d opt: Will call find_best_plan for\n",level) ;
			printi ("         next equivalent expression.\n") ; 
		       /*
			printi ("         next equivalent expression\n") ; 
			printi ("         since progress flag is COMPLETE.\n") ; 
		       */
		    }
#endif
		    CALL (find_best_plan
				 (&(temp_lele -> expr),
				  temp_lele,
				  needed_pv,
				  PV_EQUAL, 
				  excl_pv,
				  PV_EXCL_TRUE,
				  &min_cost,
				  eq_class_index,
				  eq_class,
				  rule_group,
				  ssa,
				  &(ptr_to_input_opt_return[0])
				 )
			      ) ;
	       /*
		}
		else
		{

#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi ("L%d opt: Will call optimize for\n",level) ;
			printi ("         next equivalent expression\n") ;
			printi ("         since progress flag is not COMPLETE.\n") ; 
		    }
#endif
		    CALL (optimize (temp_lele, needed_pv,excl_pv,
				     &min_cost, eq_class_index, eq_class,
				     (PHY_EXPR_LIST_ELEM *) NULL,
				     rule_group, ssa, 
				     ptr_to_input_opt_return)) ;

#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi ("L%d opt: Returned from optimization of ",
				 level) ;
			printf ("equivalent expression.\n") ;
		    }
#endif
		}
	       */

	       /* If optimization of input failed, record failure  */
	       /* and abandon search.                              */
		if (ptr_to_input_opt_return[0].error == OPTIMIZATION_FAILED)
		{
#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi ("L%d opt: Optimization of transformation FAILED.\n",
                                level) ;
			printi ("L%d opt: Reason: ", level) ; 
			print_failure_reason (ptr_to_input_opt_return[0].reason) ;
		    }
#endif
		    if (ptr_to_input_opt_return[0].reason != OPTIMIZATION_NOT_POSSIBLE)
			optimization_possible = TRUE ;
		}  /* if */
		else  /*  optimization successful */
		{
#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi ("L%d opt: Optimization of transformation SUCCESSFUL.\n",
                                 level) ;
		    }
#endif
		    optimization_possible = TRUE ;

#if SAFETY>=1
		   /* Make sure returned pv covers needed pv. */
		    compare_property_vec 
			   (&(ptr_to_input_opt_return[0].pele -> property_vector),
				needed_pv,	
				&(eq_class -> system_property),
				&(eq_class -> logical_property),
				&test_pv_compare) ;

		    if (test_pv_compare != PV1_COV_PV2
			&& test_pv_compare != PV_EQUAL)
		    {
			printi ("Property vector:\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (
			    &(ptr_to_input_opt_return[0].pele->property_vector)) ;
			decrement_indent(opt_indent) ;
			printi (
			   "        does not cover or equal property vector\n") ;
			increment_indent(opt_indent) ;
			print_property_vec (needed_pv) ;
			decrement_indent(opt_indent) ;
			FAIL (ERR_SANITY_CHECK) ;
		    }
#endif

                    copy_cost (&current_plan_cost,
			       &(ptr_to_input_opt_return[0].pele -> expr -> cost)) ;
#ifdef GET_STATS
		    if (first_call == TRUE && plan_yet == FALSE)
		    {
			copy_cost (&first_plan_cost, &current_plan_cost) ;
			plan_yet = TRUE ;
		    }
#endif
#if DEBUG>=1
		    if (trace == TRACE_ON)
		    {
			printi ("L%d opt:   Return cost now :\n", level) ;
			increment_indent(opt_indent) ;
			print_cost (&current_plan_cost) ;	
			decrement_indent(opt_indent) ;
		    }
#endif
#if SAFETY>=1
		    compare_cost (&current_plan_cost, &min_cost, &cost_compare) ;
		    if (cost_compare == GREATER_THAN || cost_compare == EQUAL_TO)
		    {
			printi ("Current plan cost :\n") ; 
			increment_indent(opt_indent) ;
			print_cost (&current_plan_cost) ;
			decrement_indent(opt_indent) ;
			printi ("Minimum cost :\n") ; 
			increment_indent(opt_indent) ;
			print_cost (&min_cost) ;
			decrement_indent(opt_indent) ;
			FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
		    }
#endif
		    opt_return -> pele = ptr_to_input_opt_return[0].pele ;
		    opt_return -> error = OPTIMIZATION_SUCCESSFUL ;
		    opt_return -> reason = REASON_NOT_SET ;

		    copy_cost
			 (&min_cost, &current_plan_cost) ;

		} /* else optimization of transformation successful */

	    }  /* if transformation not = log. expr. passed to optimize */

	}  /* for all expr. in eq. class */

    }  /* if pv complete or not started */

    if (mark_complete_on_exit == TRUE) 
    {
       /* printi ("marked progress flag COMPLETE\n") ; */
	temp_pele -> progress_flag = COMPLETE ;
    }

    if (opt_return -> error == OPTIMIZATION_FAILED)
    {
	if (covering_plan)
	{
	    compare_cost (&(covering_plan -> expr -> cost),
			  cost_limit,
			  &cost_compare) ;

	    if (cost_compare != EQUAL_TO)
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }

#ifdef USE_MACROS
	    mmodify_dominated_pele (temp_pele, 
					covering_plan -> expr, 
					covering_plan -> lele) ;
#else
	    CALL (modify_dominated_pele (ssa, temp_pele, 
					    covering_plan -> expr, 
					    covering_plan -> lele)) ;
#endif

	    opt_return -> pele = covering_plan -> expr -> derived_pele ;
	    opt_return -> error = OPTIMIZATION_SUCCESSFUL ;
	    opt_return -> reason = USED_COVERING_PLAN ;
	    
	}
    }

   /* Mark cost bound if optimization failed. */
    if (opt_return -> error == OPTIMIZATION_FAILED)  
	
    {
        FAILURE_REASON		failure_reason ;

#if DEBUG>=1
	if (trace == TRACE_ON)
	{
	    printi ("L%d opt: Optimization failed.\n", level) ;
	}
#endif
    
        if (optimization_possible)
	{
	    failure_reason = COST_LIMIT_EXCEEDED ;
	    opt_return -> reason = OPTIMIZE_FAILED ;
	}
        else
	{
	    failure_reason = OPTIMIZATION_NOT_POSSIBLE ;
	    opt_return -> reason = OPTIMIZATION_NOT_POSSIBLE ;
	}

	if (mark_complete_on_exit == TRUE)
	{

#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		printi ("L%d opt: Will record failure.\n", level) ;
	    }
#endif

	    if (temp_pele -> failure_exists == TRUE)
	    {
		if (cost_not_set (&(temp_pele -> fail_cost)))
		{
		    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
		}

		if (temp_pele -> expr)
		{
		    compare_cost (&(temp_pele -> expr -> cost), cost_limit, &cost_compare) ;
		    if (cost_compare == LESS_THAN)
		    {
			FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
		    }
		}

		compare_cost (&(temp_pele -> fail_cost), cost_limit, &cost_compare) ;

		if ((failure_reason == COST_LIMIT_EXCEEDED 
			    && temp_pele -> fail_reason == COST_LIMIT_EXCEEDED
			    && cost_compare == LESS_THAN)
		    || failure_reason == OPTIMIZATION_NOT_POSSIBLE
		    || temp_pele -> fail_reason == OPTIMIZATION_NOT_POSSIBLE) 
		{
		    copy_cost (&(temp_pele -> fail_cost), cost_limit) ;
		}
	    }
	    else
	    {
		copy_cost (&(temp_pele -> fail_cost), cost_limit) ;
	    }

	    temp_pele -> fail_reason = failure_reason ;
	    temp_pele -> failure_exists = TRUE ;

#if DEBUG>=1
	    if (trace == TRACE_ON)
	    {
		printi ("L%d opt: Recorded failure.\n", level) ;
	    }
#endif  
  	} /* if (mark_complete_on_exit == TRUE) */ 
    }  /* if optimization failed */

    if (opt_return -> error == OPTIMIZATION_SUCCESSFUL) 
    {
	if (opt_return -> pele == NULL || opt_return -> pele -> expr == NULL)
	    FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;

	compare_cost (&(opt_return -> pele -> expr -> cost), cost_limit, &cost_compare) ;

	if (cost_compare == GREATER_THAN || cost_compare == EQUAL_TO)
	{
	    if (covering_plan == NULL)
	    {
		FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
	    }
	}

       /* changed 11-07-92 */
	if (mark_complete_on_exit == TRUE)
	    opt_return -> pele -> expr -> derived_pele -> progress_flag = COMPLETE ;

    }

#if DEBUG>=1
    if (trace == TRACE_ON)
    {
	if (covering_plan)
	{
	    printi ("L%d opt: covering_plan did exist\n", level) ;
	    printi ("L%d opt: needed_pv:\n", level) ;
	    increment_indent(opt_indent) ;
	    print_property_vec (needed_pv) ;
	    decrement_indent(opt_indent) ;
	    printi ("L%d opt: excl_pv:\n", level) ;
	    increment_indent(opt_indent) ;
	    print_property_vec (excl_pv) ;
	    decrement_indent(opt_indent) ;
	    printi ("L%d opt: covering plan:\n", level) ;
	    increment_indent(opt_indent-2) ;
	    CALL (print_phy_expr_list_elem (covering_plan)) ;
	    decrement_indent(opt_indent-2) ;
	}
	else 
	{
	    printi ("L%d opt: covering_plan did NOT exist\n", level) ;
	}
	printi ("L%d opt: exiting optimize\n", level) ;
    }
#endif

    return (OKAY) ;

} /* optimize */

#if defined(__cplusplus) || defined (ANSI)
static int find_depth (LOG_EXPR_LIST_ELEM *lele)
#else
static int find_depth (lele)
LOG_EXPR_LIST_ELEM	*lele ;
#endif
{
    int i, max, j ;
    if (lele == NULL)
	return (0) ;
    if (lele -> depth != -1) return (lele -> depth) ;
    max = -1 ;
    for (i = opt_arity[(int) (lele -> expr.my_operator)];
	 --i >= 0;)
	if (lele -> expr.input[i] != NULL)
	    if ((j = find_depth (lele -> expr.input[i])) > max) 
		max = j ; 
    return ((lele -> depth = max + 1)) ;
	
}

#if defined(__cplusplus) || defined (ANSI)
static int compare_depth (INPUT_DEPTH *i, INPUT_DEPTH *j)
#else
static int compare_depth (i, j)
INPUT_DEPTH	*i, *j ;
#endif
{
    return (i -> depth - j -> depth) ;
}
