#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "expr_str.h"
#include "global.h"

extern int indent_value ;
extern int              opt_arity[] ;

extern int              algo_arity[] ;

#if DEBUG>=1
extern TRACE            trace ;

#endif
#if defined(__cplusplus) || defined(ANSI)
extern char * error_text (int) ;
#else
char *error_text () ;
#endif
#if defined(__cplusplus) || defined(ANSI)
STATUS match_impl_rule(LOG_EXPR_LIST_ELEM *lele_in,
LOG_EXPR *log_expr, int rule_group,
STORAGE_SEG_ANCHOR *ssa,
int count,
LOG_EXPR_LIST_ELEM *inputs_to_search[],
ALGORITHM *algorithm_or_enforcer,
ALGORITHM_ARGUMENT *aa_param,
int *ret_count)
{
STATUS generate_all_transformations(LOG_EXPR_LIST_ELEM *,int,STORAGE_SEG_ANCHOR *) ;
#else
STATUS match_impl_rule(lele_in, log_expr, rule_group, ssa, count, inputs_to_search, algorithm_or_enforcer, aa_param, ret_count)
LOG_EXPR_LIST_ELEM	*lele_in ;
LOG_EXPR		*log_expr ;
int		rule_group ;
STORAGE_SEG_ANCHOR *ssa ;
LOG_EXPR_LIST_ELEM	*inputs_to_search[] ;
int		count, *ret_count ;
ALGORITHM		*algorithm_or_enforcer; 
ALGORITHM_ARGUMENT *aa_param; 

{
STATUS generate_all_transformations() ;
#endif
LOG_EXPR_LIST_ELEM	*lele[20] ;
OPERATOR		operator_array[20];
OPERATOR_ARGUMENT	*op_argument[20];
OPERATOR_ARGUMENT	temp_op_argument[20];
LOG_EXPR_LIST_ELEM	*input[40];
EQ_CLASS		*temp_eq_class ;
BOOLEAN			found_rule ;
int		i ;
STATUS                     error ;

#if SAFETY>=1
for (i = -1; ++i<opt_arity[(int) (log_expr->my_operator)];)
{
get_eq_class_addr(ssa,log_expr->input[i]->eq_class_index,
&temp_eq_class) ;
if (log_expr->input[i] != temp_eq_class->log_expr_list.first)
{printi ("Problem with input.\n") ;
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
}}
#endif

--count ;
for (;;)
{

try_rule:
switch (++count)
{
case (0):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
if (lele[0]->expr.input[1] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
if (op_argument[0]->join.type==OPER && op_argument[0]->join.data.op == AND_OP)
goto try_rule ;;
}
*algorithm_or_enforcer = MERGE_JOIN ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
inputs_to_search[1] = input[2] ;
found_rule = TRUE ;
*ret_count = 0 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (1):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
if (lele[0]->expr.input[1] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

{
if (op_argument[0]->join.type==OPER && op_argument[0]->join.data.op == AND_OP)
goto try_rule ;;
}
*algorithm_or_enforcer = HASH_JOIN ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
inputs_to_search[1] = input[2] ;
found_rule = TRUE ;
*ret_count = 1 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (2):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
if (lele[0]->expr.input[1] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

*algorithm_or_enforcer = NESTED_LOOP_JOIN ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
inputs_to_search[1] = input[2] ;
found_rule = TRUE ;
*ret_count = 2 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (3):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != JOIN)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
if (lele[0]->expr.input[1] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

get_eq_class_addr
(ssa,lele[0] -> expr.input[1]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[1] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[2]=temp_eq_class->log_expr_list.first;
lele[2] != NULL;
lele[2] = lele[2] -> next)
{operator_array[2] = lele[2] -> expr.my_operator;
if (operator_array[2] != GET_SET)
continue;
op_argument[2] = &(lele[2] -> expr.argument);
{
int i;
if (op_argument[0]->join.type==OPER && op_argument[0]->join.data.op == AND_OP)
		continue;
if (op_argument[0]->join.right->type != ATTRIB)
continue;
i=strlen(op_argument[0]->join.right->data.attr);
if( strcmp(&(op_argument[0]->join.right->data.attr[i-4]),"self") != 0)
continue;
}
{
aa_param->ptr_hh_join.input = op_argument[2]->get_set.input;
strcpy(aa_param->ptr_hh_join.attr,op_argument[2]->get_set.attr);
}
*algorithm_or_enforcer = PTR_HH_JOIN ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
found_rule = TRUE ;
*ret_count = 3 ;
}
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (4):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != MAT)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

*algorithm_or_enforcer = TRAVERSE ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
found_rule = TRUE ;
*ret_count = 4 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (5):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

*algorithm_or_enforcer = FILTER ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
found_rule = TRUE ;
*ret_count = 5 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (6):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != GET_SET)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
*algorithm_or_enforcer = FILE_SCAN ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
found_rule = TRUE ;
*ret_count = 6 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (7):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != UNION)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
if (lele[0]->expr.input[1] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

lele[2] = lele[0] -> expr.input[1];
get_eq_class_addr
(ssa,lele[2] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[2] = lele[0] -> expr.input[1];
#if SAFETY>=1
get_eq_class_addr(ssa,input[2]->eq_class_index,
&temp_eq_class) ;
if (input[2] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

*algorithm_or_enforcer = UNION_ALG ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
inputs_to_search[1] = input[2] ;
found_rule = TRUE ;
*ret_count = 7 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (8):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != FIX)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

*algorithm_or_enforcer = FIX_ALG ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
found_rule = TRUE ;
*ret_count = 8 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (9):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != UNNEST)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
lele[1] = lele[0] -> expr.input[0];
get_eq_class_addr
(ssa,lele[1] ->eq_class_index, &temp_eq_class) ;
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
input[1] = lele[0] -> expr.input[0];
#if SAFETY>=1
get_eq_class_addr(ssa,input[1]->eq_class_index,
&temp_eq_class) ;
if (input[1] != temp_eq_class->log_expr_list.first)
FAIL (ERR_OPTIMIZER_INTERNAL_ERROR) ;
#endif

*algorithm_or_enforcer = UNNEST_ALG ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
inputs_to_search[0] = input[1] ;
found_rule = TRUE ;
*ret_count = 9 ;
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
case (10):
found_rule = FALSE ;
lele[0] = lele_in;
if (rule_group != DEFAULT)
 goto try_rule;
operator_array[0] = lele[0] -> expr.my_operator;
if (operator_array[0] != SELECT)
goto try_rule; 
op_argument[0] = &(lele[0] -> expr.argument);
if (lele[0]->expr.input[0] == NULL)
goto try_rule; 
get_eq_class_addr
(ssa,lele[0] -> expr.input[0]->eq_class_index,
 &temp_eq_class) ;
if (lele[0] -> expr.input[0] !=
 temp_eq_class->log_expr_list.first)
FAIL(ERR_OPTIMIZER_INTERNAL_ERROR);
if (temp_eq_class -> trans_flag == TRANSFORMATIONS_IN_PROGRESS)
goto try_rule; 
/* FAIL(ERR_OPTIMIZER_INTERNAL_ERROR); */ 
if (temp_eq_class -> trans_flag == NO_TRANSFORMATIONS) 
{
CALL (generate_all_transformations (temp_eq_class -> log_expr_list.first,
rule_group, ssa)) ;}
for (lele[1]=temp_eq_class->log_expr_list.first;
lele[1] != NULL;
lele[1] = lele[1] -> next)
{operator_array[1] = lele[1] -> expr.my_operator;
if (operator_array[1] != GET_SET)
continue;
op_argument[1] = &(lele[1] -> expr.argument);
{
int i;
char attr[50];
JOIN_ARG *ja;
if (op_argument[0]->select.terms != 1)
continue;
if ( ((op_argument[0]->select.cond[0]->left) && 
(op_argument[0]->select.cond[0]->left->type != ATTRIB)) || 
((op_argument[0]->select.cond[0]->right) && 
(op_argument[0]->select.cond[0]->right->type != CONST)) )
continue;
ja = Find_Join_Arg((JOIN_ARG*)op_argument[0]->select.cond[0]);
strcpy(attr,(char*)(ja->data.attr+strlen(op_argument[1]->get_set.attr)+1));
for (i=0;i<op_argument[1]->get_set.input.arity;i++)
if( strcmp(op_argument[1]->get_set.input.attr[i]->name,attr) == 0)
break;
if ( !(op_argument[1]->get_set.input.attr[i]->btree_avail))
continue;
}
{
int i;
char attr[50];
JOIN_ARG *ja;
ja = Find_Join_Arg((JOIN_ARG*)op_argument[0]->select.cond[0]);
if ( ja ==NULL) exit (10);
strcpy(attr,(char*)(ja->data.attr+strlen(op_argument[1]->get_set.attr)+1));
for (i=0;i<op_argument[1]->get_set.input.arity;i++)
if( strcmp(op_argument[1]->get_set.input.attr[i]->name,attr) == 0)
break;
aa_param->btree_select.index_id = op_argument[1]->get_set.input.attr[i]->index_id;
aa_param->btree_select.input = op_argument[1]->get_set.input;
aa_param->btree_select.cond = op_argument[0]->select.cond[0];
strcpy(aa_param->btree_select.attr,op_argument[1]->get_set.attr);
}
*algorithm_or_enforcer = BTREE_SELECT ;
for (i = MAX_ALGORITHM_ARITY; --i >= 0;)
inputs_to_search[i] = NULL ;
found_rule = TRUE ;
*ret_count = 10 ;
}
if (found_rule == TRUE)
return (OKAY) ;
else goto try_rule ;
default:*algorithm_or_enforcer = (ALGORITHM) NO_MORE; return (OKAY);
}
}
}
