#include "mood_catdef.h"
#include "mood_catalog.h"
#include "userreq.h"

int 		Debug = 0;
 
UserRequest::initESM( char *arg)
{ 
        int             errno;
        char            *errormsg;      
        CatBOOLEAN      status;
        FID             myfid; 
	char		configFileName[2*MAXSTRLEN];
	char		*binName;

	MoodHome = getenv( "MOOD_HOME" );

	if( !MoodHome ) {
		setError(INITIALIZATION_ERROR, 0, 
		"MOOD_HOME environment variable not set" );
		return FALSE;
	}

	noDBInUse = 1;

	MoodBin = getenv( "MOOD_BIN" );

	sprintf( configFileName, "%s/config/.sm_config", MoodHome );

	binName = strrchr( arg, '/' );

	if( binName ) binName++;
	else binName = arg;

	if( !strcmp( binName, "moodsql" ) ) interfaceMode = TEXTUAL_MODE;
	else interfaceMode = GUI_MODE;
 
        errno=sm_ReadConfigFile(configFileName,arg,&errormsg); 

	if( errno != esmNOERROR ) {
		setError( EXODUS_ERROR, errno, "Read Config File\n");  
		return FALSE;
	}
  
        if( !ESM_Startup() ) {
		userError = catalogError;
		return FALSE;  
	}
	return TRUE;
} 
 
UserRequest::closeESM()
{ 
        if( !ESM_ShutDown()) {
		userError = catalogError;
		return FALSE; 
	}
	return TRUE;
} 

UserRequest::startXAct()
{
	int err;

        mscat_OpenBufferGroup("can not open buffer group for cat group");
        //printf("buffer group is opened \n");

        mscat_BeginTransaction(" can not start transaction ");
        //printf("transaction is started \n");

	return TRUE;
}

UserRequest::commitXAct()
{
	int err ;

        mscat_CommitTransaction(" can not commit transaction ");
        //printf("transaction committed ......\n");
         
        mscat_CloseBufferGroup(" can not close catalog buffer ");
        //printf("buffer group closed ........\n");

	return TRUE;
}

UserRequest::abortXAct()
{
	int err;

        //mscat_AbortTransaction(" can not commit transaction ");
        mscat_CommitTransaction(" can not commit transaction ");
        //printf("transaction committed ......\n");
         
        mscat_CloseBufferGroup(" can not close catalog buffer ");
        //printf("buffer group closed ........\n");

	return TRUE;
}
