#include <linklist.h>
#include <keywords.h>
#include <stdio.h>
#include "mood_parser.h"


/**************************************************************************

                        ListItem Methods

**************************************************************************/


// print out a list item
void ListItem::printOn()
{
        if(!this) return;
	switch( itemType )
	{

		/* Logical Operators */
		case EQ : printf(" = "); break;
		case GT : printf(" > "); break;
		case GE : printf(" >= "); break;
		case LT : printf(" < "); break;
		case LE : printf(" <= "); break;
		case NE : printf(" != "); break;

		/* Boolean Operators */
		case NOT : printf(" NOT "); break;
		case OR  : printf(" OR ");  break;
		case AND : printf(" AND "); break;

		/* arithmetic operators */
		case ADD : printf(" + "); break;
		case SUB : printf(" - "); break;
		case MUL : printf(" * "); break;
		case DIV : printf(" / "); break;
		case MOD : printf(" % "); break;

		/* unary operators */
		case UNARYPLUS  : printf(" U+ "); break;
		case UNARYMINUS : printf(" U- "); break;
		case EVERY      : printf(" EVERY "); break;
		
		/* special constant */
		case NULLVALUE : printf(" NULL "); break;
		case MS_TRUE   : printf(" TRUE "); break;
		case MS_FALSE  : printf(" FALSE "); break;

		/* constants */
		case CHRCONS :
		case STRCONS : printf(" CONS(%s) ", (char *)item ); break;
		case UNSIGNEDREAL: printf(" CONS(%f) ", *(float *)item ); break;
		case UNSIGNEDINT : printf(" CONS(%d) ", * (int *)item ); break;
	
		/* Bind Item */
		case BIND_ITEM : ((BindListItem *)item)->printOn(); break;
		
		case PROJ_ITEM : ((ProjectionListItem *)item)->printOn(); break;

		case PATH_ITEM : (( PathItem *) item)->printOn(); break;

		case PATH_EXP  : (( PathExpression *) item)->printOn(); break;

		case UPDATE_EXP: (( Expression *) item )->printOn(); break;

		case EXP_PTR   : (( Expression *) item )->printOn(); break;

		case FUNCTION_PARAM : (( Expression *) item )->printOn(); break;

		case QRY_PTR   : (( Query *) item )->printOn(); break;

		case PNW_PTR   :
		case NEW_PTR   : (( NewClause *) item)->printOn(); break;

		case LST_PTR   :
		case SET_PTR   : (( LinkedList *) item)->printOn(); break;

		case OR_TERM   : (( AndTerm * ) item)->printOn(); break;

		case BIND_AND_TERM : ((DictItem *) item)->printOn(); break;

		case AND_TERM  : ((LinkedList *) item)->printOn(); break;

		default : 
			 printf(" Undefined Item Type : %d", itemType );
	}
}

void LinkedList::printOn()
{
	ListItem *p;
	p = firstItem;
	while( p )
	{
		p->printOn();
		p = p->next;
	}
}



void LinkedList::bprintOn()
{
	ListItem *p;
	p = lastItem;
	while( p )
	{
		p->printOn();
		p = p->prev;
	}
}

void LinkedList::traverseAsTree(ListItem *item)
{
/*	if(item) 
	{
		traverseAsTree(item->left);
		item->printOn();
		traverseAsTree(item->right);
	} */
}
