/* include files */
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <Xm/Xm.h>

#define MAX_ARGS     100

#define CENTERX(f,x,str) ((x)-XTextWidth(f,str,strlen(str))/2)
#define CENTERY(f,y) ((y)-((f->ascent+f->descent)/2)+f->ascent)

#define NEXTBYTE (*ptr++)
#define IMAGESEP 0x2c
#define INTERLACEMASK 0x40
#define COLORMAPMASK 0x80

/* X stuff */
Display	      *theDisp;
int           theScreen, dispcells;
Colormap      theCmap;
Window        rootW, mainW;
GC            theGC;
unsigned long fcol,bcol;
Font          mfont;
XFontStruct   *mfinfo;
Visual        *theVisual;
XImage        *theImage, *expImage;

/* global vars */
int            iWIDE,iHIGH,eWIDE,eHIGH,numcols,strip,nostrip;
unsigned long  cols[256];
XColor         defs[256];

extern Widget fn_toplevel;

Widget Shell;
Widget MainWindow;
Widget WorkRegion;
Widget MenuBar;
Widget PullDown1;
Widget MenuBtn1;
Widget Label1;
Widget DrawingArea;
Widget MainBoard;
Widget Label;

int BitOffset = 0,		/* Bit Offset of next code */
    XC = 0, YC = 0,		/* Output X and Y coords of current pixel */
    Pass = 0,			/* Used by output routine if interlaced pic */
    OutCount = 0,		/* Decompressor output 'stack count' */
    RWidth, RHeight,		/* screen dimensions */
    Width, Height,		/* image dimensions */
    LeftOfs, TopOfs,		/* image offset */
    BitsPerPixel,		/* Bits per pixel, read from GIF header */
    BytesPerScanline,		/* bytes per scanline in output raster */
    ColorMapSize,		/* number of colors */
    Background,			/* background color */
    CodeSize,			/* Code size, read from GIF header */
    InitCodeSize,		/* Starting code size, used during Clear */
    Code,			/* Value returned by ReadCode */
    MaxCode,			/* limiting value for current code size */
    ClearCode,			/* GIF clear code */
    EOFCode,			/* GIF end-of-information code */
    CurCode, OldCode, InCode,	/* Decompressor variables */
    FirstFree,			/* First free code, generated per GIF spec */
    FreeCode,			/* Decompressor, next free slot in hash table */
    FinChar,			/* Decompressor variable */
    BitMask,			/* AND mask for data size */
    ReadMask;			/* Code AND mask for current code size */

int Interlace, HasColormap;

unsigned char *Image;		/* The result array */
unsigned char *RawGIF;		/* The heap array to hold it, raw */
unsigned char *Raster;		/* The raster data stream, unblocked */

/* The hash table used by the decompressor */
int Prefix[4096];
int Suffix[4096];

/* An output array used by the decompressor */
int OutCode[1025];

/* The color map, read from the GIF header */
unsigned char Red[256], Green[256], Blue[256], used[256];
int  numused;

char *id = "GIF87a";

/* Prototypes */
Widget CreateCascade(char *label, char mnemonic, Widget submenu, Widget parent);
Widget CreatePushButton(char *label, char mnemonic, Widget parent);
void CreateMenuBar();
XtCallbackProc MenuQuit(Widget w, caddr_t  client_data, caddr_t call_data);
Resize(int w, int h);
LoadGIF(unsigned char *ptr, int PicSize);
ReadCode();
AddToPixel(unsigned char Index);
ColorDicking();

int ShowGIF(unsigned char *buf, int Size)
{
	int		i=0;
	char		*display;
	register int	n;
	Arg		args[MAX_ARGS];
	Pixmap		pixmap;
	XtAppContext	app;
        Widget		ParentW;

    ParentW = fn_toplevel;

    if( buf == NULL ) return TRUE;

    display = NULL;
    expImage = NULL;

    strip = 0;  nostrip = 1;
    BitOffset = XC = YC = Pass = OutCount = 0;

    theDisp = XtDisplay(ParentW);

    theScreen = DefaultScreen(theDisp);
    theCmap   = DefaultColormap(theDisp, theScreen);
    rootW     = RootWindow(theDisp,theScreen);
    theGC     = DefaultGC(theDisp,theScreen);
    fcol      = WhitePixel(theDisp,theScreen);
    bcol      = BlackPixel(theDisp,theScreen);
    theVisual = DefaultVisual(theDisp,theScreen);

    dispcells = DisplayCells(theDisp, theScreen);
    if (dispcells<=2) {
	printf("ERROR: This program requires a color display, pref. 8 bits. (ShowGIF)\n");
	return FALSE;
    }


    /****************** Open/Read the File  *****************/
    LoadGIF(buf,Size);

    eWIDE = iWIDE = theImage->width;  
    eHIGH = iHIGH = theImage->height;

    if (eWIDE > DisplayWidth(theDisp,theScreen)) 
        eWIDE = DisplayWidth(theDisp,theScreen);
    if (eHIGH > DisplayHeight(theDisp,theScreen)) 
        eHIGH = DisplayHeight(theDisp,theScreen);

    /**************** Create/Open X Resources ***************/
    if ((mfinfo = XLoadQueryFont(theDisp,"variable"))==NULL) {
	printf("ERROR: couldn't open 'variable' font (ShowGIF)\n");
	return FALSE;
    }

    mfont=mfinfo->fid;
    XSetFont(theDisp,theGC,mfont);
    XSetForeground(theDisp,theGC,fcol);
    XSetBackground(theDisp,theGC,bcol);


    n = 0;
    XtSetArg(args[n], XmNwidth,  eWIDE+50); n++;
    XtSetArg(args[n], XmNheight, eHIGH+84); n++;
    XtSetArg(args[n], XmNallowShellResize, True); n++;

    Shell = XtVaCreatePopupShell(NULL, topLevelShellWidgetClass, ParentW, XmNallowShellResize, 
				True,XmNdeleteResponse, XmUNMAP, NULL);

    n = 0;
    MainWindow = XmCreateMainWindow(Shell, "MainWindow", args, n);
    XtManageChild(MainWindow);

    WorkRegion = XmCreateBulletinBoard (MainWindow, "s_text", args, n);
    XtManageChild (WorkRegion);
    
    CreateMenuBar ();

    n = 0;
    XtSetArg(args[n],  XmNx,  10); n++;
    XtSetArg(args[n], XmNy,  10); n++;
    XtSetArg(args[n], XmNheight,  eHIGH + 50); n++;
    XtSetArg(args[n], XmNwidth,  eWIDE + 50); n++;
    XtSetArg(args[n], XmNshadowThickness,  2); n++;
    MainBoard = XmCreateBulletinBoard (WorkRegion, "s_text", args, n);
    XtManageChild (MainBoard);

    n = 0;
    XtSetArg(args[n], XmNheight,  eHIGH + 50); n++;
    XtSetArg(args[n], XmNwidth,  eWIDE + 50); n++;

    XtRealizeWidget(Shell);

    DrawingArea = XmCreateDrawingArea (MainBoard, "d_area", args, n);
    XtCreateWindow (DrawingArea, InputOutput, CopyFromParent, 0L, 0);
    pixmap = XCreatePixmap (theDisp, XtWindow (DrawingArea), eWIDE, 
			    eHIGH, 
			    (unsigned int)DefaultDepth(theDisp, theScreen));
    Resize(eWIDE,eHIGH);

    XPutImage(theDisp, pixmap, theGC, expImage, 0, 0, 0, 0, eWIDE, eHIGH);

    n = 0;
    XtSetArg(args[n], XmNx,  20); n++;
    XtSetArg(args[n], XmNy,  20); n++;
    XtSetArg(args[n], XmNheight,  eHIGH); n++;
    XtSetArg(args[n], XmNwidth,  eWIDE); n++;
    XtSetArg(args[n], XmNlabelType,  XmPIXMAP); n++;
    XtSetArg(args[n], XmNlabelPixmap,  pixmap); n++;
    XtSetArg(args[n], XmNlabelInsensitivePixmap,  pixmap); n++;

    Label = XmCreateLabel (MainBoard, "label", args, n);

    XtManageChild (Label);

    XtPopup(Shell, XtGrabNone);

}

Widget CreateCascade(char *label, char mnemonic, Widget submenu, Widget parent)
{

  Widget   widget;
  int      n;
  Arg      args[MAX_ARGS];
  XmString tcs;

  n = 0;
  tcs = XmStringLtoRCreate (label, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[n], XmNlabelString, tcs); n++;
  XtSetArg(args[n], XmNmnemonic, mnemonic); n++;
  XtSetArg(args[n], XmNsubMenuId, submenu); n++;
  widget = XmCreateCascadeButton (parent, "cascade", args, n);
  XtManageChild(widget);
  XmStringFree(tcs);

  return (widget);
}

Widget CreatePushButton(char *label, char mnemonic, Widget parent)
{

  static Widget       widget;
  int          n;
  Arg          args[MAX_ARGS];
  XmString     tcs, acc_text;

  n = 0;
  tcs = XmStringLtoRCreate(label, XmSTRING_DEFAULT_CHARSET);
  XtSetArg(args[n], XmNlabelString, tcs); n++;
  XtSetArg(args[n], XmNmnemonic, mnemonic); n++;
  widget = XmCreatePushButton(parent, label, args, n);
  XtManageChild(widget);
  XmStringFree(tcs);

  return(widget);
}


void CreateMenuBar()
{
    int n;
    Arg args[MAX_ARGS];

    n = 0;
    MenuBar = (Widget)XmCreateMenuBar((Widget)MainWindow, "MenuBar", args, n); 
    if (MenuBar == NULL) {
      printf("ERROR: null menu bar (ShowGIF)\n");
      return FALSE;
    }

    XtManageChild(MenuBar);

    /*  create the first level pulldowns */
    n = 0;
    PullDown1 = XmCreatePulldownMenu (MenuBar, "File", args, n);

    /*  create cascade buttons for menubar  */
    MenuBtn1 = CreateCascade ("File", 'F', PullDown1, MenuBar);

    Label1 = CreatePushButton ("Quit",'1',PullDown1);
    XtAddCallback (Label1, XmNactivateCallback, MenuQuit, NULL);
}

XtCallbackProc MenuQuit(Widget w, caddr_t  client_data, caddr_t call_data)
{
 Widget Pwidget;

    Pwidget = XtParent(w);
    Pwidget = XtParent(Pwidget);
    Pwidget = XtParent(Pwidget);
    Pwidget = XtParent(Pwidget);
    Pwidget = XtParent(Pwidget);
    XtDestroyWidget(Pwidget);
}


Resize( int w,int h)
{
    int  ix,iy,ex,ey;
    unsigned char *ximag,*ilptr,*ipptr,*elptr,*epptr;
    static char *rstr = "Resizing Image.  Please wait...";

    /* warning:  this code'll only run machines where int=32-bits */

    if (w==iWIDE && h==iHIGH) {		/* very special case */
        if (expImage != theImage) {
            if (expImage) XDestroyImage(expImage);
            expImage = theImage;
            eWIDE = iWIDE;  eHIGH = iHIGH;
            }
        }

    else {				/* have to do some work */
        /* if it's a big image, this'll take a while.  mention it */
        if (w*h>(500*500)) {
            XDrawImageString(theDisp,mainW,theGC,CENTERX(mfinfo,w/2,rstr),
                  CENTERY(mfinfo,h/2),rstr, strlen(rstr));
            XFlush(theDisp);
            }

	/* first, kill the old expImage, if one exists */
	if (expImage && expImage != theImage) {
            free(expImage->data);  expImage->data = NULL;
            XDestroyImage(expImage);
            }

        /* create expImage of the appropriate size */
        
        eWIDE = w;  eHIGH = h;
        ximag = (unsigned char *) malloc(w*h);
        expImage = XCreateImage(theDisp,theVisual,8,ZPixmap,0,ximag,
                        eWIDE,eHIGH,8,eWIDE);

        if (!ximag || !expImage) {
            printf("ERROR: unable to create a %dx%d image (ShowGIF)\n",w,h);
            return FALSE;
            }

        elptr = epptr = (unsigned char *) expImage->data;

        for (ey=0;  ey<eHIGH;  ey++, elptr+=eWIDE) {
            iy = (iHIGH * ey) / eHIGH;
            epptr = elptr;
            ilptr = (unsigned char *) theImage->data + (iy * iWIDE);
            for (ex=0;  ex<eWIDE;  ex++,epptr++) {
                ix = (iWIDE * ex) / eWIDE;
                ipptr = ilptr + ix;
                *epptr = *ipptr;
                }
            }
        }
}


LoadGIF(unsigned char *ptr, int PicSize)
{
    register unsigned char ch, ch1;
    register unsigned char *ptr1;
    register int   i;

    RawGIF = ptr;

    if (!(Raster = (unsigned char *) malloc(PicSize))) {
	printf("ERROR: not enough memory to read gif file (ShowGIF)\n");
	return FALSE;
    }

    if (strncmp(ptr, id, 6)) {
	printf("ERROR: not a GIF file (ShowGIF)\n");
	return FALSE;
    }

    ptr += 6;

    /* Get variables from the GIF screen descriptor */
    ch = NEXTBYTE;
    RWidth = ch + 0x100 * NEXTBYTE;	/* screen dimensions... not used. */
    ch = NEXTBYTE;
    RHeight = ch + 0x100 * NEXTBYTE;

    ch = NEXTBYTE;
    HasColormap = ((ch & COLORMAPMASK) ? True : False);

    BitsPerPixel = (ch & 7) + 1;
    numcols = ColorMapSize = 1 << BitsPerPixel;
    BitMask = ColorMapSize - 1;

    Background = NEXTBYTE;		/* background color... not used. */

    if (NEXTBYTE) {		/* supposed to be NULL */
	printf("ERROR: corrupt GIF file (bad screen descriptor) (ShowGIF)\n");
	return FALSE;
    }

    /* Read in global colormap. */

    if (HasColormap) {
	for (i = 0; i < ColorMapSize; i++) {
	    Red[i] = NEXTBYTE;
	    Green[i] = NEXTBYTE;
	    Blue[i] = NEXTBYTE;
            used[i] = 0;
	    }
        numused = 0;

        }

    else {  /* no colormap in GIF file */
        printf("warning!  no colortable in this file.  Winging it.\n");
        if (!numcols) numcols=256;
        for (i=0; i<numcols; i++) cols[i] = (unsigned long) i;
        }

    /* Check for image seperator */

    if (NEXTBYTE != IMAGESEP) {
	printf("ERROR: corrupt GIF file (no image separator) (ShowGIF)\n");
	return FALSE;
    }

    /* Now read in values from the image descriptor */

    ch = NEXTBYTE;
    LeftOfs = ch + 0x100 * NEXTBYTE;
    ch = NEXTBYTE;
    TopOfs = ch + 0x100 * NEXTBYTE;
    ch = NEXTBYTE;
    Width = ch + 0x100 * NEXTBYTE;
    ch = NEXTBYTE;
    Height = ch + 0x100 * NEXTBYTE;
    Interlace = ((NEXTBYTE & INTERLACEMASK) ? True : False);

    printf("Picture is %dx%d, %d colors  ", Width,Height,ColorMapSize);
    

    /* Note that I ignore the possible existence of a local color map.
     * I'm told there aren't many files around that use them, and the spec
     * says it's defined for future use.  This could lead to an error
     * reading some files. 
     */

    /* Start reading the raster data. First we get the intial code size
     * and compute decompressor constant values, based on this code size.
     */

    CodeSize = NEXTBYTE;
    ClearCode = (1 << CodeSize);
    EOFCode = ClearCode + 1;
    FreeCode = FirstFree = ClearCode + 2;

    /* The GIF spec has it that the code size is the code size used to
     * compute the above values is the code size given in the file, but the
     * code size used in compression/decompression is the code size given in
     * the file plus one. (thus the ++).
     */

    CodeSize++;
    InitCodeSize = CodeSize;
    MaxCode = (1 << CodeSize);
    ReadMask = MaxCode - 1;

    /* Read the raster data.  Here we just transpose it from the GIF array
     * to the Raster array, turning it from a series of blocks into one long
     * data stream, which makes life much easier for ReadCode().
     */

    ptr1 = Raster;
    do {
	ch = ch1 = NEXTBYTE;
	while (ch--) *ptr1++ = NEXTBYTE;
	if ((ptr1 - Raster)  > PicSize) {
	    printf("ERROR: corrupt GIF file (unblock) (ShowGIF)\n");
	    return FALSE;
	}
    } while(ch1);

    free(RawGIF);		/* We're done with the raw data now... */

    /* Allocate the X Image */
    Image = (unsigned char *) malloc(Width*Height);
    if (!Image) {
	printf("ERROR: not enough memory for XImage (ShowGIF)\n");
	return FALSE;
    }

    theImage = XCreateImage(theDisp,theVisual,8,ZPixmap,0,Image,
                         Width,Height,8,Width);
    if (!theImage) {
	printf("ERROR: unable to create XImage (ShowGIF)\n");
	return FALSE;
    }

    BytesPerScanline = Width;


    /* Decompress the file, continuing until you see the GIF EOF code.
     * One obvious enhancement is to add checking for corrupt files here.
     */

    Code = ReadCode();
    while (Code != EOFCode) {

    /* Clear code sets everything back to its initial value, then reads the
     * immediately subsequent code as uncompressed data.
     */

	if (Code == ClearCode) {
	    CodeSize = InitCodeSize;
	    MaxCode = (1 << CodeSize);
	    ReadMask = MaxCode - 1;
	    FreeCode = FirstFree;
	    CurCode = OldCode = Code = ReadCode();
	    FinChar = CurCode & BitMask;
	    AddToPixel(FinChar);
	}
	else {

    /* If not a clear code, then must be data:save same as CurCode and InCode */

	    CurCode = InCode = Code;

    /* If greater or equal to FreeCode, not in the hash table yet;
     * repeat the last character decoded
     */

	    if (CurCode >= FreeCode) {
		CurCode = OldCode;
		OutCode[OutCount++] = FinChar;
	    }

    /* Unless this code is raw data, pursue the chain pointed to by CurCode
     * through the hash table to its end; each code in the chain puts its
     * associated output code on the output queue.
     */

	    while (CurCode > BitMask) {
		if (OutCount > 1024) {
		    printf("ERROR: Corrupt GIF file (OutCount) (ShowGIF)\n");
                    return FALSE;
                    }
		OutCode[OutCount++] = Suffix[CurCode];
		CurCode = Prefix[CurCode];
	    }

    /* The last code in the chain is treated as raw data. */

	    FinChar = CurCode & BitMask;
	    OutCode[OutCount++] = FinChar;

    /* Now we put the data out to the Output routine.
     * It's been stacked LIFO, so deal with it that way...
     */

	    for (i = OutCount - 1; i >= 0; i--)
		AddToPixel(OutCode[i]);
	    OutCount = 0;

    /* Build the hash table on-the-fly. No table is stored in the file. */

	    Prefix[FreeCode] = OldCode;
	    Suffix[FreeCode] = FinChar;
	    OldCode = InCode;

    /* Point to the next slot in the table.  If we exceed the current
     * MaxCode value, increment the code size unless it's already 12.  If it
     * is, do nothing: the next code decompressed better be CLEAR
     */

	    FreeCode++;
	    if (FreeCode >= MaxCode) {
		if (CodeSize < 12) {
		    CodeSize++;
		    MaxCode *= 2;
		    ReadMask = (1 << CodeSize) - 1;
		}
	    }
	}
	Code = ReadCode();
    }

    free(Raster);

    printf("(of which %d are used)\n",numused);

    ColorDicking();
}


/* Fetch the next code from the raster data stream.  The codes can be
 * any length from 3 to 12 bits, packed into 8-bit bytes, so we have to
 * maintain our location in the Raster array as a BIT Offset.  We compute
 * the byte Offset into the raster array by dividing this by 8, pick up
 * three bytes, compute the bit Offset into our 24-bit chunk, shift to
 * bring the desired code to the bottom, then mask it off and return it. 
 */
ReadCode()
{
int RawCode, ByteOffset;

    ByteOffset = BitOffset / 8;
    RawCode = Raster[ByteOffset] + (0x100 * Raster[ByteOffset + 1]);
    if (CodeSize >= 8)
	RawCode += (0x10000 * Raster[ByteOffset + 2]);
    RawCode >>= (BitOffset % 8);
    BitOffset += CodeSize;
    return(RawCode & ReadMask);
}


AddToPixel(unsigned char Index)
{
    if (YC<Height)
        *(Image + YC * BytesPerScanline + XC) = Index;

    if (!used[Index]) { used[Index]=1;  numused++; }

    /* Update the X-coordinate, and if it overflows, update the Y-coordinate */

    if (++XC == Width) {

    /* If a non-interlaced picture, just increment YC to the next scan line. 
     * If it's interlaced, deal with the interlace as described in the GIF
     * spec.  Put the decoded scan line out to the screen if we haven't gone
     * past the bottom of it
     */

	XC = 0;
	if (!Interlace) YC++;
	else {
	    switch (Pass) {
		case 0:
		    YC += 8;
		    if (YC >= Height) {
			Pass++;
			YC = 4;
		    }
		break;
		case 1:
		    YC += 8;
		    if (YC >= Height) {
			Pass++;
			YC = 2;
		    }
		break;
		case 2:
		    YC += 4;
		    if (YC >= Height) {
			Pass++;
			YC = 1;
		    }
		break;
		case 3:
		    YC += 2;
		break;
		default:
		break;
	    }
	}
    }
}

ColorDicking()
{
    /* we've got the picture loaded, we know what colors are needed. get 'em */

    register int   i,j;
    static unsigned char    lmasks[8] = {0xff, 0xfe, 0xfc, 0xf8, 0xf0, 0xe0, 0xc0, 0x80};
    unsigned char           lmask, *ptr;


    if (!HasColormap) return;
    /* no need to allocate any colors if no colormap in GIF file */

    /* Allocate the X colors for this picture */

    if (nostrip)  {   /* nostrip was set.  try REAL hard to do it */
        for (i=j=0; i<numcols; i++) {
            if (used[i]) {
                defs[i].red   = Red[i]<<8;
                defs[i].green = Green[i]<<8;
                defs[i].blue  = Blue[i]<<8;
                defs[i].flags = DoRed | DoGreen | DoBlue;
                if (!XAllocColor(theDisp,theCmap,&defs[i])) { 
                    j++;  defs[i].pixel = 0xffff;
                    }
                cols[i] = defs[i].pixel;
                }
            }

        if (j) {		/* failed to pull it off */
            XColor ctab[256];
            int    dc;

            dc = (dispcells<256) ? dispcells : 256;

            printf("failed to allocate %d out of %d colors.  Trying extra hard.\n",j,numused);

            /* read in the color table */
            for (i=0; i<dc; i++) ctab[i].pixel = i;
            XQueryColors(theDisp,theCmap,ctab,dc);
                
            /* run through the used colors.  any used color that has a pixel
               value of 0xffff wasn't allocated.  for such colors, run through
               the entire X colormap and pick the closest color */

            for (i=0; i<numcols; i++)
                if (used[i] && cols[i]==0xffff) {  /* an unallocated pixel */
                    int d, mdist, close;
                    unsigned long r,g,b;

                    mdist = 100000;   close = -1;
                    r =  Red[i];
                    g =  Green[i];
                    b =  Blue[i];
                    for (j=0; j<dc; j++) {
                        d = abs(r - (ctab[j].red>>8)) +
                            abs(g - (ctab[j].green>>8)) +
                            abs(b - (ctab[j].blue>>8));
                        if (d<mdist) { mdist=d; close=j; }
                        }

                    if (close<0) {
			printf("ERROR: simply can't do it. Sorry. (ShowGIF)\n");
			return FALSE;
		    }

                    bcopy(&defs[close],&defs[i],sizeof(XColor));
                    cols[i] = ctab[close].pixel;
                    }
            }	/* end 'failed to pull it off' */
        }

    else {          /* strip wasn't set, do the best auto-strip */
        j = 0;
        while (strip<8) {
            lmask = lmasks[strip];
            for (i=0; i<numcols; i++)
                if (used[i]) {
                    defs[i].red   = (Red[i]  &lmask)<<8;
                    defs[i].green = (Green[i]&lmask)<<8;
                    defs[i].blue  = (Blue[i] &lmask)<<8;
                    defs[i].flags = DoRed | DoGreen | DoBlue;
                    if (!XAllocColor(theDisp,theCmap,&defs[i])) break;
                    cols[i] = defs[i].pixel;
                    }

            if (i<numcols) {		/* failed */
                strip++;  j++;
                for (i--; i>=0; i--)
                    if (used[i]) XFreeColors(theDisp,theCmap,cols+i,1,0L);
                }
            else break;
            }

        if (j && strip<8)
            printf("Picture stripped %d bits\n",strip);

        if (strip==8) {
            printf("UTTERLY failed to allocate the desired colors.\n");
            for (i=0; i<numcols; i++) cols[i]=i;
            }
        }

    ptr = Image;
    for (i=0; i<Height; i++)
        for (j=0; j<Width; j++,ptr++) 
            *ptr = (unsigned char) cols[*ptr];
}
