#include "linklist.h"
#include "string.h"

ListItem        undefinedItem;

extern myFree( char * );
extern char * myAlloc( int );

SortedStringList * SortedStringList::merge( SortedStringList *mergeList )
{
	ListItem	*p = firstItem;
	ListItem	*q = mergeList->firstItem;
	int		result;
	SortedStringList *outList;
	char		*inKey;

	outList = new SortedStringList();

	while( p && q )
	{
		result = strcmp( (char *) p->item, (char *) q->item );
		if( result == 0 ){
			inKey = myAlloc( MAXSTRLEN );
			strcpy( inKey, (char *) p->item );
			outList->insertSorted( STRCONS, inKey );
			q = q->next;
			p = p->next;
		}
		else if( result < 0 )
		{
			inKey = myAlloc( MAXSTRLEN );
			strcpy( inKey, (char *) p->item );
			outList->insertSorted( STRCONS, inKey );
			p = p->next;
		}
		else if( result > 0 )
		{
			inKey = myAlloc( MAXSTRLEN );
			strcpy( inKey, (char *) q->item );
			outList->insertSorted( STRCONS, inKey );
			q = q->next;
		}
	}

	while( p ) {
		inKey = myAlloc( MAXSTRLEN );
		strcpy( inKey, (char *) p->item );
		outList->insertSorted( STRCONS, inKey );
	}

	while( q ) {
		inKey = myAlloc( MAXSTRLEN );
		strcpy( inKey, (char *) q->item );
		outList->insertSorted( STRCONS, inKey );
	}

	return outList;
}

SortedStringList::contains( SortedStringList *checkList )
{
	ListItem *p;
	for( p = checkList->firstItem; p; p=p->next )
		if( !hasMember( (char *) p->item )) return FALSE;
	return TRUE;
}

SortedStringList::hasMember( char *keyStr )
{
	ListItem	*p;
	for( p = firstItem; p; p=p->next )
		if( !strcmp( (char *) p->item, keyStr ))
			return TRUE;

	return FALSE; 
}

ListItem* SortedStringList::findPlace( char *i )
{
	ListItem	*p;
	int		 anInt;
	//this->printOn();
	p = firstItem;
	while(p)
	{
		anInt = strcmp((char *) p->item, i );

		if( anInt == 0 ) return &undefinedItem;
		else if( anInt >= 1 ) return p;

		p = p->next;
	}
	return NULL;
}

void SortedStringList::insertSorted(unsigned itype, void *i)
{

	ListItem	*nextItem, *inItem;

	nextItem = findPlace( (char * ) i );

	if( nextItem == &undefinedItem ) {
#ifdef DEBUG
		printf("UNDEFINED ITEM\n");
#endif
		myFree( (char *) i );
		return;
	}

	inItem = new ListItem( itype, i );	

	if( size == 0 )
	{
		firstItem = inItem;
		lastItem  = inItem;
		size++;
	}
	else    if( nextItem == NULL ) LinkedList::insert( itype, i );
		else {
			inItem->prev = nextItem->prev;
			nextItem->prev = inItem;
			inItem->next = nextItem; 
			if( firstItem == nextItem ) firstItem = inItem;
			size++;
		} 
}
