#include "opt_defs.h"
#include "dbi_gen.h"
#include "dbi.h"
#include "opt.h"
#include "global.h"
#include <math.h>
#include <string.h>
#include "vol_util.h"

extern  char *myAlloc( int );
extern  myFree( char *);
 

QUERY     *get_qry( FILE   *fp );
void       prnt_qry( QUERY * node, FILE   *fp );
void       AddUse(SEARCH *s, char *name);
void       DelUse(SEARCH *s, int i);
void       PutUse(QUERY *q, SEARCH *s);
void       PutAttribute(ATTRIBUTE* attr, FILE *fp);
ATTRIBUTE *GetAttribute(FILE *fp);
void       PutJoinArg(JOIN_ARG *ja, FILE *fp);
JOIN_ARG  *GetJoinArg(FILE *fp);
QUERY     *node_alloc ();
PLAN      *plan_alloc ();
void       prnt_op_arg(OPERATOR_ARGUMENT *oa, OPERATOR op, FILE *fp);
void       prnt_qry ( QUERY * node, FILE   *fp );
void       PutRS( RELATION_SCHEMA *rs, FILE   *fp );
RELATION_SCHEMA *GetRS(FILE   *fp );
void       get_op_arg(OPERATOR_ARGUMENT *oa,OPERATOR op, FILE *fp);
QUERY     *get_qry (FILE   *fp );
void       prnt_al_arg(ALGORITHM_ARGUMENT *aa, ALGORITHM al, FILE *fp);
void       prnt_pln ( PLAN *node, FILE   *fp );
void       get_al_arg(ALGORITHM_ARGUMENT *aa, ALGORITHM al, FILE *fp);
PLAN      *get_pln ( FILE   *fp );


SEARCH *s;
SEARCH s1;
QUERY  *q;
JOIN_ARG  dummy_ja; 
FCN_INPUT dummy_fun;

/******** FUNCTION AddUse ****************/

void AddUse(SEARCH *s, char *name)
{
    char *ptr, temp[150], nm[20];
    int   i;

    strcpy(temp,name);
    ptr = strrchr(temp,'.');
    strcpy(nm,&(ptr[1]));
    *ptr = (char)0;
    for ( i=0;i<s->num;i++) 
       if((!strcmp(s->d[i]->pre,temp))&&(!strcmp(s->d[i]->name,nm))){
          s->d[i]->use ++;
          return;
       }
    i= s->num;
    s->d[i]=(S_S*)myAlloc(sizeof(S_S));
    s->num++;
    s->d[i]->pre = (char*) myAlloc(strlen(temp)+2);
    s->d[i]->name =(char*) myAlloc(strlen(nm)+2);
    strcpy(s->d[i]->pre,temp);
    strcpy(s->d[i]->name,nm);
    s->d[i]->use = 1;
}

/******** FUNCTION DelUse ****************/
void DelUse(SEARCH *s, int i)
{
    myFree((char *)s->d[i]->name);
    myFree((char *)s->d[i]->pre);
    myFree((char *)s->d[i]);
    for(;i<s->num;i++)
       s->d[i] = s->d[i+1];
    s->num--;
}


/******** FUNCTION PutUse ****************/
/*
void PutUse(QUERY *q, SEARCH *s)
{
  int       i,j,t;
  JOIN_ARG *ja,*current;

   switch(q->my_operator) {
      case (GET_SET) :
        i=0;
        while ( i<s->num){
          if (!strcmp(q->argument.get_set.attr,s->d[i]->pre)) {
            j = 0;
            while (j<q->argument.get_set.input.arity) {
              if (!strcmp(q->argument.get_set.input.attr[j]->name,s->d[i]->name)){ 
                 if ( q->argument.get_set.input.attr[j]->attr_type == METHOD) {
                   for (t=0;t<q->argument.get_set.input.arity;t++)
                      q->argument.get_set.input.attr[t]->use++;
                 }
                 else
                   q->argument.get_set.input.attr[j]->use=s->d[i]->use; 
                 DelUse(s,i);
                 i--;
                 break;
              }
              j++;
            }
          }
          i++;
        }
        break;
      case (MAT) :
        i=0;
        while (i<s->num) {
          if (!strcmp(q->argument.mat.attr[0],s->d[i]->pre)) {
            j=0;
            while (j<q->argument.mat.input[0].arity) {
              if (!strcmp(q->argument.mat.input[0].attr[j]->name,s->d[i]->name)){
                 if ( q->argument.mat.input[0].attr[j]->attr_type == METHOD) {
                   for (t=0;t<q->argument.mat.input[0].arity;t++)
                      q->argument.mat.input[0].attr[t]->use++;
                 }
                 else
                   q->argument.mat.input[0].attr[j]->use=s->d[i]->use;
                 DelUse(s,i);
                 i--;
                 break;
              }
              j++;
            }
          }
          i++;
        }
        AddUse(s,q->argument.mat.attr[0]);
        PutUse(q->input[0],s);
        break;
      case (JOIN) :
        current = &(q->argument.join);
        while (1) {
           if (current->data.op ==AND_OP) {
              ja = Find_Join_Arg(current->left->left);
              AddUse(s,ja->data.attr);
              ja = Find_Join_Arg(current->left->right);
              AddUse(s,ja->data.attr);
              current = current->right;
           }
           else {
              ja = Find_Join_Arg(current->left);
              AddUse(s,ja->data.attr);
              ja = Find_Join_Arg(current->right);
              AddUse(s,ja->data.attr);
              break;
           }
        }
        PutUse(q->input[0],s);
        PutUse(q->input[1],s);
        break;
      case (SELECT) :
        for ( i=0; i<q->argument.select.terms;i++) {
            ja = Find_Join_Arg(q->argument.select.cond[i]);
            AddUse(s,ja->data.attr);
            ja = Find_Join_Arg(q->argument.select.cond[i]->right);
            if ( ja!= NULL)
              AddUse(s,ja->data.attr);
        }
        PutUse(q->input[0],s);
        break;
      case (UNNEST) :
        for (i=0;i<s->num;i++) {
          if (!strcmp(q->argument.unnest.attr,s->d[i]->pre)) {
            for (j=0;j<q->argument.unnest.input.arity;j++) {
              if (!strcmp(q->argument.unnest.input.attr[j]->name,s->d[i]->name)){
                if ( q->argument.unnest.input.attr[j]->attr_type == METHOD) {
                  for (t=0;t<q->argument.unnest.input.arity;t++)
                     q->argument.unnest.input.attr[t]->use++;
                }
                else
                  q->argument.unnest.input.attr[j]->use=s->d[i]->use;
                DelUse(s,i);
              }
            }
          }
        }
        AddUse(s,q->argument.unnest.attr);
        PutUse(q->input[0],s);
        break;
      default:
        break;
   }
} */


/******** FUNCTION PutAttribute ****************/
void PutAttribute(ATTRIBUTE* attr, FILE *fp)
{
    fwrite(attr,sizeof(ATTRIBUTE),1,fp);
}

/******** FUNCTION GetAttribute ****************/
ATTRIBUTE *GetAttribute(FILE *fp)
{
    ATTRIBUTE *attr;
    attr = (ATTRIBUTE*) myAlloc(sizeof(ATTRIBUTE));
    fread(attr,sizeof(ATTRIBUTE),1,fp);
    return attr;
}

/******* FUNCTION PutFcn   ******************/
void PutFcn( FCN_INPUT *fun, FILE *fp)
{
    int i;

    if (fun == NULL) {
       fwrite(&dummy_fun,sizeof(FCN_INPUT),1,fp);
       return;
    }
    fwrite(fun,sizeof(FCN_INPUT),1,fp);
    for (i=0;i<fun->argnum;i++) {
       PutJoinArg(fun->ParExpr[0],fp);
       fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
    } 
}

/******* FUNCTION GetFcn   ******************/
FCN_INPUT *GetFcn(FILE* fp)
{
    FCN_INPUT *fn;
    int i;

    fn = (FCN_INPUT*) myAlloc(sizeof(FCN_INPUT));
    fread(fn,sizeof(FCN_INPUT),1,fp);
    if ( memcmp(fn,&dummy_fun,sizeof(FCN_INPUT)) == 0 )
       return (NULL);
    for ( i=0;i<fn->argnum;i++ )
        fn->ParExpr[i] = GetJoinArg(fp);
    return(fn);
}

/******** FUNCTION PutJoinArg ****************/
void PutJoinArg(JOIN_ARG *ja, FILE *fp)
{
    if (ja->left  != NULL) PutJoinArg(ja->left,fp);
    if (ja->right != NULL) PutJoinArg(ja->right,fp);
    fwrite(ja,sizeof(JOIN_ARG),1,fp);
    PutFcn(ja->fcn,fp);
}

/******** FUNCTION GetJoinArg ****************/
JOIN_ARG *GetJoinArg(FILE *fp)
{
    JOIN_ARG *join_stack[5];
    int       join_top;
    JOIN_ARG *ja;

    join_top = -1;
    ja= (JOIN_ARG*) myAlloc(sizeof(JOIN_ARG));
    fread(ja,sizeof(JOIN_ARG),1,fp);
 //   ja->fcn=GetFcn(fp);
    ja->left =NULL;
    ja->right=NULL;
    while ( memcmp(&dummy_ja,ja,sizeof(JOIN_ARG)) != 0) {
      ja->fcn=GetFcn(fp);
      if ( ja->type == ATTRIB || ja->type == CONST ){
         join_top++;
         join_stack[join_top] = ja; 
      } 
      else {
         ja->left = join_stack[join_top-1];
         ja->right= join_stack[join_top];
         join_top --;
         join_stack[join_top] = ja;
      }
      ja= (JOIN_ARG*) myAlloc(sizeof(JOIN_ARG));
      fread(ja,sizeof(JOIN_ARG),1,fp);
  //    ja->fcn=GetFcn(fp);
    }
    return(join_stack[join_top]);
}

/******** FUNCTION node_alloc ****************/
QUERY * node_alloc ()
{
    QUERY * temp ;
    temp = (QUERY *) myAlloc ((unsigned) sizeof (QUERY)) ;
    temp -> input [0] = NULL ;
    temp -> input [1] = NULL ;
    return (temp) ;
}

/******** FUNCTION plan_alloc ****************/
PLAN * plan_alloc ()
{
    PLAN *temp ;
    temp = (PLAN *) myAlloc ((unsigned) sizeof (PLAN)) ;
    temp -> input [0] = NULL ;
    temp -> input [1] = NULL ;
    return (temp) ;
}

/******** FUNCTION prnt_op_arg ****************/
void prnt_op_arg(OPERATOR_ARGUMENT *oa, OPERATOR op, FILE *fp)
{
    int m;

    if ( op == GET_SET ) {
       fwrite(&(oa->get_set),sizeof(GET_SET_ARG),1,fp);
       for (m = 0; m != oa->get_set.input.arity; m++)
          PutAttribute( oa->get_set.input.attr[m], fp);
    }
    else if  ( op == SELECT ) {
       fwrite(&(oa->select),sizeof(SELECT_ARG),1,fp);
       for (m=0;m<oa->select.terms;m++) {
          PutJoinArg(oa->select.cond[m],fp);
          fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
       }
    }
    else if ( op == JOIN )  {
       PutJoinArg(&(oa->join),fp);
       fwrite(&(dummy_ja),sizeof(JOIN_ARG),1,fp);
    }
    else if ( op  == MAT )  {
       fwrite(&(oa->mat),sizeof(MAT_ARG),1,fp);
       for( m = 0; m < oa->mat.num; m++ )
          PutFcn(oa->mat.fcn[m],fp);
       for (m = 0; m != oa->mat.input[0].arity; m++) 
          PutAttribute(oa->mat.input[0].attr[m],fp);
    }
    else if ( op == UNNEST )  {
       fwrite(&(oa->unnest),sizeof(UNNEST_ARG),1,fp);
       for (m = 0; m != oa->unnest.input.arity; m++)
          PutAttribute(oa->unnest.input.attr[m],fp);
    }
    else if ( op  == FIX )  {
       fwrite(&(oa->fix),sizeof(FIX),1,fp);
       for (m = 0; m != oa->fix.input.arity; m++)
          PutAttribute(oa->fix.input.attr[m],fp);
    }
    else if  ( op  == UNION ) {
    }
    return ;
}

/******** FUNCTION prnt_qry ****************/
void prnt_qry ( QUERY * node, FILE   *fp )
{
    if (node->input[0]!=NULL) prnt_qry(node->input[0],fp);
    if (node->input[1]!=NULL) prnt_qry(node->input[1],fp);
    fwrite(&(node->my_operator),sizeof(OPERATOR),1,fp);
    prnt_op_arg(&(node->argument),node->my_operator,fp);
}

/******** FUNCTION PutRS ****************/
void PutRS( RELATION_SCHEMA *rs, FILE   *fp )
{
           int m;

           fwrite(rs,sizeof(RELATION_SCHEMA),1,fp);
           for (m = 0; m != rs->arity; m++) 
              PutAttribute( rs->attr[m],fp);
}

/******** FUNCTION GetRS ****************/
RELATION_SCHEMA *GetRS(FILE   *fp )
{
           RELATION_SCHEMA *rs;
           int m;

           rs = ( RELATION_SCHEMA *)myAlloc(sizeof(RELATION_SCHEMA));
           fread(rs,sizeof(RELATION_SCHEMA),1,fp);
           for (m = 0; m != rs->arity; m++) 
              rs->attr[m] = GetAttribute(fp);
           return (rs);
}

/******** FUNCTION get_op_arg ****************/
void get_op_arg(OPERATOR_ARGUMENT *oa,OPERATOR op, FILE *fp)
{
    int m;
    JOIN_ARG *tempJA=NULL;

    if ( op == GET_SET ) {
       fread(&(oa->get_set),sizeof(GET_SET_ARG),1,fp);
       for (m = 0; m != oa->get_set.input.arity; m++)
         oa->get_set.input.attr[m]= GetAttribute( fp);
    }
    else if  ( op == SELECT ) {
       fread(&(oa->select),sizeof(SELECT_ARG),1,fp);
       for (m=0;m<oa->select.terms;m++) {
          oa->select.cond[m]=GetJoinArg(fp);
       }
    }
    else if ( op == JOIN )  {
       //oa->join=*(GetJoinArg(fp));
       tempJA = GetJoinArg(fp);
       oa->join=*tempJA;
       myFree((char *)tempJA );
    }
    else if ( op  == MAT )  {
       fread(&(oa->mat),sizeof(MAT_ARG),1,fp);
       for( m = 0; m < oa->mat.num; m++ )
          oa->mat.fcn[m] = GetFcn(fp);
       for (m = 0; m != oa->mat.input[0].arity; m++)
         oa->mat.input[0].attr[m]= GetAttribute(fp);
    }
    else if ( op  == UNNEST )  {
       fread(&(oa->unnest),sizeof(UNNEST_ARG),1,fp);
       for (m = 0; m != oa->unnest.input.arity; m++)
          oa->unnest.input.attr[m]=GetAttribute(fp);
    }
    else if ( op  == FIX )  {
       fread(&(oa->fix),sizeof(FIX),1,fp);
       for (m = 0; m != oa->fix.input.arity; m++)
          oa->fix.input.attr[m]=GetAttribute(fp);
    }
    else if  (  op == UNION ) {
    }
    return ;
}

/******** FUNCTION get_qry  ****************/
QUERY *get_qry (FILE   *fp )
{
    QUERY    *stack[20];
    int       top = -1;
    QUERY    *node;
    int m;

    top = -1;
    while (!feof(fp)) {
       node = node_alloc();
       m=fread(&(node->my_operator),sizeof(OPERATOR),1,fp);
       if (m==0)
          return( stack[top] );
       get_op_arg(&(node->argument),node->my_operator,fp);
       if ( node->my_operator == GET_SET ){
           top++;
           stack[top] = node;
       }
       else if (node->my_operator == SELECT ||
                node->my_operator == MAT ||
                node->my_operator == UNNEST ||
                node->my_operator == FIX )  {
          node->input[0] = stack[top];
          stack[top] = node;
       }
       else if (node->my_operator == JOIN || 
                node->my_operator == UNION)  {

          node->input[1] = stack[top];
          top--;
          node->input[0] = stack[top];
          stack[top]=node;
       }
       else {
          printf("error\n");
          exit(3);
       }
    }
    return(node) ;
}

/******** FUNCTION prnt_al_arg ****************/
void prnt_al_arg(ALGORITHM_ARGUMENT *aa, ALGORITHM al, FILE *fp)
{
    int m;

    if ( al == FILE_SCAN ) {
       fwrite(&(aa->file_scan),sizeof(FILE_SCAN_ARG),1,fp);
       for (m = 0; m != aa->file_scan.input.arity; m++)
          PutAttribute( aa->file_scan.input.attr[m],fp);
    }
    else if ( al  == FILTER ) {
       fwrite(&(aa->filter),sizeof(FILTER_ARG),1,fp);
       for (m=0;m<aa->filter.terms;m++) {
          PutJoinArg(aa->filter.cond[m],fp);
          fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
       }
    }
    else if ( al == HASH_JOIN)  {
       PutJoinArg(&(aa->hash_join),fp);
       fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
    }
    else if ( al == NESTED_LOOP_JOIN)  {
       PutJoinArg(&(aa->nested_loop_join),fp);
       fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
    }
    else if ( al == MERGE_JOIN)  {
       PutJoinArg(&(aa->merge_join),fp);
       fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
    }
    else if ( al == TRAVERSE )  {
       fwrite(&(aa->traverse),sizeof(MAT_ARG),1,fp);
       for( m =0; m<aa->traverse.num; m++ )
          PutFcn(aa->traverse.fcn[m],fp);
       for (m = 0; m != aa->traverse.input[0].arity; m++) 
          PutAttribute(aa->traverse.input[0].attr[m],fp);
    }
    else if ( al == PTR_HH_JOIN )  {
       fwrite(&(aa->ptr_hh_join),sizeof(PTR_HH_JOIN_ARG),1,fp);
       PutFcn(aa->ptr_hh_join.fcn,fp);
       for (m = 0; m != aa->ptr_hh_join.input.arity; m++) 
          PutAttribute(aa->ptr_hh_join.input.attr[m],fp);
    }
    else if ( al == PTR_SM_JOIN )  {
       fwrite(&(aa->ptr_sm_join),sizeof(PTR_SM_JOIN_ARG),1,fp);
       PutFcn(aa->ptr_sm_join.fcn,fp);
       for (m = 0; m != aa->ptr_sm_join.input.arity; m++) 
          PutAttribute(aa->ptr_sm_join.input.attr[m],fp);
    }
    else if ( al == UNNEST_ALG )  {
       fwrite(&(aa->unnest_alg),sizeof(UNNEST_ALG_ARG),1,fp);
       for (m = 0; m != aa->unnest_alg.input.arity; m++)
          PutAttribute(aa->unnest_alg.input.attr[m],fp);
    }
    else if ( al == FIX_ALG )  {
       fwrite(&(aa->fix_alg),sizeof(FIX_ALG),1,fp);
       for (m = 0; m != aa->fix_alg.input.arity; m++)
          PutAttribute(aa->fix_alg.input.attr[m],fp);
    }
    else if ( al == BTREE_SELECT ) {
       fwrite(&(aa->btree_select),sizeof(BTREE_SELECT_ARG),1,fp);
       for (m = 0; m != aa->btree_select.input.arity; m++)
          PutAttribute( aa->btree_select.input.attr[m],fp);
       PutJoinArg(aa->btree_select.cond,fp);
       fwrite(&dummy_ja,sizeof(JOIN_ARG),1,fp);
    }
    else if ( al == SORT ) {
       fwrite(&(aa->sort),sizeof(SORT_ARG),1,fp);
    }
    else if  ( al == UNION_ALG ) {
    }
    return ;
}

/******** FUNCTION prnt_pln ****************/
void prnt_pln ( PLAN *node, FILE   *fp )
{
    if (node->input[0]!=NULL) prnt_pln(node->input[0],fp);
    if (node->input[1]!=NULL) prnt_pln(node->input[1],fp);
    fwrite(&(node->algorithm),sizeof(ALGORITHM),1,fp);
    prnt_al_arg(&(node->algorithm_argument),node->algorithm,fp);
    fwrite(&(node->my_operator),sizeof(OPERATOR),1,fp);
    prnt_op_arg(&(node->operator_argument),node->my_operator,fp);
    fwrite(&(node->cost),sizeof(COST),1,fp);
    PutRS(&(node->logical_property),fp);
    fwrite(&(node->property_vector),sizeof(PROPERTY_VECTOR),1,fp);
    fwrite(&(node->excl_property_vector),sizeof(PROPERTY_VECTOR),1,fp);
}


/******** FUNCTION get_al_arg ****************/
void get_al_arg(ALGORITHM_ARGUMENT *aa, ALGORITHM al, FILE *fp)
{
    int m;
    JOIN_ARG *tempJA=NULL;

    if ( al == FILE_SCAN ) {
       fread(&(aa->file_scan),sizeof(FILE_SCAN_ARG),1,fp);
       for (m = 0; m != aa->file_scan.input.arity; m++)
          aa->file_scan.input.attr[m]=GetAttribute(fp);
    }
    else if ( al  == FILTER ) {
       fread(&(aa->filter),sizeof(FILTER_ARG),1,fp);
       for (m=0;m<aa->filter.terms;m++) {
          aa->filter.cond[m]=GetJoinArg(fp);
       }
    }
    else if ( al == HASH_JOIN)  {
       //aa->hash_join = (*GetJoinArg(fp));
       tempJA = GetJoinArg(fp);
       aa->hash_join = *tempJA;
       myFree( (char *) tempJA );
    }
    else if ( al == NESTED_LOOP_JOIN)  {
       //aa->nested_loop_join= (*GetJoinArg(fp));
       tempJA = GetJoinArg(fp);
       aa->nested_loop_join= *tempJA;
       myFree( (char *) tempJA );
    }
    else if ( al == MERGE_JOIN)  {
       //aa->merge_join= (*GetJoinArg(fp));
       tempJA = GetJoinArg(fp);
       aa->merge_join= *tempJA;
       myFree( (char *) tempJA );
    }
    else if ( al == TRAVERSE )  {
       fread(&(aa->traverse),sizeof(MAT_ARG),1,fp);
       for( m = 0; m < aa->traverse.num; m++ )
         aa->traverse.fcn[m]=GetFcn(fp);
       for (m = 0; m != aa->traverse.input[0].arity; m++)
          aa->traverse.input[0].attr[m]=GetAttribute(fp);
    }
    else if ( al == PTR_HH_JOIN )  {
       fread(&(aa->ptr_hh_join),sizeof(PTR_HH_JOIN_ARG),1,fp);
       aa->ptr_hh_join.fcn=GetFcn(fp);
       for (m = 0; m != aa->ptr_hh_join.input.arity; m++)
          aa->ptr_hh_join.input.attr[m]=GetAttribute(fp);
    }
    else if ( al == PTR_SM_JOIN )  {
       fread(&(aa->ptr_sm_join),sizeof(PTR_SM_JOIN_ARG),1,fp);
       aa->ptr_sm_join.fcn=GetFcn(fp);
       for (m = 0; m != aa->ptr_sm_join.input.arity; m++)
          aa->ptr_sm_join.input.attr[m]=GetAttribute(fp);
    }
    else if ( al == UNNEST_ALG )  {
       fread(&(aa->unnest_alg),sizeof(UNNEST_ALG_ARG),1,fp);
       for (m = 0; m != aa->unnest_alg.input.arity; m++)
          aa->unnest_alg.input.attr[m]=GetAttribute(fp);
    }
    else if ( al == FIX_ALG )  {
       fread(&(aa->fix_alg),sizeof(FIX_ALG),1,fp);
       for (m = 0; m != aa->fix_alg.input.arity; m++)
          aa->fix_alg.input.attr[m]=GetAttribute(fp);
    }
    else if ( al == BTREE_SELECT ) {
       fread(&(aa->btree_select),sizeof(BTREE_SELECT_ARG),1,fp);
       for (m = 0; m != aa->btree_select.input.arity; m++)
          aa->btree_select.input.attr[m]=GetAttribute(fp);
       aa->btree_select.cond=GetJoinArg(fp);
    }
    else if ( al == SORT ) {
       fread(&(aa->sort),sizeof(SORT_ARG),1,fp);
    }
    else if  ( al == UNION_ALG ) {
    }
    return ;
}


/******** FUNCTION get_pln ****************/
PLAN * get_pln ( FILE   *fp )
{
    PLAN    *node;
    PLAN    *stack[20];
    int      top = -1;
    int m;
    RELATION_SCHEMA	*tempSchema = NULL;

    while (!feof(fp)) {
       node = plan_alloc();

       m=fread(&(node->algorithm),sizeof(ALGORITHM),1,fp);
       if ( m== 0)
          return(stack[top]);
       get_al_arg(&(node->algorithm_argument),node->algorithm,fp);
       fread(&(node->my_operator),sizeof(OPERATOR),1,fp);
       get_op_arg(&(node->operator_argument),node->my_operator,fp);
       fread(&(node->cost),sizeof(COST),1,fp);

       //node->logical_property =*(GetRS(fp));
       tempSchema = GetRS( fp );
       node->logical_property =*tempSchema;
       myFree( (char *) tempSchema );

       fread(&(node->property_vector),sizeof(PROPERTY_VECTOR),1,fp);
       fread(&(node->excl_property_vector),sizeof(PROPERTY_VECTOR),1,fp);
       if ( node->algorithm == FILE_SCAN ||
            node->algorithm == BTREE_SELECT ) {
           top++;
           stack[top] = node;
       }
       else if ( node->algorithm == FILTER ||
                 node->algorithm == TRAVERSE ||
                 node->algorithm == UNNEST_ALG ||
                 node->algorithm == FIX_ALG ||
                 node->algorithm == PTR_HH_JOIN ||
                 node->algorithm == PTR_SM_JOIN) {
          node->input[0] = stack[top];
          stack[top] = node;
       }
       else if ( node->algorithm == HASH_JOIN ||
                 node->algorithm == MERGE_JOIN ||
                 node->algorithm == UNION_ALG ||
                 node->algorithm == NESTED_LOOP_JOIN) {
          node->input[1] = stack[top];
          top--;
          node->input[0] = stack[top];
          stack[top]=node;
       }
       else {
         printf("error\n");
         exit(3);
       }
    }
    return(node) ;
}
